(***************************************************************************
*                                                                          *
* Automatically generated file, do not modify                              *
*                                                                          *
* Emmanuel Polonowski, March 2012, Coq v8.3                                *
*                                                                          *
***************************************************************************)

Require Import Arith Omega.


(* ********************************************************************** *)
(** * Syntax definition                                                   *)

Module SYS_F_terms.

  Create HintDb SYS_F_terms_database.


  (** ** General Tactics *)

  Hint Rewrite Plus.plus_0_r Minus.minus_diag : SYS_F_terms_database.

  Ltac omega_tac :=
    omega || (absurd False; auto; omega).

  Ltac fomega_tac :=
    f_equal; auto with SYS_F_terms_database; try omega_tac.

  Ltac efomega_tac :=
    f_equal; eauto with SYS_F_terms_database; try omega_tac.

  Ltac crush_tac :=
    autorewrite with SYS_F_terms_database in *; auto with SYS_F_terms_database; try omega_tac;
      try match goal with
            | [ H : False |- _ ] => inversion H
          end;
      try (repeat fomega_tac; fail).

  Ltac ecrush_tac :=
    autorewrite with SYS_F_terms_database in *; eauto with SYS_F_terms_database; try omega_tac;
      try match goal with
            | [ H : False |- _ ] => inversion H
          end;
      try (repeat efomega_tac; fail).

  Ltac cfail :=
    simpl; crush_tac; fail.




  (** * Inductive syntax and function definitions *)


  (** *** De Bruijn primitive syntax *)

  Inductive type : Type :=
  | tvar (i : nat)
  | tconst (n : nat)
  | tarrow (A : type) (B : type)
  | tall (A : type)
  .

  Hint Constructors type : SYS_F_terms_database.

  Inductive term : Type :=
  | var (x : nat)
  | app (t1 : term) (t2 : term)
  | lam (A : type) (t : term)
  | tapp (t : term) (A : type)
  | gen (t : term)
  .

  Hint Constructors term : SYS_F_terms_database.


  (** *** De Bruijn lifting function *)

  Fixpoint type_lift_in_type (_n : nat) (_m : nat) (_arg : type) { struct _arg } : type :=
    match _arg with
      | tvar i =>
        if le_lt_dec _m i then tvar (i + _n) else tvar i
      | tconst n =>
        tconst n
      | tarrow A B =>
        tarrow (type_lift_in_type _n _m A) (type_lift_in_type _n _m B)
      | tall A =>
        tall (type_lift_in_type _n (_m + 1) A)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma type_lift_in_type_tvar :
    forall (_n : nat) (_m : nat) (i : nat),
      type_lift_in_type _n _m (tvar i) =
        if le_lt_dec _m i then tvar (i + _n) else tvar i
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_type_tvar : SYS_F_terms_database.

  Lemma type_lift_in_type_tconst :
    forall (_n : nat) (_m : nat) (n : nat),
      type_lift_in_type _n _m (tconst n) =
        tconst n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_type_tconst : SYS_F_terms_database.

  Lemma type_lift_in_type_tarrow :
    forall (_n : nat) (_m : nat) (A : type) (B : type),
      type_lift_in_type _n _m (tarrow A B) =
        tarrow (type_lift_in_type _n _m A) (type_lift_in_type _n _m B)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_type_tarrow : SYS_F_terms_database.

  Lemma type_lift_in_type_tall :
    forall (_n : nat) (_m : nat) (A : type),
      type_lift_in_type _n _m (tall A) =
        tall (type_lift_in_type _n (_m + 1) A)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_type_tall : SYS_F_terms_database.

  Fixpoint type_lift_in_term (_n : nat) (_m : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        var x
      | app t1 t2 =>
        app (type_lift_in_term _n _m t1) (type_lift_in_term _n _m t2)
      | lam A t =>
        lam (type_lift_in_type _n _m A) (type_lift_in_term _n _m t)
      | tapp t A =>
        tapp (type_lift_in_term _n _m t) (type_lift_in_type _n _m A)
      | gen t =>
        gen (type_lift_in_term _n (_m + 1) t)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma type_lift_in_term_var :
    forall (_n : nat) (_m : nat) (x : nat),
      type_lift_in_term _n _m (var x) =
        var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_term_var : SYS_F_terms_database.

  Lemma type_lift_in_term_app :
    forall (_n : nat) (_m : nat) (t1 : term) (t2 : term),
      type_lift_in_term _n _m (app t1 t2) =
        app (type_lift_in_term _n _m t1) (type_lift_in_term _n _m t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_term_app : SYS_F_terms_database.

  Lemma type_lift_in_term_lam :
    forall (_n : nat) (_m : nat) (A : type) (t : term),
      type_lift_in_term _n _m (lam A t) =
        lam (type_lift_in_type _n _m A) (type_lift_in_term _n _m t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_term_lam : SYS_F_terms_database.

  Lemma type_lift_in_term_tapp :
    forall (_n : nat) (_m : nat) (t : term) (A : type),
      type_lift_in_term _n _m (tapp t A) =
        tapp (type_lift_in_term _n _m t) (type_lift_in_type _n _m A)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_term_tapp : SYS_F_terms_database.

  Lemma type_lift_in_term_gen :
    forall (_n : nat) (_m : nat) (t : term),
      type_lift_in_term _n _m (gen t) =
        gen (type_lift_in_term _n (_m + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_lift_in_term_gen : SYS_F_terms_database.

  (** *** De Bruijn lifting function *)

  Fixpoint term_lift_in_term (_n : nat) (_m : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        if le_lt_dec _m x then var (x + _n) else var x
      | app t1 t2 =>
        app (term_lift_in_term _n _m t1) (term_lift_in_term _n _m t2)
      | lam A t =>
        lam A (term_lift_in_term _n (_m + 1) t)
      | tapp t A =>
        tapp (term_lift_in_term _n _m t) A
      | gen t =>
        gen (term_lift_in_term _n _m t)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma term_lift_in_term_var :
    forall (_n : nat) (_m : nat) (x : nat),
      term_lift_in_term _n _m (var x) =
        if le_lt_dec _m x then var (x + _n) else var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_var : SYS_F_terms_database.

  Lemma term_lift_in_term_app :
    forall (_n : nat) (_m : nat) (t1 : term) (t2 : term),
      term_lift_in_term _n _m (app t1 t2) =
        app (term_lift_in_term _n _m t1) (term_lift_in_term _n _m t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_app : SYS_F_terms_database.

  Lemma term_lift_in_term_lam :
    forall (_n : nat) (_m : nat) (A : type) (t : term),
      term_lift_in_term _n _m (lam A t) =
        lam A (term_lift_in_term _n (_m + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_lam : SYS_F_terms_database.

  Lemma term_lift_in_term_tapp :
    forall (_n : nat) (_m : nat) (t : term) (A : type),
      term_lift_in_term _n _m (tapp t A) =
        tapp (term_lift_in_term _n _m t) A
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_tapp : SYS_F_terms_database.

  Lemma term_lift_in_term_gen :
    forall (_n : nat) (_m : nat) (t : term),
      term_lift_in_term _n _m (gen t) =
        gen (term_lift_in_term _n _m t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_lift_in_term_gen : SYS_F_terms_database.


  (** *** De Bruijn substitution function *)

  Fixpoint type_subst_in_type (_a : type) (_n : nat) (_arg : type) { struct _arg } : type :=
    match _arg with
      | tvar i =>
        match lt_eq_lt_dec _n i with
            (* case _n < i *)
          | inleft (left _) => tvar (i - 1)
            (* case _n = i *)
          | inleft (right _) => _a
            (* case i < _n *)
          | inright _ => tvar i
        end
      | tconst n =>
        tconst n
      | tarrow A B =>
        tarrow (type_subst_in_type _a _n A) (type_subst_in_type _a _n B)
      | tall A =>
        tall (type_subst_in_type (type_lift_in_type 1 0 _a) (_n + 1) A)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma type_subst_in_type_tvar :
    forall (_a : type) (_n : nat) (i : nat),
      type_subst_in_type _a _n (tvar i) =
        match lt_eq_lt_dec _n i with
            (* case _n < i *)
          | inleft (left _) => tvar (i - 1)
            (* case _n = i *)
          | inleft (right _) => _a
            (* case i < _n *)
          | inright _ => tvar i
        end
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_type_tvar : SYS_F_terms_database.

  Lemma type_subst_in_type_tconst :
    forall (_a : type) (_n : nat) (n : nat),
      type_subst_in_type _a _n (tconst n) =
        tconst n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_type_tconst : SYS_F_terms_database.

  Lemma type_subst_in_type_tarrow :
    forall (_a : type) (_n : nat) (A : type) (B : type),
      type_subst_in_type _a _n (tarrow A B) =
        tarrow (type_subst_in_type _a _n A) (type_subst_in_type _a _n B)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_type_tarrow : SYS_F_terms_database.

  Lemma type_subst_in_type_tall :
    forall (_a : type) (_n : nat) (A : type),
      type_subst_in_type _a _n (tall A) =
        tall (type_subst_in_type (type_lift_in_type 1 0 _a) (_n + 1) A)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_type_tall : SYS_F_terms_database.

  Fixpoint type_subst_in_term (_a : type) (_n : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        var x
      | app t1 t2 =>
        app (type_subst_in_term _a _n t1) (type_subst_in_term _a _n t2)
      | lam A t =>
        lam (type_subst_in_type _a _n A) (type_subst_in_term _a _n t)
      | tapp t A =>
        tapp (type_subst_in_term _a _n t) (type_subst_in_type _a _n A)
      | gen t =>
        gen (type_subst_in_term (type_lift_in_type 1 0 _a) (_n + 1) t)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma type_subst_in_term_var :
    forall (_a : type) (_n : nat) (x : nat),
      type_subst_in_term _a _n (var x) =
        var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_term_var : SYS_F_terms_database.

  Lemma type_subst_in_term_app :
    forall (_a : type) (_n : nat) (t1 : term) (t2 : term),
      type_subst_in_term _a _n (app t1 t2) =
        app (type_subst_in_term _a _n t1) (type_subst_in_term _a _n t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_term_app : SYS_F_terms_database.

  Lemma type_subst_in_term_lam :
    forall (_a : type) (_n : nat) (A : type) (t : term),
      type_subst_in_term _a _n (lam A t) =
        lam (type_subst_in_type _a _n A) (type_subst_in_term _a _n t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_term_lam : SYS_F_terms_database.

  Lemma type_subst_in_term_tapp :
    forall (_a : type) (_n : nat) (t : term) (A : type),
      type_subst_in_term _a _n (tapp t A) =
        tapp (type_subst_in_term _a _n t) (type_subst_in_type _a _n A)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_term_tapp : SYS_F_terms_database.

  Lemma type_subst_in_term_gen :
    forall (_a : type) (_n : nat) (t : term),
      type_subst_in_term _a _n (gen t) =
        gen (type_subst_in_term (type_lift_in_type 1 0 _a) (_n + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_subst_in_term_gen : SYS_F_terms_database.

  (** *** De Bruijn substitution function *)

  Fixpoint term_subst_in_term (_a : term) (_n : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => var (x - 1)
            (* case _n = x *)
          | inleft (right _) => _a
            (* case x < _n *)
          | inright _ => var x
        end
      | app t1 t2 =>
        app (term_subst_in_term _a _n t1) (term_subst_in_term _a _n t2)
      | lam A t =>
        lam A (term_subst_in_term (term_lift_in_term 1 0 _a) (_n + 1) t)
      | tapp t A =>
        tapp (term_subst_in_term _a _n t) A
      | gen t =>
        gen (term_subst_in_term (type_lift_in_term 1 0 _a) _n t)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma term_subst_in_term_var :
    forall (_a : term) (_n : nat) (x : nat),
      term_subst_in_term _a _n (var x) =
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => var (x - 1)
            (* case _n = x *)
          | inleft (right _) => _a
            (* case x < _n *)
          | inright _ => var x
        end
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_var : SYS_F_terms_database.

  Lemma term_subst_in_term_app :
    forall (_a : term) (_n : nat) (t1 : term) (t2 : term),
      term_subst_in_term _a _n (app t1 t2) =
        app (term_subst_in_term _a _n t1) (term_subst_in_term _a _n t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_app : SYS_F_terms_database.

  Lemma term_subst_in_term_lam :
    forall (_a : term) (_n : nat) (A : type) (t : term),
      term_subst_in_term _a _n (lam A t) =
        lam A (term_subst_in_term (term_lift_in_term 1 0 _a) (_n + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_lam : SYS_F_terms_database.

  Lemma term_subst_in_term_tapp :
    forall (_a : term) (_n : nat) (t : term) (A : type),
      term_subst_in_term _a _n (tapp t A) =
        tapp (term_subst_in_term _a _n t) A
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_tapp : SYS_F_terms_database.

  Lemma term_subst_in_term_gen :
    forall (_a : term) (_n : nat) (t : term),
      term_subst_in_term _a _n (gen t) =
        gen (term_subst_in_term (type_lift_in_term 1 0 _a) _n t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_subst_in_term_gen : SYS_F_terms_database.

  Module SizedList.
    Set Implicit Arguments.

    Section Definitions.
      Variable A : Type.

      Inductive sized_list : nat -> Type :=
      | snil : sized_list 0
      | scons : A -> forall n : nat, sized_list n -> sized_list (S n).
      
      Implicit Arguments scons [n].
    
      Fixpoint app (n1 : nat) (l1 : sized_list n1) (n2 : nat) (l2 : sized_list n2) : sized_list (n1 + n2) :=
        match l1 in sized_list n1 return sized_list (n1 + n2) with
          | snil => l2
          | scons x _ l1' => scons x (app l1' l2)
        end.
      
      Variable eq : forall x y : A, { x = y } + { x <> y }.
      
      Fixpoint index_of (x : A) (n : nat) (l : sized_list n) : nat :=
        match l with
          | snil => 0
          | scons y _ l' => if eq x y then 0 else S (index_of x l')
        end.
      
      Fixpoint build_permut (n : nat) (l : sized_list n) (n' : nat) (l' : sized_list n') : list nat :=
        match l' with
          | snil => nil
          | scons x _ l'' => cons (index_of x l) (build_permut l l'')
        end.
    
    End Definitions.
  End SizedList.

  Require Import String.
  Local Open Scope string_scope.

  Definition _name_list := SizedList.sized_list string.
  Definition _xcons := @SizedList.scons string.
  Definition _xnil := @SizedList.snil string.
  Definition _index_of := SizedList.index_of string_dec.
  Definition _concat := @SizedList.app string.
  Definition _build_permut := SizedList.build_permut string_dec.


  (** *** Named syntax *)

  Inductive _type : Type :=
  | _tvar (i : string)
  | _tconst (n : nat)
  | _tarrow (A : _type) (B : _type)
  | _tall (xl : _name_list 1) (A : _type)
  | _db_type (_xn_type : nat) (_xl_type : _name_list _xn_type) (_arg : type)
  .

  Hint Constructors _type : SYS_F_terms_database.

  Inductive _term : Type :=
  | _var (x : string)
  | _app (t1 : _term) (t2 : _term)
  | _lam (A : _type) (xl1 : _name_list 1) (t : _term)
  | _tapp (t : _term) (A : _type)
  | _gen (xl : _name_list 1) (t : _term)
  | _db_term (_xn_type : nat) (_xl_type : _name_list _xn_type) (_xn_term : nat) (_xl_term : _name_list _xn_term) (_arg : term)
  .

  Hint Constructors _term : SYS_F_terms_database.



  (** *** Free variable index permutations *)

  Fixpoint type_fv_permut_in_type (_k : nat) (_l_type : list nat) (_m : nat) (_arg : type) { struct _arg } : type :=
    match _arg with
      | tvar i =>
        if le_lt_dec _m i
        then
          if le_lt_dec (List.length _l_type) (i - _m)
          then tvar (i + _k)
          else tvar (_m + List.nth (i - _m) _l_type 0)
        else tvar i
      | tconst n =>
        tconst n
      | tarrow A B =>
        tarrow (type_fv_permut_in_type _k _l_type _m A) (type_fv_permut_in_type _k _l_type _m B)
      | tall A =>
        tall (type_fv_permut_in_type _k _l_type (_m + 1) A)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma type_fv_permut_in_type_tvar :
    forall (_k : nat) (_l_type : list nat) (_m : nat) (i : nat),
      type_fv_permut_in_type _k _l_type _m (tvar i) =
        if le_lt_dec _m i
        then
          if le_lt_dec (List.length _l_type) (i - _m)
          then tvar (i + _k)
          else tvar (_m + List.nth (i - _m) _l_type 0)
        else tvar i
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_type_tvar : SYS_F_terms_database.

  Lemma type_fv_permut_in_type_tconst :
    forall (_k : nat) (_l_type : list nat) (_m : nat) (n : nat),
      type_fv_permut_in_type _k _l_type _m (tconst n) =
        tconst n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_type_tconst : SYS_F_terms_database.

  Lemma type_fv_permut_in_type_tarrow :
    forall (_k : nat) (_l_type : list nat) (_m : nat) (A : type) (B : type),
      type_fv_permut_in_type _k _l_type _m (tarrow A B) =
        tarrow (type_fv_permut_in_type _k _l_type _m A) (type_fv_permut_in_type _k _l_type _m B)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_type_tarrow : SYS_F_terms_database.

  Lemma type_fv_permut_in_type_tall :
    forall (_k : nat) (_l_type : list nat) (_m : nat) (A : type),
      type_fv_permut_in_type _k _l_type _m (tall A) =
        tall (type_fv_permut_in_type _k _l_type (_m + 1) A)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_type_tall : SYS_F_terms_database.

  Fixpoint type_fv_permut_in_term (_k : nat) (_l_term : list nat) (_m : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        var x
      | app t1 t2 =>
        app (type_fv_permut_in_term _k _l_term _m t1) (type_fv_permut_in_term _k _l_term _m t2)
      | lam A t =>
        lam (type_fv_permut_in_type _k _l_term _m A) (type_fv_permut_in_term _k _l_term _m t)
      | tapp t A =>
        tapp (type_fv_permut_in_term _k _l_term _m t) (type_fv_permut_in_type _k _l_term _m A)
      | gen t =>
        gen (type_fv_permut_in_term _k _l_term (_m + 1) t)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma type_fv_permut_in_term_var :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (x : nat),
      type_fv_permut_in_term _k _l_term _m (var x) =
        var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_term_var : SYS_F_terms_database.

  Lemma type_fv_permut_in_term_app :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t1 : term) (t2 : term),
      type_fv_permut_in_term _k _l_term _m (app t1 t2) =
        app (type_fv_permut_in_term _k _l_term _m t1) (type_fv_permut_in_term _k _l_term _m t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_term_app : SYS_F_terms_database.

  Lemma type_fv_permut_in_term_lam :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (A : type) (t : term),
      type_fv_permut_in_term _k _l_term _m (lam A t) =
        lam (type_fv_permut_in_type _k _l_term _m A) (type_fv_permut_in_term _k _l_term _m t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_term_lam : SYS_F_terms_database.

  Lemma type_fv_permut_in_term_tapp :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t : term) (A : type),
      type_fv_permut_in_term _k _l_term _m (tapp t A) =
        tapp (type_fv_permut_in_term _k _l_term _m t) (type_fv_permut_in_type _k _l_term _m A)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_term_tapp : SYS_F_terms_database.

  Lemma type_fv_permut_in_term_gen :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t : term),
      type_fv_permut_in_term _k _l_term _m (gen t) =
        gen (type_fv_permut_in_term _k _l_term (_m + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite type_fv_permut_in_term_gen : SYS_F_terms_database.

  (** *** Free variable index permutations *)

  Fixpoint term_fv_permut_in_term (_k : nat) (_l_term : list nat) (_m : nat) (_arg : term) { struct _arg } : term :=
    match _arg with
      | var x =>
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_term) (x - _m)
          then var (x + _k)
          else var (_m + List.nth (x - _m) _l_term 0)
        else var x
      | app t1 t2 =>
        app (term_fv_permut_in_term _k _l_term _m t1) (term_fv_permut_in_term _k _l_term _m t2)
      | lam A t =>
        lam A (term_fv_permut_in_term _k _l_term (_m + 1) t)
      | tapp t A =>
        tapp (term_fv_permut_in_term _k _l_term _m t) A
      | gen t =>
        gen (term_fv_permut_in_term _k _l_term _m t)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma term_fv_permut_in_term_var :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (x : nat),
      term_fv_permut_in_term _k _l_term _m (var x) =
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_term) (x - _m)
          then var (x + _k)
          else var (_m + List.nth (x - _m) _l_term 0)
        else var x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_var : SYS_F_terms_database.

  Lemma term_fv_permut_in_term_app :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t1 : term) (t2 : term),
      term_fv_permut_in_term _k _l_term _m (app t1 t2) =
        app (term_fv_permut_in_term _k _l_term _m t1) (term_fv_permut_in_term _k _l_term _m t2)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_app : SYS_F_terms_database.

  Lemma term_fv_permut_in_term_lam :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (A : type) (t : term),
      term_fv_permut_in_term _k _l_term _m (lam A t) =
        lam A (term_fv_permut_in_term _k _l_term (_m + 1) t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_lam : SYS_F_terms_database.

  Lemma term_fv_permut_in_term_tapp :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t : term) (A : type),
      term_fv_permut_in_term _k _l_term _m (tapp t A) =
        tapp (term_fv_permut_in_term _k _l_term _m t) A
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_tapp : SYS_F_terms_database.

  Lemma term_fv_permut_in_term_gen :
    forall (_k : nat) (_l_term : list nat) (_m : nat) (t : term),
      term_fv_permut_in_term _k _l_term _m (gen t) =
        gen (term_fv_permut_in_term _k _l_term _m t)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite term_fv_permut_in_term_gen : SYS_F_terms_database.


  (** *** Named to De Bruijn translation function *)

  Fixpoint named_to_db_type (_n_type : nat) (_l_type : _name_list _n_type) (_arg : _type) { struct _arg } : type :=
    match _arg with
      | _tvar i =>
        tvar (_index_of i _n_type _l_type)
      | _tconst n =>
        tconst n
      | _tarrow A B =>
        tarrow (named_to_db_type _n_type _l_type A) (named_to_db_type _n_type _l_type B)
      | _tall xl A =>
        tall (named_to_db_type (1 + _n_type) (_concat 1 xl _n_type _l_type) A)
      | _db_type _xn_type _xl_type _arg =>
        (type_fv_permut_in_type (_n_type - _xn_type) (_build_permut _n_type _l_type _xn_type _xl_type) 0 _arg)
    end
  .

  (** Equations for Named to De Bruijn translation function *)


  Fixpoint named_to_db_term (_n_type : nat) (_l_type : _name_list _n_type) (_n_term : nat) (_l_term : _name_list _n_term) (_arg : _term) { struct _arg } : term :=
    match _arg with
      | _var x =>
        var (_index_of x _n_term _l_term)
      | _app t1 t2 =>
        app (named_to_db_term _n_type _l_type _n_term _l_term t1) (named_to_db_term _n_type _l_type _n_term _l_term t2)
      | _lam A xl1 t =>
        lam (named_to_db_type _n_type _l_type A) (named_to_db_term _n_type _l_type (1 + _n_term) (_concat 1 xl1 _n_term _l_term) t)
      | _tapp t A =>
        tapp (named_to_db_term _n_type _l_type _n_term _l_term t) (named_to_db_type _n_type _l_type A)
      | _gen xl t =>
        gen (named_to_db_term (1 + _n_type) (_concat 1 xl _n_type _l_type) _n_term _l_term t)
      | _db_term _xn_type _xl_type _xn_term _xl_term _arg =>
        (type_fv_permut_in_term (_n_type - _xn_type) (_build_permut _n_type _l_type _xn_type _xl_type) 0 (term_fv_permut_in_term (_n_term - _xn_term) (_build_permut _n_term _l_term _xn_term _xl_term) 0 _arg))
    end
  .

  (** Equations for Named to De Bruijn translation function *)





  (** * Primary lifting and substitution properties *)

  Lemma type_lift_in_type_tvar_dec :
    forall _n _m _p : nat,
    { prod (_m <= _p) (type_lift_in_type _n _m (tvar _p) = tvar (_p + _n)) } +
    { prod (_p < _m) (type_lift_in_type _n _m (tvar _p) = tvar _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _type_lift_in_type_tvar_dec_tac n m p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (type_lift_in_type_tvar_dec n m p) as
              [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.
  Lemma term_lift_in_term_var_dec :
    forall _n _m _p : nat,
    { prod (_m <= _p) (term_lift_in_term _n _m (var _p) = var (_p + _n)) } +
    { prod (_p < _m) (term_lift_in_term _n _m (var _p) = var _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _term_lift_in_term_var_dec_tac n m p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (term_lift_in_term_var_dec n m p) as
              [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Ltac lift_index_dec_tac :=
    match goal with
      | [ |- context [ type_lift_in_type ?n ?m (tvar ?p) ] ] =>
        _type_lift_in_type_tvar_dec_tac n m p

      | [ H : context [ type_lift_in_type ?n ?m (tvar ?p) ] |- _ ] =>
        _type_lift_in_type_tvar_dec_tac n m p

      | [ |- context [ term_lift_in_term ?n ?m (var ?p) ] ] =>
        _term_lift_in_term_var_dec_tac n m p

      | [ H : context [ term_lift_in_term ?n ?m (var ?p) ] |- _ ] =>
        _term_lift_in_term_var_dec_tac n m p

    end.

  Lemma type_subst_in_type_tvar_dec :
    forall (_a : type) (_n _p : nat),
    { prod (_n < _p) (type_subst_in_type _a _n (tvar _p) = tvar (_p - 1)) } +
    { prod (_n = _p) (type_subst_in_type _a _n (tvar _p) = _a) } +
    { prod (_p < _n) (type_subst_in_type _a _n (tvar _p) = tvar _p) }.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ];
      subst; simpl; crush_tac.
  Qed.

  Ltac _type_subst_in_type_tvar_dec_tac a n p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (type_subst_in_type_tvar_dec a n p) as
              [ [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ]
                | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.
  Lemma term_subst_in_term_var_dec :
    forall (_a : term) (_n _p : nat),
    { prod (_n < _p) (term_subst_in_term _a _n (var _p) = var (_p - 1)) } +
    { prod (_n = _p) (term_subst_in_term _a _n (var _p) = _a) } +
    { prod (_p < _n) (term_subst_in_term _a _n (var _p) = var _p) }.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ];
      subst; simpl; crush_tac.
  Qed.

  Ltac _term_subst_in_term_var_dec_tac a n p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (term_subst_in_term_var_dec a n p) as
              [ [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ]
                | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Ltac subst_index_dec_tac :=
    match goal with
      | [ |- context [ type_subst_in_type ?a ?n (tvar ?p) ] ] =>
        _type_subst_in_type_tvar_dec_tac a n p

      | [ H : context [ type_subst_in_type ?a ?n (tvar ?p) ] |- _ ] =>
        _type_subst_in_type_tvar_dec_tac a n p

      | [ |- context [ term_subst_in_term ?a ?n (var ?p) ] ] =>
        _term_subst_in_term_var_dec_tac a n p

      | [ H : context [ term_subst_in_term ?a ?n (var ?p) ] |- _ ] =>
        _term_subst_in_term_var_dec_tac a n p

    end.

  Lemma type_lift_in_type_tvar_le :
    forall _n _m _p : nat,
      _m <= _p -> type_lift_in_type _n _m (tvar _p) = tvar (_p + _n).
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma type_lift_in_type_tvar_lt :
    forall _n _m _p : nat,
      _p < _m -> type_lift_in_type _n _m (tvar _p) = tvar _p.
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.
  Lemma term_lift_in_term_var_le :
    forall _n _m _p : nat,
      _m <= _p -> term_lift_in_term _n _m (var _p) = var (_p + _n).
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_lift_in_term_var_lt :
    forall _n _m _p : nat,
      _p < _m -> term_lift_in_term _n _m (var _p) = var _p.
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Ltac lift_index_tac :=
    match goal with
      | [ |- context [ type_lift_in_type ?n ?m (tvar ?p) ] ] =>
          (cutrewrite ->
            (type_lift_in_type n m (tvar p) = tvar (p + n));
            [ | apply (type_lift_in_type_tvar_le n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (tvar p) = tvar p);
            [ | apply (type_lift_in_type_tvar_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ H : context [ type_lift_in_type ?n ?m (tvar ?p) ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_type n m (tvar p) = tvar (p + n)) in H;
            [ | apply (type_lift_in_type_tvar_le n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (tvar p) = tvar p) in H;
            [ | apply (type_lift_in_type_tvar_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ |- context [ term_lift_in_term ?n ?m (var ?p) ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var (p + n));
            [ | apply (term_lift_in_term_var_le n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var p);
            [ | apply (term_lift_in_term_var_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ H : context [ term_lift_in_term ?n ?m (var ?p) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var (p + n)) in H;
            [ | apply (term_lift_in_term_var_le n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (var p) = var p) in H;
            [ | apply (term_lift_in_term_var_lt n m p); cfail ]) ||
          lift_index_dec_tac

    end.

  Lemma type_subst_in_type_tvar_lt_l :
    forall (_a : type) (_n _p : nat),
      _n < _p -> type_subst_in_type _a _n (tvar _p) = tvar (_p - 1).
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma type_subst_in_type_tvar_eq :
    forall (_a : type) (_n _p : nat),
      _n = _p -> type_subst_in_type _a _n (tvar _p) = _a.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma type_subst_in_type_tvar_lt_r :
    forall (_a : type) (_n _p : nat),
      _p < _n -> type_subst_in_type _a _n (tvar _p) = tvar _p.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.
  Lemma term_subst_in_term_var_lt_l :
    forall (_a : term) (_n _p : nat),
      _n < _p -> term_subst_in_term _a _n (var _p) = var (_p - 1).
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma term_subst_in_term_var_eq :
    forall (_a : term) (_n _p : nat),
      _n = _p -> term_subst_in_term _a _n (var _p) = _a.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma term_subst_in_term_var_lt_r :
    forall (_a : term) (_n _p : nat),
      _p < _n -> term_subst_in_term _a _n (var _p) = var _p.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Ltac subst_index_tac :=
    match goal with
        | [ |- context [ type_subst_in_type ?a ?n (tvar ?m) ] ] =>
          (cutrewrite ->
            (type_subst_in_type a n (tvar m) = tvar (m - 1));
            [ | apply (type_subst_in_type_tvar_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (type_subst_in_type a n (tvar m) = a);
            [ | apply (type_subst_in_type_tvar_eq a n m); cfail ]) ||
          (cutrewrite ->
            (type_subst_in_type a n (tvar m) = tvar m);
            [ | apply (type_subst_in_type_tvar_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ H : context [ type_subst_in_type ?a ?n (tvar ?m) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_type a n (tvar m) = tvar (m - 1)) in H;
            [ | apply (type_subst_in_type_tvar_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (type_subst_in_type a n (tvar m) = a) in H;
            [ | apply (type_subst_in_type_tvar_eq a n m); cfail ]) ||
          (cutrewrite ->
            (type_subst_in_type a n (tvar m) = tvar m) in H;
            [ | apply (type_subst_in_type_tvar_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ |- context [ term_subst_in_term ?a ?n (var ?m) ] ] =>
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var (m - 1));
            [ | apply (term_subst_in_term_var_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = a);
            [ | apply (term_subst_in_term_var_eq a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var m);
            [ | apply (term_subst_in_term_var_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ H : context [ term_subst_in_term ?a ?n (var ?m) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var (m - 1)) in H;
            [ | apply (term_subst_in_term_var_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = a) in H;
            [ | apply (term_subst_in_term_var_eq a n m); cfail ]) ||
          (cutrewrite ->
            (term_subst_in_term a n (var m) = var m) in H;
            [ | apply (term_subst_in_term_var_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

    end.

  Ltac index_tac :=
    repeat (progress (lift_index_tac || subst_index_tac)).



  (** * Additional properties *)


  (** ** Lifting main properties *)


  (** *** Lifting with 0 simplification *)

  Lemma type_lift_in_type_0_simpl :
    forall (_arg : type) (_m : nat),
      type_lift_in_type 0 _m _arg = _arg
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite type_lift_in_type_0_simpl : SYS_F_terms_database.

  Lemma type_lift_in_term_0_simpl :
    forall (_arg : term) (_m : nat),
      type_lift_in_term 0 _m _arg = _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_lift_in_type_0_simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_lift_in_type_0_simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite type_lift_in_term_0_simpl : SYS_F_terms_database.

  Lemma term_lift_in_term_0_simpl :
    forall (_arg : term) (_m : nat),
      term_lift_in_term 0 _m _arg = _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite term_lift_in_term_0_simpl : SYS_F_terms_database.

  (** *** Lifting with 0 simplification generalized *)

  Lemma type_lift_in_type_0_simpl_gen :
    forall (_arg : type) (_n _m : nat),
      _n = 0 -> type_lift_in_type _n _m _arg = _arg
  .
  Proof.
    intros; subst; crush_tac.
  Qed.


  Lemma type_lift_in_term_0_simpl_gen :
    forall (_arg : term) (_n _m : nat),
      _n = 0 -> type_lift_in_term _n _m _arg = _arg
  .
  Proof.
    intros; subst; crush_tac.
  Qed.


  Lemma term_lift_in_term_0_simpl_gen :
    forall (_arg : term) (_n _m : nat),
      _n = 0 -> term_lift_in_term _n _m _arg = _arg
  .
  Proof.
    intros; subst; crush_tac.
  Qed.


  Ltac lift_0_simpl_tac :=
    repeat
      match goal with
        | [ |- context [ type_lift_in_type ?n ?m ?t ] ] =>
          (cutrewrite ->
            (type_lift_in_type n m t = t);
            [ | apply (type_lift_in_type_0_simpl_gen t n m); cfail ])
        | [ H : context [ type_lift_in_type ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_type n m t = t) in H;
            [ | apply (type_lift_in_type_0_simpl_gen t n m); cfail ])
        | [ |- context [ type_lift_in_term ?n ?m ?t ] ] =>
          (cutrewrite ->
            (type_lift_in_term n m t = t);
            [ | apply (type_lift_in_term_0_simpl_gen t n m); cfail ])
        | [ H : context [ type_lift_in_term ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_term n m t = t) in H;
            [ | apply (type_lift_in_term_0_simpl_gen t n m); cfail ])
        | [ |- context [ term_lift_in_term ?n ?m ?t ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m t = t);
            [ | apply (term_lift_in_term_0_simpl_gen t n m); cfail ])
        | [ H : context [ term_lift_in_term ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m t = t) in H;
            [ | apply (term_lift_in_term_0_simpl_gen t n m); cfail ])
      end; crush_tac.

  (** *** Lifting over lifting simplification and commutation *)

  Lemma type_lift_in_type_type_lift_in_type_simpl :
    forall (_arg : type) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      type_lift_in_type _n _m (type_lift_in_type _n' _m' _arg) =
      type_lift_in_type (_n' + _n) _m' _arg
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      idtac.
  Qed.


  Lemma type_lift_in_term_type_lift_in_term_simpl :
    forall (_arg : term) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      type_lift_in_term _n _m (type_lift_in_term _n' _m' _arg) =
      type_lift_in_term (_n' + _n) _m' _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_lift_in_type_type_lift_in_type_simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_lift_in_type_type_lift_in_type_simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.


  Lemma term_lift_in_term_term_lift_in_term_simpl :
    forall (_arg : term) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      term_lift_in_term _n _m (term_lift_in_term _n' _m' _arg) =
      term_lift_in_term (_n' + _n) _m' _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.


  Lemma type_lift_in_type_type_lift_in_type_commut :
    forall (_arg : type) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      type_lift_in_type _n _m (type_lift_in_type _n' _m' _arg) =
      type_lift_in_type _n' _m' (type_lift_in_type _n (_m - _n') _arg)
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      idtac.
  Qed.


  Lemma type_lift_in_term_type_lift_in_term_commut :
    forall (_arg : term) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      type_lift_in_term _n _m (type_lift_in_term _n' _m' _arg) =
      type_lift_in_term _n' _m' (type_lift_in_term _n (_m - _n') _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_lift_in_type_type_lift_in_type_commut; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_lift_in_type_type_lift_in_type_commut; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.


  Lemma term_lift_in_term_term_lift_in_term_commut :
    forall (_arg : term) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      term_lift_in_term _n _m (term_lift_in_term _n' _m' _arg) =
      term_lift_in_term _n' _m' (term_lift_in_term _n (_m - _n') _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.


  Ltac lift_lift_tac :=
    repeat
      match goal with
        | [ |- context [ type_lift_in_type ?n ?m (type_lift_in_type ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (type_lift_in_type n m (type_lift_in_type p q t) =
             type_lift_in_type (p + n) q t);
            [ | apply (type_lift_in_type_type_lift_in_type_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (type_lift_in_type p q t) =
             type_lift_in_type p q (type_lift_in_type n (m - p) t));
            [ | apply (type_lift_in_type_type_lift_in_type_commut t n m p q); cfail ])
        | [ H : context [ type_lift_in_type ?n ?m (type_lift_in_type ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_type n m (type_lift_in_type p q t) =
             type_lift_in_type (p + n) q t) in H;
            [ | apply (type_lift_in_type_type_lift_in_type_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (type_lift_in_type p q t) =
             type_lift_in_type p q (type_lift_in_type n (m - p) t)) in H;
            [ | apply (type_lift_in_type_type_lift_in_type_commut t n m p q); cfail ])
        | [ |- context [ type_lift_in_term ?n ?m (type_lift_in_term ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (type_lift_in_term n m (type_lift_in_term p q t) =
             type_lift_in_term (p + n) q t);
            [ | apply (type_lift_in_term_type_lift_in_term_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_term n m (type_lift_in_term p q t) =
             type_lift_in_term p q (type_lift_in_term n (m - p) t));
            [ | apply (type_lift_in_term_type_lift_in_term_commut t n m p q); cfail ])
        | [ H : context [ type_lift_in_term ?n ?m (type_lift_in_term ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_term n m (type_lift_in_term p q t) =
             type_lift_in_term (p + n) q t) in H;
            [ | apply (type_lift_in_term_type_lift_in_term_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_term n m (type_lift_in_term p q t) =
             type_lift_in_term p q (type_lift_in_term n (m - p) t)) in H;
            [ | apply (type_lift_in_term_type_lift_in_term_commut t n m p q); cfail ])
        | [ |- context [ term_lift_in_term ?n ?m (term_lift_in_term ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term (p + n) q t);
            [ | apply (term_lift_in_term_term_lift_in_term_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term p q (term_lift_in_term n (m - p) t));
            [ | apply (term_lift_in_term_term_lift_in_term_commut t n m p q); cfail ])
        | [ H : context [ term_lift_in_term ?n ?m (term_lift_in_term ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term (p + n) q t) in H;
            [ | apply (term_lift_in_term_term_lift_in_term_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_lift_in_term p q t) =
             term_lift_in_term p q (term_lift_in_term n (m - p) t)) in H;
            [ | apply (term_lift_in_term_term_lift_in_term_commut t n m p q); cfail ])
      end; crush_tac.

  Ltac lift_tac :=
    crush_tac;
    repeat (progress (lift_index_tac || lift_0_simpl_tac || lift_lift_tac)).


  (** ** Substitution main properties *)


  (** *** Lifting and substitution respective independance *)

  Lemma type_lift_in_term_term_lift_in_term_indep :
    forall (_arg : term) (_n _m _n' _m' : nat),
      type_lift_in_term _n _m (term_lift_in_term _n' _m' _arg) = 
      term_lift_in_term _n' _m' (type_lift_in_term _n _m _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros; 
        [ index_tac; simpl; try destruct le_lt_dec as [ ? | ? ]; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite type_lift_in_term_term_lift_in_term_indep : SYS_F_terms_database.

  Lemma type_lift_in_term_term_subst_in_term_indep :
    forall (_arg : term) (_n _m _p : nat) (_arg' : term),
      type_lift_in_term _n _m (term_subst_in_term _arg' _p _arg) = 
      term_subst_in_term (type_lift_in_term _n _m _arg') _p (type_lift_in_term _n _m _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros; 
        [ index_tac; simpl; try destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; try destruct le_lt_dec as [ ? | ? ]; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      lift_lift_tac; crush_tac.
  Qed.

  Hint Rewrite type_lift_in_term_term_subst_in_term_indep : SYS_F_terms_database.

  Lemma term_lift_in_term_type_subst_in_term_indep :
    forall (_arg : term) (_n _m _p : nat) (_arg' : type),
      term_lift_in_term _n _m (type_subst_in_term _arg' _p _arg) = 
      type_subst_in_term _arg' _p (term_lift_in_term _n _m _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros; 
        [ index_tac; simpl; try destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; try destruct le_lt_dec as [ ? | ? ]; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      lift_lift_tac; crush_tac.
  Qed.

  Hint Rewrite term_lift_in_term_type_subst_in_term_indep : SYS_F_terms_database.

  (** *** Interactions between lifting and substitution *)

  Lemma type_subst_in_type_type_lift_in_type_simpl :
    forall (_arg : type) (_arg' : type) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      type_subst_in_type _arg' _p (type_lift_in_type _n _m _arg) =
      type_lift_in_type (_n - 1) _m _arg
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      idtac.
  Qed.


  Lemma type_subst_in_term_type_lift_in_term_simpl :
    forall (_arg : term) (_arg' : type) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      type_subst_in_term _arg' _p (type_lift_in_term _n _m _arg) =
      type_lift_in_term (_n - 1) _m _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_subst_in_type_type_lift_in_type_simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_subst_in_type_type_lift_in_type_simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_simpl :
    forall (_arg : term) (_arg' : term) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      term_subst_in_term _arg' _p (term_lift_in_term _n _m _arg) =
      term_lift_in_term (_n - 1) _m _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.


  Lemma type_subst_in_type_type_lift_in_type_0_simpl :
    forall (_arg : type) (_n _m : nat),
      0 < _n ->
      type_subst_in_type (tvar _m) _m (type_lift_in_type _n (S _m) _arg) =
      type_lift_in_type (_n - 1) (S _m) _arg
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma type_subst_in_term_type_lift_in_term_0_simpl :
    forall (_arg : term) (_n _m : nat),
      0 < _n ->
      type_subst_in_term (tvar _m) _m (type_lift_in_term _n (S _m) _arg) =
      type_lift_in_term (_n - 1) (S _m) _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_subst_in_type_type_lift_in_type_0_simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_subst_in_type_type_lift_in_type_0_simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_0_simpl :
    forall (_arg : term) (_n _m : nat),
      0 < _n ->
      term_subst_in_term (var _m) _m (term_lift_in_term _n (S _m) _arg) =
      term_lift_in_term (_n - 1) (S _m) _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma type_subst_in_type_type_lift_in_type_commut :
    forall (_arg : type) (_arg' : type) (_n _m _p : nat),
      _m <= _p ->
      type_lift_in_type _n _m (type_subst_in_type _arg' _p _arg) =
      type_subst_in_type (type_lift_in_type _n _m _arg') (_p + _n) (type_lift_in_type _n _m _arg)
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma type_subst_in_term_type_lift_in_term_commut :
    forall (_arg : term) (_arg' : type) (_n _m _p : nat),
      _m <= _p ->
      type_lift_in_term _n _m (type_subst_in_term _arg' _p _arg) =
      type_subst_in_term (type_lift_in_type _n _m _arg') (_p + _n) (type_lift_in_term _n _m _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_subst_in_type_type_lift_in_type_commut; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_subst_in_type_type_lift_in_type_commut; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_commut :
    forall (_arg : term) (_arg' : term) (_n _m _p : nat),
      _m <= _p ->
      term_lift_in_term _n _m (term_subst_in_term _arg' _p _arg) =
      term_subst_in_term (term_lift_in_term _n _m _arg') (_p + _n) (term_lift_in_term _n _m _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma type_subst_in_type_type_lift_in_type_distrib :
    forall (_arg : type) (_arg' : type) (_n _m _p : nat),
      _p <= _m ->
      type_lift_in_type _n _m (type_subst_in_type _arg' _p _arg) =
      type_subst_in_type (type_lift_in_type _n _m _arg') _p (type_lift_in_type _n (S _m) _arg)
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma type_subst_in_term_type_lift_in_term_distrib :
    forall (_arg : term) (_arg' : type) (_n _m _p : nat),
      _p <= _m ->
      type_lift_in_term _n _m (type_subst_in_term _arg' _p _arg) =
      type_subst_in_term (type_lift_in_type _n _m _arg') _p (type_lift_in_term _n (S _m) _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_subst_in_type_type_lift_in_type_distrib; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_subst_in_type_type_lift_in_type_distrib; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma term_subst_in_term_term_lift_in_term_distrib :
    forall (_arg : term) (_arg' : term) (_n _m _p : nat),
      _p <= _m ->
      term_lift_in_term _n _m (term_subst_in_term _arg' _p _arg) =
      term_subst_in_term (term_lift_in_term _n _m _arg') _p (term_lift_in_term _n (S _m) _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Ltac subst_lift_tac :=
    repeat
      match goal with
        | [ |- context [ type_subst_in_type ?v ?p (type_lift_in_type ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (type_subst_in_type v p (type_lift_in_type n m t) =
             type_lift_in_type (n - 1) m t);
            [ | apply (type_subst_in_type_type_lift_in_type_simpl t v n m p); cfail ])
        | [ H : context [ type_subst_in_type ?v ?p (type_lift_in_type ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_type v p (type_lift_in_type n m t) =
             type_lift_in_type (n - 1) m t) in H;
            [ | apply (type_subst_in_type_type_lift_in_type_simpl t v n m p); cfail ])
        | [ |- context [ type_subst_in_term ?v ?p (type_lift_in_term ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (type_subst_in_term v p (type_lift_in_term n m t) =
             type_lift_in_term (n - 1) m t);
            [ | apply (type_subst_in_term_type_lift_in_term_simpl t v n m p); cfail ])
        | [ H : context [ type_subst_in_term ?v ?p (type_lift_in_term ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_term v p (type_lift_in_term n m t) =
             type_lift_in_term (n - 1) m t) in H;
            [ | apply (type_subst_in_term_type_lift_in_term_simpl t v n m p); cfail ])
        | [ |- context [ term_subst_in_term ?v ?p (term_lift_in_term ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (term_subst_in_term v p (term_lift_in_term n m t) =
             term_lift_in_term (n - 1) m t);
            [ | apply (term_subst_in_term_term_lift_in_term_simpl t v n m p); cfail ])
        | [ H : context [ term_subst_in_term ?v ?p (term_lift_in_term ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term v p (term_lift_in_term n m t) =
             term_lift_in_term (n - 1) m t) in H;
            [ | apply (term_subst_in_term_term_lift_in_term_simpl t v n m p); cfail ])
        | [ |- context [ type_subst_in_type (tvar ?m) ?m (type_lift_in_type ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (type_subst_in_type (tvar m) m (type_lift_in_type n (S m) t) =
             type_lift_in_type (n - 1) (S m) t);
            [ | apply (type_subst_in_type_type_lift_in_type_0_simpl t n m); cfail ])
        | [ H : context [ type_subst_in_type (tvar ?m) ?m (type_lift_in_type ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_type (tvar m) m (type_lift_in_type n (S m) t) =
             type_lift_in_type (n - 1) (S m) t) in H;
            [ | apply (type_subst_in_type_type_lift_in_type_0_simpl t n m); cfail ])
        | [ |- context [ type_subst_in_term (tvar ?m) ?m (type_lift_in_term ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (type_subst_in_term (tvar m) m (type_lift_in_term n (S m) t) =
             type_lift_in_term (n - 1) (S m) t);
            [ | apply (type_subst_in_term_type_lift_in_term_0_simpl t n m); cfail ])
        | [ H : context [ type_subst_in_term (tvar ?m) ?m (type_lift_in_term ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_term (tvar m) m (type_lift_in_term n (S m) t) =
             type_lift_in_term (n - 1) (S m) t) in H;
            [ | apply (type_subst_in_term_type_lift_in_term_0_simpl t n m); cfail ])
        | [ |- context [ term_subst_in_term (var ?m) ?m (term_lift_in_term ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (term_subst_in_term (var m) m (term_lift_in_term n (S m) t) =
             term_lift_in_term (n - 1) (S m) t);
            [ | apply (term_subst_in_term_term_lift_in_term_0_simpl t n m); cfail ])
        | [ H : context [ term_subst_in_term (var ?m) ?m (term_lift_in_term ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term (var m) m (term_lift_in_term n (S m) t) =
             term_lift_in_term (n - 1) (S m) t) in H;
            [ | apply (term_subst_in_term_term_lift_in_term_0_simpl t n m); cfail ])
        | [ |- context [ type_lift_in_type ?n ?m (type_subst_in_type ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (type_lift_in_type n m (type_subst_in_type v p t) =
             type_subst_in_type (type_lift_in_type n m v) (p + n) (type_lift_in_type n m t));
            [ cfail | apply (type_subst_in_type_type_lift_in_type_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (type_subst_in_type v p t) =
             type_subst_in_type (type_lift_in_type n m v) p (type_lift_in_type n (S m) t));
            [ cfail | apply (type_subst_in_type_type_lift_in_type_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (type_subst_in_type v p t) =
             type_subst_in_type (type_lift_in_type n m v) (p + n) (type_lift_in_type n m t));
            [ | apply (type_subst_in_type_type_lift_in_type_commut t v n m p); cfail ])
        | [ H : context [ type_lift_in_type ?n ?m (type_subst_in_type ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_type n m (type_subst_in_type v p t) =
             type_subst_in_type (type_lift_in_type n m v) (p + n) (type_lift_in_type n m t)) in H;
            [ cfail | apply (type_subst_in_type_type_lift_in_type_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (type_subst_in_type v p t) =
             type_subst_in_type (type_lift_in_type n m v) p (type_lift_in_type n (S m) t)) in H;
            [ cfail | apply (type_subst_in_type_type_lift_in_type_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_type n m (type_subst_in_type v p t) =
             type_subst_in_type (type_lift_in_type n m v) (p + n) (type_lift_in_type n m t)) in H;
            [ | apply (type_subst_in_type_type_lift_in_type_commut t v n m p); cfail ])
        | [ |- context [ type_lift_in_term ?n ?m (type_subst_in_term ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (type_lift_in_term n m (type_subst_in_term v p t) =
             type_subst_in_term (type_lift_in_type n m v) (p + n) (type_lift_in_term n m t));
            [ cfail | apply (type_subst_in_term_type_lift_in_term_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_term n m (type_subst_in_term v p t) =
             type_subst_in_term (type_lift_in_type n m v) p (type_lift_in_term n (S m) t));
            [ cfail | apply (type_subst_in_term_type_lift_in_term_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_term n m (type_subst_in_term v p t) =
             type_subst_in_term (type_lift_in_type n m v) (p + n) (type_lift_in_term n m t));
            [ | apply (type_subst_in_term_type_lift_in_term_commut t v n m p); cfail ])
        | [ H : context [ type_lift_in_term ?n ?m (type_subst_in_term ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (type_lift_in_term n m (type_subst_in_term v p t) =
             type_subst_in_term (type_lift_in_type n m v) (p + n) (type_lift_in_term n m t)) in H;
            [ cfail | apply (type_subst_in_term_type_lift_in_term_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_term n m (type_subst_in_term v p t) =
             type_subst_in_term (type_lift_in_type n m v) p (type_lift_in_term n (S m) t)) in H;
            [ cfail | apply (type_subst_in_term_type_lift_in_term_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (type_lift_in_term n m (type_subst_in_term v p t) =
             type_subst_in_term (type_lift_in_type n m v) (p + n) (type_lift_in_term n m t)) in H;
            [ | apply (type_subst_in_term_type_lift_in_term_commut t v n m p); cfail ])
        | [ |- context [ term_lift_in_term ?n ?m (term_subst_in_term ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n m v) (p + n) (term_lift_in_term n m t));
            [ cfail | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n m v) p (term_lift_in_term n (S m) t));
            [ cfail | apply (term_subst_in_term_term_lift_in_term_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n m v) (p + n) (term_lift_in_term n m t));
            [ | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ])
        | [ H : context [ term_lift_in_term ?n ?m (term_subst_in_term ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n m v) (p + n) (term_lift_in_term n m t)) in H;
            [ cfail | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n m v) p (term_lift_in_term n (S m) t)) in H;
            [ cfail | apply (term_subst_in_term_term_lift_in_term_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (term_lift_in_term n m (term_subst_in_term v p t) =
             term_subst_in_term (term_lift_in_term n m v) (p + n) (term_lift_in_term n m t)) in H;
            [ | apply (term_subst_in_term_term_lift_in_term_commut t v n m p); cfail ])
      end; crush_tac.

  (** *** Substitution lemma *)

  Lemma type_subst_in_type_type_subst_in_type_distrib :
    forall (_arg : type) (_arg' _arg'' : type) (_n _m : nat),
      _m <= _n ->
      type_subst_in_type _arg' _n (type_subst_in_type _arg'' _m _arg) =
      type_subst_in_type (type_subst_in_type _arg' _n _arg'') _m (type_subst_in_type (type_lift_in_type 1 _m _arg') (S _n) _arg)
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.
  Qed.


  Lemma type_subst_in_term_type_subst_in_term_distrib :
    forall (_arg : term) (_arg' _arg'' : type) (_n _m : nat),
      _m <= _n ->
      type_subst_in_term _arg' _n (type_subst_in_term _arg'' _m _arg) =
      type_subst_in_term (type_subst_in_type _arg' _n _arg'') _m (type_subst_in_term (type_lift_in_type 1 _m _arg') (S _n) _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_subst_in_type_type_subst_in_type_distrib; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_subst_in_type_type_subst_in_type_distrib; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.
  Qed.


  Lemma term_subst_in_term_term_subst_in_term_distrib :
    forall (_arg : term) (_arg' _arg'' : term) (_n _m : nat),
      _m <= _n ->
      term_subst_in_term _arg' _n (term_subst_in_term _arg'' _m _arg) =
      term_subst_in_term (term_subst_in_term _arg' _n _arg'') _m (term_subst_in_term (term_lift_in_term 1 _m _arg') (S _n) _arg)
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.
  Qed.


  Ltac subst_subst_tac :=
    repeat
      match goal with
        | [ |- context [ type_subst_in_type ?b ?n (type_subst_in_type ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (type_subst_in_type b n (type_subst_in_type c m a) =
             type_subst_in_type (type_subst_in_type b n c) m (type_subst_in_type (type_lift_in_type 1 m b) (S n) a));
            [ | apply (type_subst_in_type_type_subst_in_type_distrib a b c n m); cfail ])
        | [ H : context [ type_subst_in_type ?b ?n (type_subst_in_type ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_type b n (type_subst_in_type c m a) =
             type_subst_in_type (type_subst_in_type b n c) m (type_subst_in_type (type_lift_in_type 1 m b) (S n) a)) in H;
            [ | apply (type_subst_in_type_type_subst_in_type_distrib a b c n m); cfail ])
        | [ |- context [ type_subst_in_term ?b ?n (type_subst_in_term ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (type_subst_in_term b n (type_subst_in_term c m a) =
             type_subst_in_term (type_subst_in_type b n c) m (type_subst_in_term (type_lift_in_type 1 m b) (S n) a));
            [ | apply (type_subst_in_term_type_subst_in_term_distrib a b c n m); cfail ])
        | [ H : context [ type_subst_in_term ?b ?n (type_subst_in_term ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (type_subst_in_term b n (type_subst_in_term c m a) =
             type_subst_in_term (type_subst_in_type b n c) m (type_subst_in_term (type_lift_in_type 1 m b) (S n) a)) in H;
            [ | apply (type_subst_in_term_type_subst_in_term_distrib a b c n m); cfail ])
        | [ |- context [ term_subst_in_term ?b ?n (term_subst_in_term ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (term_subst_in_term b n (term_subst_in_term c m a) =
             term_subst_in_term (term_subst_in_term b n c) m (term_subst_in_term (term_lift_in_term 1 m b) (S n) a));
            [ | apply (term_subst_in_term_term_subst_in_term_distrib a b c n m); cfail ])
        | [ H : context [ term_subst_in_term ?b ?n (term_subst_in_term ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (term_subst_in_term b n (term_subst_in_term c m a) =
             term_subst_in_term (term_subst_in_term b n c) m (term_subst_in_term (term_lift_in_term 1 m b) (S n) a)) in H;
            [ | apply (term_subst_in_term_term_subst_in_term_distrib a b c n m); cfail ])
      end; crush_tac.

  Ltac subst_tac :=
    crush_tac;
    repeat (progress (subst_index_tac || subst_lift_tac || subst_subst_tac)).


  (** ** Free variables permutation properties *)

  Lemma type_fv_permut_in_type_tvar_dec :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
    { prod (prod (_m <= _p) ((_p - _m) < List.length _l)) (type_fv_permut_in_type _k _l _m (tvar _p) = tvar (_m + List.nth (_p - _m) _l 0)) } +
    { prod (prod (_m <= _p) (List.length _l <= (_p - _m))) (type_fv_permut_in_type _k _l _m (tvar _p) = tvar (_p + _k)) } +
    { prod (_p < _m) (type_fv_permut_in_type _k _l _m (tvar _p) = tvar _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _type_fv_permut_in_type_tvar_dec_tac k l m p :=
    let Hcomp := fresh "Hcomp" in
       let Hcomp' := fresh "Hcomp'" in
          let Hfun := fresh "Hfun" in
            destruct (type_fv_permut_in_type_tvar_dec k l m p) as
              [ [ [ [ Hcomp Hcomp' ] Hfun ] | [ [ Hcomp Hcomp' ] Hfun ] ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Lemma term_fv_permut_in_term_var_dec :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
    { prod (prod (_m <= _p) ((_p - _m) < List.length _l)) (term_fv_permut_in_term _k _l _m (var _p) = var (_m + List.nth (_p - _m) _l 0)) } +
    { prod (prod (_m <= _p) (List.length _l <= (_p - _m))) (term_fv_permut_in_term _k _l _m (var _p) = var (_p + _k)) } +
    { prod (_p < _m) (term_fv_permut_in_term _k _l _m (var _p) = var _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _term_fv_permut_in_term_var_dec_tac k l m p :=
    let Hcomp := fresh "Hcomp" in
       let Hcomp' := fresh "Hcomp'" in
          let Hfun := fresh "Hfun" in
            destruct (term_fv_permut_in_term_var_dec k l m p) as
              [ [ [ [ Hcomp Hcomp' ] Hfun ] | [ [ Hcomp Hcomp' ] Hfun ] ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.


  Ltac fv_permut_index_dec_tac :=
    match goal with
      | [ |- context [ type_fv_permut_in_type ?k ?l ?m (tvar ?p) ] ] =>
        _type_fv_permut_in_type_tvar_dec_tac k l m p

      | [ H : context [ type_fv_permut_in_type ?k ?l ?m (tvar ?p) ] |- _ ] =>
        _type_fv_permut_in_type_tvar_dec_tac k l m p

      | [ |- context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] ] =>
        _term_fv_permut_in_term_var_dec_tac k l m p

      | [ H : context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] |- _ ] =>
        _term_fv_permut_in_term_var_dec_tac k l m p

    end.

  Lemma type_fv_permut_in_type_tvar_le_le :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> List.length _l <= (_p - _m) -> type_fv_permut_in_type _k _l _m (tvar _p) = tvar (_p + _k).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma type_fv_permut_in_type_tvar_le_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> (_p - _m) < List.length _l -> type_fv_permut_in_type _k _l _m (tvar _p) = tvar (_m + List.nth (_p - _m) _l 0).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma type_fv_permut_in_type_tvar_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _p < _m -> type_fv_permut_in_type _k _l _m (tvar _p) = tvar _p.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_fv_permut_in_term_var_le_le :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> List.length _l <= (_p - _m) -> term_fv_permut_in_term _k _l _m (var _p) = var (_p + _k).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_fv_permut_in_term_var_le_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> (_p - _m) < List.length _l -> term_fv_permut_in_term _k _l _m (var _p) = var (_m + List.nth (_p - _m) _l 0).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma term_fv_permut_in_term_var_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _p < _m -> term_fv_permut_in_term _k _l _m (var _p) = var _p.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.


  Ltac fv_permut_index_tac :=
    repeat match goal with
      | [ |- context [ type_fv_permut_in_type ?k ?l ?m (tvar ?p) ] ] =>
          (cutrewrite ->
            (type_fv_permut_in_type k l m (tvar p) = tvar (p + k));
            [ | apply (type_fv_permut_in_type_tvar_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (type_fv_permut_in_type k l m (tvar p) = tvar (m + List.nth (p - m) l 0));
            [ | apply (type_fv_permut_in_type_tvar_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (type_fv_permut_in_type k l m (tvar p) = tvar p);
            [ | apply (type_fv_permut_in_type_tvar_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ H : context [ type_fv_permut_in_type ?k ?l ?m (tvar ?p) ] |- _ ] =>
          (cutrewrite ->
            (type_fv_permut_in_type k l m (tvar p) = tvar (p + k)) in H;
            [ | apply (type_fv_permut_in_type_tvar_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (type_fv_permut_in_type k l m (tvar p) = tvar (m + List.nth (p - m) l 0)) in H;
            [ | apply (type_fv_permut_in_type_tvar_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (type_fv_permut_in_type k l m (tvar p) = tvar p) in H;
            [ | apply (type_fv_permut_in_type_tvar_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ |- context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (p + k));
            [ | apply (term_fv_permut_in_term_var_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (m + List.nth (p - m) l 0));
            [ | apply (term_fv_permut_in_term_var_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var p);
            [ | apply (term_fv_permut_in_term_var_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ H : context [ term_fv_permut_in_term ?k ?l ?m (var ?p) ] |- _ ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (p + k)) in H;
            [ | apply (term_fv_permut_in_term_var_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var (m + List.nth (p - m) l 0)) in H;
            [ | apply (term_fv_permut_in_term_var_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (term_fv_permut_in_term k l m (var p) = var p) in H;
            [ | apply (term_fv_permut_in_term_var_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

    end.

  (** *** Identity free variables permutation simplification *)

  Lemma type_fv_permut_in_type_id_simpl :
    forall (_k : nat) (_arg : type) (_m _n : nat),
      type_fv_permut_in_type _k (List.seq 0 _n) _m _arg = type_lift_in_type _k (_m + _n) _arg
  .
  Proof.
    induction _arg as [ i | n | A IHA B IHB | A IHA ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        | simpl; crush_tac
        | simpl; try rewrite IHA; simpl; try rewrite IHB; crush_tac
        | simpl; try rewrite IHA; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite type_fv_permut_in_type_id_simpl : SYS_F_terms_database.

  Lemma type_fv_permut_in_term_id_simpl :
    forall (_k : nat) (_arg : term) (_m _n : nat),
      type_fv_permut_in_term _k (List.seq 0 _n) _m _arg = type_lift_in_term _k (_m + _n) _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; try rewrite type_fv_permut_in_type_id_simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; try rewrite type_fv_permut_in_type_id_simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite type_fv_permut_in_term_id_simpl : SYS_F_terms_database.

  Lemma term_fv_permut_in_term_id_simpl :
    forall (_k : nat) (_arg : term) (_m _n : nat),
      term_fv_permut_in_term _k (List.seq 0 _n) _m _arg = term_lift_in_term _k (_m + _n) _arg
  .
  Proof.
    induction _arg as [ x | t1 IHt1 t2 IHt2 | A t IHt | t IHt A | t IHt ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        | simpl; try rewrite IHt1; simpl; try rewrite IHt2; crush_tac
        | simpl; simpl; try rewrite IHt; crush_tac
        | simpl; try rewrite IHt; simpl; crush_tac
        | simpl; try rewrite IHt; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite term_fv_permut_in_term_id_simpl : SYS_F_terms_database.

  (** *** Identity free variables permutation simplification generalized *)

  Lemma type_fv_permut_in_type_id_simpl_gen :
    forall (_k : nat) (_arg : type) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> type_fv_permut_in_type _k _l _m _arg = type_lift_in_type _k (_m + List.length _l) _arg
  .
  Proof.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Lemma type_fv_permut_in_term_id_simpl_gen :
    forall (_k : nat) (_arg : term) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> type_fv_permut_in_term _k _l _m _arg = type_lift_in_term _k (_m + List.length _l) _arg
  .
  Proof.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Lemma term_fv_permut_in_term_id_simpl_gen :
    forall (_k : nat) (_arg : term) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> term_fv_permut_in_term _k _l _m _arg = term_lift_in_term _k (_m + List.length _l) _arg
  .
  Proof.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Ltac fv_permut_id_simpl_tac :=
    repeat
      match goal with
        | [ |- context [ type_fv_permut_in_type ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (type_fv_permut_in_type k l m t = type_lift_in_type k (m + List.length l) t);
            [ | (apply (type_fv_permut_in_type_id_simpl_gen k t l m 0); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 1); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 2); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 3); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 4); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ type_fv_permut_in_type ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (type_fv_permut_in_type k l m t = type_lift_in_type k (m + List.length l) t) in H;
            [ | (apply (type_fv_permut_in_type_id_simpl_gen k t l m 0); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 1); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 2); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 3); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 4); cfail) ||
                (apply (type_fv_permut_in_type_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ type_fv_permut_in_term ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (type_fv_permut_in_term k l m t = type_lift_in_term k (m + List.length l) t);
            [ | (apply (type_fv_permut_in_term_id_simpl_gen k t l m 0); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 1); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 2); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 3); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 4); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ type_fv_permut_in_term ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (type_fv_permut_in_term k l m t = type_lift_in_term k (m + List.length l) t) in H;
            [ | (apply (type_fv_permut_in_term_id_simpl_gen k t l m 0); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 1); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 2); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 3); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 4); cfail) ||
                (apply (type_fv_permut_in_term_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ term_fv_permut_in_term ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m t = term_lift_in_term k (m + List.length l) t);
            [ | (apply (term_fv_permut_in_term_id_simpl_gen k t l m 0); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 1); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 2); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 3); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 4); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ term_fv_permut_in_term ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (term_fv_permut_in_term k l m t = term_lift_in_term k (m + List.length l) t) in H;
            [ | (apply (term_fv_permut_in_term_id_simpl_gen k t l m 0); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 1); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 2); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 3); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 4); cfail) ||
                (apply (term_fv_permut_in_term_id_simpl_gen k t l m 5); cfail) ])
      end; crush_tac.

  Ltac fv_permut_tac :=
    crush_tac;
    repeat (progress (fv_permut_index_tac || fv_permut_id_simpl_tac)).




  (** * Main dbgen tactic *)

  Ltac dbgen_tac :=
    crush_tac;
    repeat (progress (index_tac || lift_tac || subst_tac || fv_permut_tac)).


End SYS_F_terms.
