(***************************************************************************
*                                                                          *
* Automatically generated file, do not modify                              *
*                                                                          *
* Emmanuel Polonowski, March 2012, Coq v8.3                                *
*                                                                          *
***************************************************************************)

Require Import Arith Omega.


(* ********************************************************************** *)
(** * Syntax definition                                                   *)

Module LOOPW.

  Create HintDb LOOPW_database.


  (** ** General Tactics *)

  Hint Rewrite Plus.plus_0_r Minus.minus_diag : LOOPW_database.

  Ltac omega_tac :=
    omega || (absurd False; auto; omega).

  Ltac fomega_tac :=
    f_equal; auto with LOOPW_database; try omega_tac.

  Ltac efomega_tac :=
    f_equal; eauto with LOOPW_database; try omega_tac.

  Ltac crush_tac :=
    autorewrite with LOOPW_database in *; auto with LOOPW_database; try omega_tac;
      try match goal with
            | [ H : False |- _ ] => inversion H
          end;
      try (repeat fomega_tac; fail).

  Ltac ecrush_tac :=
    autorewrite with LOOPW_database in *; eauto with LOOPW_database; try omega_tac;
      try match goal with
            | [ H : False |- _ ] => inversion H
          end;
      try (repeat efomega_tac; fail).

  Ltac cfail :=
    simpl; crush_tac; fail.




  (** * Inductive syntax and function definitions *)


  (** *** De Bruijn primitive syntax *)

  Inductive mutable : Type :=
  | id (x : nat)

  with mutables : Type :=
  | mnil 
  | mcons (m : mutable) (ms : mutables)
  .

  Hint Constructors mutable mutables : LOOPW_database.

  Inductive exp : Type :=
  | cvar (x : nat)
  | mvar (x : mutable)
  | int (n : nat)
  | proc (n : nat) (m : nat)   (s : seq)

  with exps : Type :=
  | enil 
  | econs (e : exp) (es : exps)

  with comm : Type :=
  | assign (x : mutable) (e : exp)
  | inc (x : mutable)
  | dec (x : mutable)
  | block (s : seq)
  | forloop (e : exp) (s : seq)
  | call (p : exp) (es : exps) (ms : mutables)

  with seq : Type :=
  | empty 
  | cst (e : exp) (s : seq)
  | var (s : seq)
  | com (c : comm) (s : seq)
  .

  Hint Constructors exp exps comm seq : LOOPW_database.


  (** *** De Bruijn lifting function *)

  Fixpoint mutable_lift_in_mutable (_n : nat) (_m : nat) (_arg : mutable) { struct _arg } : mutable :=
    match _arg with
      | id x =>
        if le_lt_dec _m x then id (x + _n) else id x
    end

  with mutable_lift_in_mutables (_n : nat) (_m : nat) (_arg : mutables) { struct _arg } : mutables :=
    match _arg with
      | mnil  =>
        mnil
      | mcons m ms =>
        mcons (mutable_lift_in_mutable _n _m m) (mutable_lift_in_mutables _n _m ms)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma mutable_lift_in_mutable_id :
    forall (_n : nat) (_m : nat) (x : nat),
      mutable_lift_in_mutable _n _m (id x) =
        if le_lt_dec _m x then id (x + _n) else id x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_mutable_id : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma mutable_lift_in_mutables_mnil :
    forall (_n : nat) (_m : nat) ,
      mutable_lift_in_mutables _n _m (mnil ) =
        mnil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_mutables_mnil : LOOPW_database.

  Lemma mutable_lift_in_mutables_mcons :
    forall (_n : nat) (_m : nat) (m : mutable) (ms : mutables),
      mutable_lift_in_mutables _n _m (mcons m ms) =
        mcons (mutable_lift_in_mutable _n _m m) (mutable_lift_in_mutables _n _m ms)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_mutables_mcons : LOOPW_database.

  Fixpoint mutable_lift_in_exp (_n : nat) (_m : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | cvar x =>
        cvar x
      | mvar x =>
        mvar (mutable_lift_in_mutable _n _m x)
      | int n =>
        int n
      | proc n m s =>
        proc n m (mutable_lift_in_seq _n (_m + m) s)
    end

  with mutable_lift_in_exps (_n : nat) (_m : nat) (_arg : exps) { struct _arg } : exps :=
    match _arg with
      | enil  =>
        enil
      | econs e es =>
        econs (mutable_lift_in_exp _n _m e) (mutable_lift_in_exps _n _m es)
    end

  with mutable_lift_in_comm (_n : nat) (_m : nat) (_arg : comm) { struct _arg } : comm :=
    match _arg with
      | assign x e =>
        assign (mutable_lift_in_mutable _n _m x) (mutable_lift_in_exp _n _m e)
      | inc x =>
        inc (mutable_lift_in_mutable _n _m x)
      | dec x =>
        dec (mutable_lift_in_mutable _n _m x)
      | block s =>
        block (mutable_lift_in_seq _n _m s)
      | forloop e s =>
        forloop (mutable_lift_in_exp _n _m e) (mutable_lift_in_seq _n _m s)
      | call p es ms =>
        call (mutable_lift_in_exp _n _m p) (mutable_lift_in_exps _n _m es) (mutable_lift_in_mutables _n _m ms)
    end

  with mutable_lift_in_seq (_n : nat) (_m : nat) (_arg : seq) { struct _arg } : seq :=
    match _arg with
      | empty  =>
        empty
      | cst e s =>
        cst (mutable_lift_in_exp _n _m e) (mutable_lift_in_seq _n _m s)
      | var s =>
        var (mutable_lift_in_seq _n (_m + 1) s)
      | com c s =>
        com (mutable_lift_in_comm _n _m c) (mutable_lift_in_seq _n _m s)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma mutable_lift_in_exp_cvar :
    forall (_n : nat) (_m : nat) (x : nat),
      mutable_lift_in_exp _n _m (cvar x) =
        cvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_exp_cvar : LOOPW_database.

  Lemma mutable_lift_in_exp_mvar :
    forall (_n : nat) (_m : nat) (x : mutable),
      mutable_lift_in_exp _n _m (mvar x) =
        mvar (mutable_lift_in_mutable _n _m x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_exp_mvar : LOOPW_database.

  Lemma mutable_lift_in_exp_int :
    forall (_n : nat) (_m : nat) (n : nat),
      mutable_lift_in_exp _n _m (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_exp_int : LOOPW_database.

  Lemma mutable_lift_in_exp_proc :
    forall (_n : nat) (_m : nat) (n : nat) (m : nat) (s : seq),
      mutable_lift_in_exp _n _m (proc n m s) =
        proc n m (mutable_lift_in_seq _n (_m + m) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_exp_proc : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma mutable_lift_in_exps_enil :
    forall (_n : nat) (_m : nat) ,
      mutable_lift_in_exps _n _m (enil ) =
        enil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_exps_enil : LOOPW_database.

  Lemma mutable_lift_in_exps_econs :
    forall (_n : nat) (_m : nat) (e : exp) (es : exps),
      mutable_lift_in_exps _n _m (econs e es) =
        econs (mutable_lift_in_exp _n _m e) (mutable_lift_in_exps _n _m es)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_exps_econs : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma mutable_lift_in_comm_assign :
    forall (_n : nat) (_m : nat) (x : mutable) (e : exp),
      mutable_lift_in_comm _n _m (assign x e) =
        assign (mutable_lift_in_mutable _n _m x) (mutable_lift_in_exp _n _m e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_comm_assign : LOOPW_database.

  Lemma mutable_lift_in_comm_inc :
    forall (_n : nat) (_m : nat) (x : mutable),
      mutable_lift_in_comm _n _m (inc x) =
        inc (mutable_lift_in_mutable _n _m x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_comm_inc : LOOPW_database.

  Lemma mutable_lift_in_comm_dec :
    forall (_n : nat) (_m : nat) (x : mutable),
      mutable_lift_in_comm _n _m (dec x) =
        dec (mutable_lift_in_mutable _n _m x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_comm_dec : LOOPW_database.

  Lemma mutable_lift_in_comm_block :
    forall (_n : nat) (_m : nat) (s : seq),
      mutable_lift_in_comm _n _m (block s) =
        block (mutable_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_comm_block : LOOPW_database.

  Lemma mutable_lift_in_comm_forloop :
    forall (_n : nat) (_m : nat) (e : exp) (s : seq),
      mutable_lift_in_comm _n _m (forloop e s) =
        forloop (mutable_lift_in_exp _n _m e) (mutable_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_comm_forloop : LOOPW_database.

  Lemma mutable_lift_in_comm_call :
    forall (_n : nat) (_m : nat) (p : exp) (es : exps) (ms : mutables),
      mutable_lift_in_comm _n _m (call p es ms) =
        call (mutable_lift_in_exp _n _m p) (mutable_lift_in_exps _n _m es) (mutable_lift_in_mutables _n _m ms)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_comm_call : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma mutable_lift_in_seq_empty :
    forall (_n : nat) (_m : nat) ,
      mutable_lift_in_seq _n _m (empty ) =
        empty
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_seq_empty : LOOPW_database.

  Lemma mutable_lift_in_seq_cst :
    forall (_n : nat) (_m : nat) (e : exp) (s : seq),
      mutable_lift_in_seq _n _m (cst e s) =
        cst (mutable_lift_in_exp _n _m e) (mutable_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_seq_cst : LOOPW_database.

  Lemma mutable_lift_in_seq_var :
    forall (_n : nat) (_m : nat) (s : seq),
      mutable_lift_in_seq _n _m (var s) =
        var (mutable_lift_in_seq _n (_m + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_seq_var : LOOPW_database.

  Lemma mutable_lift_in_seq_com :
    forall (_n : nat) (_m : nat) (c : comm) (s : seq),
      mutable_lift_in_seq _n _m (com c s) =
        com (mutable_lift_in_comm _n _m c) (mutable_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_lift_in_seq_com : LOOPW_database.

  (** *** De Bruijn lifting function *)

  Fixpoint exp_lift_in_exp (_n : nat) (_m : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | cvar x =>
        if le_lt_dec _m x then cvar (x + _n) else cvar x
      | mvar x =>
        mvar x
      | int n =>
        int n
      | proc n m s =>
        proc n m (exp_lift_in_seq _n (_m + n) s)
    end

  with exp_lift_in_exps (_n : nat) (_m : nat) (_arg : exps) { struct _arg } : exps :=
    match _arg with
      | enil  =>
        enil
      | econs e es =>
        econs (exp_lift_in_exp _n _m e) (exp_lift_in_exps _n _m es)
    end

  with exp_lift_in_comm (_n : nat) (_m : nat) (_arg : comm) { struct _arg } : comm :=
    match _arg with
      | assign x e =>
        assign x (exp_lift_in_exp _n _m e)
      | inc x =>
        inc x
      | dec x =>
        dec x
      | block s =>
        block (exp_lift_in_seq _n _m s)
      | forloop e s =>
        forloop (exp_lift_in_exp _n _m e) (exp_lift_in_seq _n (_m + 1) s)
      | call p es ms =>
        call (exp_lift_in_exp _n _m p) (exp_lift_in_exps _n _m es) ms
    end

  with exp_lift_in_seq (_n : nat) (_m : nat) (_arg : seq) { struct _arg } : seq :=
    match _arg with
      | empty  =>
        empty
      | cst e s =>
        cst (exp_lift_in_exp _n _m e) (exp_lift_in_seq _n (_m + 1) s)
      | var s =>
        var (exp_lift_in_seq _n _m s)
      | com c s =>
        com (exp_lift_in_comm _n _m c) (exp_lift_in_seq _n _m s)
    end
  .

  (** Equations for De Bruijn lifting function *)

  Lemma exp_lift_in_exp_cvar :
    forall (_n : nat) (_m : nat) (x : nat),
      exp_lift_in_exp _n _m (cvar x) =
        if le_lt_dec _m x then cvar (x + _n) else cvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_exp_cvar : LOOPW_database.

  Lemma exp_lift_in_exp_mvar :
    forall (_n : nat) (_m : nat) (x : mutable),
      exp_lift_in_exp _n _m (mvar x) =
        mvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_exp_mvar : LOOPW_database.

  Lemma exp_lift_in_exp_int :
    forall (_n : nat) (_m : nat) (n : nat),
      exp_lift_in_exp _n _m (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_exp_int : LOOPW_database.

  Lemma exp_lift_in_exp_proc :
    forall (_n : nat) (_m : nat) (n : nat) (m : nat) (s : seq),
      exp_lift_in_exp _n _m (proc n m s) =
        proc n m (exp_lift_in_seq _n (_m + n) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_exp_proc : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma exp_lift_in_exps_enil :
    forall (_n : nat) (_m : nat) ,
      exp_lift_in_exps _n _m (enil ) =
        enil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_exps_enil : LOOPW_database.

  Lemma exp_lift_in_exps_econs :
    forall (_n : nat) (_m : nat) (e : exp) (es : exps),
      exp_lift_in_exps _n _m (econs e es) =
        econs (exp_lift_in_exp _n _m e) (exp_lift_in_exps _n _m es)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_exps_econs : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma exp_lift_in_comm_assign :
    forall (_n : nat) (_m : nat) (x : mutable) (e : exp),
      exp_lift_in_comm _n _m (assign x e) =
        assign x (exp_lift_in_exp _n _m e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_comm_assign : LOOPW_database.

  Lemma exp_lift_in_comm_inc :
    forall (_n : nat) (_m : nat) (x : mutable),
      exp_lift_in_comm _n _m (inc x) =
        inc x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_comm_inc : LOOPW_database.

  Lemma exp_lift_in_comm_dec :
    forall (_n : nat) (_m : nat) (x : mutable),
      exp_lift_in_comm _n _m (dec x) =
        dec x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_comm_dec : LOOPW_database.

  Lemma exp_lift_in_comm_block :
    forall (_n : nat) (_m : nat) (s : seq),
      exp_lift_in_comm _n _m (block s) =
        block (exp_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_comm_block : LOOPW_database.

  Lemma exp_lift_in_comm_forloop :
    forall (_n : nat) (_m : nat) (e : exp) (s : seq),
      exp_lift_in_comm _n _m (forloop e s) =
        forloop (exp_lift_in_exp _n _m e) (exp_lift_in_seq _n (_m + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_comm_forloop : LOOPW_database.

  Lemma exp_lift_in_comm_call :
    forall (_n : nat) (_m : nat) (p : exp) (es : exps) (ms : mutables),
      exp_lift_in_comm _n _m (call p es ms) =
        call (exp_lift_in_exp _n _m p) (exp_lift_in_exps _n _m es) ms
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_comm_call : LOOPW_database.

  (** Equations for De Bruijn lifting function *)

  Lemma exp_lift_in_seq_empty :
    forall (_n : nat) (_m : nat) ,
      exp_lift_in_seq _n _m (empty ) =
        empty
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_seq_empty : LOOPW_database.

  Lemma exp_lift_in_seq_cst :
    forall (_n : nat) (_m : nat) (e : exp) (s : seq),
      exp_lift_in_seq _n _m (cst e s) =
        cst (exp_lift_in_exp _n _m e) (exp_lift_in_seq _n (_m + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_seq_cst : LOOPW_database.

  Lemma exp_lift_in_seq_var :
    forall (_n : nat) (_m : nat) (s : seq),
      exp_lift_in_seq _n _m (var s) =
        var (exp_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_seq_var : LOOPW_database.

  Lemma exp_lift_in_seq_com :
    forall (_n : nat) (_m : nat) (c : comm) (s : seq),
      exp_lift_in_seq _n _m (com c s) =
        com (exp_lift_in_comm _n _m c) (exp_lift_in_seq _n _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_lift_in_seq_com : LOOPW_database.


  (** *** De Bruijn substitution function *)

  Fixpoint mutable_subst_in_mutable (_a : mutable) (_n : nat) (_arg : mutable) { struct _arg } : mutable :=
    match _arg with
      | id x =>
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => id (x - 1)
            (* case _n = x *)
          | inleft (right _) => _a
            (* case x < _n *)
          | inright _ => id x
        end
    end

  with mutable_subst_in_mutables (_a : mutable) (_n : nat) (_arg : mutables) { struct _arg } : mutables :=
    match _arg with
      | mnil  =>
        mnil
      | mcons m ms =>
        mcons (mutable_subst_in_mutable _a _n m) (mutable_subst_in_mutables _a _n ms)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma mutable_subst_in_mutable_id :
    forall (_a : mutable) (_n : nat) (x : nat),
      mutable_subst_in_mutable _a _n (id x) =
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => id (x - 1)
            (* case _n = x *)
          | inleft (right _) => _a
            (* case x < _n *)
          | inright _ => id x
        end
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_mutable_id : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma mutable_subst_in_mutables_mnil :
    forall (_a : mutable) (_n : nat) ,
      mutable_subst_in_mutables _a _n (mnil ) =
        mnil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_mutables_mnil : LOOPW_database.

  Lemma mutable_subst_in_mutables_mcons :
    forall (_a : mutable) (_n : nat) (m : mutable) (ms : mutables),
      mutable_subst_in_mutables _a _n (mcons m ms) =
        mcons (mutable_subst_in_mutable _a _n m) (mutable_subst_in_mutables _a _n ms)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_mutables_mcons : LOOPW_database.

  Fixpoint mutable_subst_in_exp (_a : mutable) (_n : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | cvar x =>
        cvar x
      | mvar x =>
        mvar (mutable_subst_in_mutable _a _n x)
      | int n =>
        int n
      | proc n m s =>
        proc n m (mutable_subst_in_seq (mutable_lift_in_mutable m 0 _a) (_n + m) s)
    end

  with mutable_subst_in_exps (_a : mutable) (_n : nat) (_arg : exps) { struct _arg } : exps :=
    match _arg with
      | enil  =>
        enil
      | econs e es =>
        econs (mutable_subst_in_exp _a _n e) (mutable_subst_in_exps _a _n es)
    end

  with mutable_subst_in_comm (_a : mutable) (_n : nat) (_arg : comm) { struct _arg } : comm :=
    match _arg with
      | assign x e =>
        assign (mutable_subst_in_mutable _a _n x) (mutable_subst_in_exp _a _n e)
      | inc x =>
        inc (mutable_subst_in_mutable _a _n x)
      | dec x =>
        dec (mutable_subst_in_mutable _a _n x)
      | block s =>
        block (mutable_subst_in_seq _a _n s)
      | forloop e s =>
        forloop (mutable_subst_in_exp _a _n e) (mutable_subst_in_seq _a _n s)
      | call p es ms =>
        call (mutable_subst_in_exp _a _n p) (mutable_subst_in_exps _a _n es) (mutable_subst_in_mutables _a _n ms)
    end

  with mutable_subst_in_seq (_a : mutable) (_n : nat) (_arg : seq) { struct _arg } : seq :=
    match _arg with
      | empty  =>
        empty
      | cst e s =>
        cst (mutable_subst_in_exp _a _n e) (mutable_subst_in_seq _a _n s)
      | var s =>
        var (mutable_subst_in_seq (mutable_lift_in_mutable 1 0 _a) (_n + 1) s)
      | com c s =>
        com (mutable_subst_in_comm _a _n c) (mutable_subst_in_seq _a _n s)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma mutable_subst_in_exp_cvar :
    forall (_a : mutable) (_n : nat) (x : nat),
      mutable_subst_in_exp _a _n (cvar x) =
        cvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_exp_cvar : LOOPW_database.

  Lemma mutable_subst_in_exp_mvar :
    forall (_a : mutable) (_n : nat) (x : mutable),
      mutable_subst_in_exp _a _n (mvar x) =
        mvar (mutable_subst_in_mutable _a _n x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_exp_mvar : LOOPW_database.

  Lemma mutable_subst_in_exp_int :
    forall (_a : mutable) (_n : nat) (n : nat),
      mutable_subst_in_exp _a _n (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_exp_int : LOOPW_database.

  Lemma mutable_subst_in_exp_proc :
    forall (_a : mutable) (_n : nat) (n : nat) (m : nat) (s : seq),
      mutable_subst_in_exp _a _n (proc n m s) =
        proc n m (mutable_subst_in_seq (mutable_lift_in_mutable m 0 _a) (_n + m) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_exp_proc : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma mutable_subst_in_exps_enil :
    forall (_a : mutable) (_n : nat) ,
      mutable_subst_in_exps _a _n (enil ) =
        enil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_exps_enil : LOOPW_database.

  Lemma mutable_subst_in_exps_econs :
    forall (_a : mutable) (_n : nat) (e : exp) (es : exps),
      mutable_subst_in_exps _a _n (econs e es) =
        econs (mutable_subst_in_exp _a _n e) (mutable_subst_in_exps _a _n es)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_exps_econs : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma mutable_subst_in_comm_assign :
    forall (_a : mutable) (_n : nat) (x : mutable) (e : exp),
      mutable_subst_in_comm _a _n (assign x e) =
        assign (mutable_subst_in_mutable _a _n x) (mutable_subst_in_exp _a _n e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_comm_assign : LOOPW_database.

  Lemma mutable_subst_in_comm_inc :
    forall (_a : mutable) (_n : nat) (x : mutable),
      mutable_subst_in_comm _a _n (inc x) =
        inc (mutable_subst_in_mutable _a _n x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_comm_inc : LOOPW_database.

  Lemma mutable_subst_in_comm_dec :
    forall (_a : mutable) (_n : nat) (x : mutable),
      mutable_subst_in_comm _a _n (dec x) =
        dec (mutable_subst_in_mutable _a _n x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_comm_dec : LOOPW_database.

  Lemma mutable_subst_in_comm_block :
    forall (_a : mutable) (_n : nat) (s : seq),
      mutable_subst_in_comm _a _n (block s) =
        block (mutable_subst_in_seq _a _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_comm_block : LOOPW_database.

  Lemma mutable_subst_in_comm_forloop :
    forall (_a : mutable) (_n : nat) (e : exp) (s : seq),
      mutable_subst_in_comm _a _n (forloop e s) =
        forloop (mutable_subst_in_exp _a _n e) (mutable_subst_in_seq _a _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_comm_forloop : LOOPW_database.

  Lemma mutable_subst_in_comm_call :
    forall (_a : mutable) (_n : nat) (p : exp) (es : exps) (ms : mutables),
      mutable_subst_in_comm _a _n (call p es ms) =
        call (mutable_subst_in_exp _a _n p) (mutable_subst_in_exps _a _n es) (mutable_subst_in_mutables _a _n ms)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_comm_call : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma mutable_subst_in_seq_empty :
    forall (_a : mutable) (_n : nat) ,
      mutable_subst_in_seq _a _n (empty ) =
        empty
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_seq_empty : LOOPW_database.

  Lemma mutable_subst_in_seq_cst :
    forall (_a : mutable) (_n : nat) (e : exp) (s : seq),
      mutable_subst_in_seq _a _n (cst e s) =
        cst (mutable_subst_in_exp _a _n e) (mutable_subst_in_seq _a _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_seq_cst : LOOPW_database.

  Lemma mutable_subst_in_seq_var :
    forall (_a : mutable) (_n : nat) (s : seq),
      mutable_subst_in_seq _a _n (var s) =
        var (mutable_subst_in_seq (mutable_lift_in_mutable 1 0 _a) (_n + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_seq_var : LOOPW_database.

  Lemma mutable_subst_in_seq_com :
    forall (_a : mutable) (_n : nat) (c : comm) (s : seq),
      mutable_subst_in_seq _a _n (com c s) =
        com (mutable_subst_in_comm _a _n c) (mutable_subst_in_seq _a _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_subst_in_seq_com : LOOPW_database.

  (** *** De Bruijn substitution function *)

  Fixpoint exp_subst_in_exp (_a : exp) (_n : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | cvar x =>
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => cvar (x - 1)
            (* case _n = x *)
          | inleft (right _) => _a
            (* case x < _n *)
          | inright _ => cvar x
        end
      | mvar x =>
        mvar x
      | int n =>
        int n
      | proc n m s =>
        proc n m (exp_subst_in_seq (exp_lift_in_exp n 0 (mutable_lift_in_exp m 0 _a)) (_n + n) s)
    end

  with exp_subst_in_exps (_a : exp) (_n : nat) (_arg : exps) { struct _arg } : exps :=
    match _arg with
      | enil  =>
        enil
      | econs e es =>
        econs (exp_subst_in_exp _a _n e) (exp_subst_in_exps _a _n es)
    end

  with exp_subst_in_comm (_a : exp) (_n : nat) (_arg : comm) { struct _arg } : comm :=
    match _arg with
      | assign x e =>
        assign x (exp_subst_in_exp _a _n e)
      | inc x =>
        inc x
      | dec x =>
        dec x
      | block s =>
        block (exp_subst_in_seq _a _n s)
      | forloop e s =>
        forloop (exp_subst_in_exp _a _n e) (exp_subst_in_seq (exp_lift_in_exp 1 0 _a) (_n + 1) s)
      | call p es ms =>
        call (exp_subst_in_exp _a _n p) (exp_subst_in_exps _a _n es) ms
    end

  with exp_subst_in_seq (_a : exp) (_n : nat) (_arg : seq) { struct _arg } : seq :=
    match _arg with
      | empty  =>
        empty
      | cst e s =>
        cst (exp_subst_in_exp _a _n e) (exp_subst_in_seq (exp_lift_in_exp 1 0 _a) (_n + 1) s)
      | var s =>
        var (exp_subst_in_seq (mutable_lift_in_exp 1 0 _a) _n s)
      | com c s =>
        com (exp_subst_in_comm _a _n c) (exp_subst_in_seq _a _n s)
    end
  .

  (** Equations for De Bruijn substitution function *)

  Lemma exp_subst_in_exp_cvar :
    forall (_a : exp) (_n : nat) (x : nat),
      exp_subst_in_exp _a _n (cvar x) =
        match lt_eq_lt_dec _n x with
            (* case _n < x *)
          | inleft (left _) => cvar (x - 1)
            (* case _n = x *)
          | inleft (right _) => _a
            (* case x < _n *)
          | inright _ => cvar x
        end
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_exp_cvar : LOOPW_database.

  Lemma exp_subst_in_exp_mvar :
    forall (_a : exp) (_n : nat) (x : mutable),
      exp_subst_in_exp _a _n (mvar x) =
        mvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_exp_mvar : LOOPW_database.

  Lemma exp_subst_in_exp_int :
    forall (_a : exp) (_n : nat) (n : nat),
      exp_subst_in_exp _a _n (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_exp_int : LOOPW_database.

  Lemma exp_subst_in_exp_proc :
    forall (_a : exp) (_n : nat) (n : nat) (m : nat) (s : seq),
      exp_subst_in_exp _a _n (proc n m s) =
        proc n m (exp_subst_in_seq (exp_lift_in_exp n 0 (mutable_lift_in_exp m 0 _a)) (_n + n) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_exp_proc : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma exp_subst_in_exps_enil :
    forall (_a : exp) (_n : nat) ,
      exp_subst_in_exps _a _n (enil ) =
        enil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_exps_enil : LOOPW_database.

  Lemma exp_subst_in_exps_econs :
    forall (_a : exp) (_n : nat) (e : exp) (es : exps),
      exp_subst_in_exps _a _n (econs e es) =
        econs (exp_subst_in_exp _a _n e) (exp_subst_in_exps _a _n es)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_exps_econs : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma exp_subst_in_comm_assign :
    forall (_a : exp) (_n : nat) (x : mutable) (e : exp),
      exp_subst_in_comm _a _n (assign x e) =
        assign x (exp_subst_in_exp _a _n e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_comm_assign : LOOPW_database.

  Lemma exp_subst_in_comm_inc :
    forall (_a : exp) (_n : nat) (x : mutable),
      exp_subst_in_comm _a _n (inc x) =
        inc x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_comm_inc : LOOPW_database.

  Lemma exp_subst_in_comm_dec :
    forall (_a : exp) (_n : nat) (x : mutable),
      exp_subst_in_comm _a _n (dec x) =
        dec x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_comm_dec : LOOPW_database.

  Lemma exp_subst_in_comm_block :
    forall (_a : exp) (_n : nat) (s : seq),
      exp_subst_in_comm _a _n (block s) =
        block (exp_subst_in_seq _a _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_comm_block : LOOPW_database.

  Lemma exp_subst_in_comm_forloop :
    forall (_a : exp) (_n : nat) (e : exp) (s : seq),
      exp_subst_in_comm _a _n (forloop e s) =
        forloop (exp_subst_in_exp _a _n e) (exp_subst_in_seq (exp_lift_in_exp 1 0 _a) (_n + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_comm_forloop : LOOPW_database.

  Lemma exp_subst_in_comm_call :
    forall (_a : exp) (_n : nat) (p : exp) (es : exps) (ms : mutables),
      exp_subst_in_comm _a _n (call p es ms) =
        call (exp_subst_in_exp _a _n p) (exp_subst_in_exps _a _n es) ms
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_comm_call : LOOPW_database.

  (** Equations for De Bruijn substitution function *)

  Lemma exp_subst_in_seq_empty :
    forall (_a : exp) (_n : nat) ,
      exp_subst_in_seq _a _n (empty ) =
        empty
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_seq_empty : LOOPW_database.

  Lemma exp_subst_in_seq_cst :
    forall (_a : exp) (_n : nat) (e : exp) (s : seq),
      exp_subst_in_seq _a _n (cst e s) =
        cst (exp_subst_in_exp _a _n e) (exp_subst_in_seq (exp_lift_in_exp 1 0 _a) (_n + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_seq_cst : LOOPW_database.

  Lemma exp_subst_in_seq_var :
    forall (_a : exp) (_n : nat) (s : seq),
      exp_subst_in_seq _a _n (var s) =
        var (exp_subst_in_seq (mutable_lift_in_exp 1 0 _a) _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_seq_var : LOOPW_database.

  Lemma exp_subst_in_seq_com :
    forall (_a : exp) (_n : nat) (c : comm) (s : seq),
      exp_subst_in_seq _a _n (com c s) =
        com (exp_subst_in_comm _a _n c) (exp_subst_in_seq _a _n s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_subst_in_seq_com : LOOPW_database.

  Module SizedList.
    Set Implicit Arguments.

    Section Definitions.
      Variable A : Type.

      Inductive sized_list : nat -> Type :=
      | snil : sized_list 0
      | scons : A -> forall n : nat, sized_list n -> sized_list (S n).
      
      Implicit Arguments scons [n].
    
      Fixpoint app (n1 : nat) (l1 : sized_list n1) (n2 : nat) (l2 : sized_list n2) : sized_list (n1 + n2) :=
        match l1 in sized_list n1 return sized_list (n1 + n2) with
          | snil => l2
          | scons x _ l1' => scons x (app l1' l2)
        end.
      
      Variable eq : forall x y : A, { x = y } + { x <> y }.
      
      Fixpoint index_of (x : A) (n : nat) (l : sized_list n) : nat :=
        match l with
          | snil => 0
          | scons y _ l' => if eq x y then 0 else S (index_of x l')
        end.
      
      Fixpoint build_permut (n : nat) (l : sized_list n) (n' : nat) (l' : sized_list n') : list nat :=
        match l' with
          | snil => nil
          | scons x _ l'' => cons (index_of x l) (build_permut l l'')
        end.
    
    End Definitions.
  End SizedList.

  Require Import String.
  Local Open Scope string_scope.

  Definition _name_list := SizedList.sized_list string.
  Definition _xcons := @SizedList.scons string.
  Definition _xnil := @SizedList.snil string.
  Definition _index_of := SizedList.index_of string_dec.
  Definition _concat := @SizedList.app string.
  Definition _build_permut := SizedList.build_permut string_dec.


  (** *** Named syntax *)

  Inductive _mutable : Type :=
  | _id (x : string)
  | _db_mutable (_xn_mutable : nat) (_xl_mutable : _name_list _xn_mutable) (_arg : mutable)

  with _mutables : Type :=
  | _mnil 
  | _mcons (m : _mutable) (ms : _mutables)
  | _db_mutables (_xn_mutable : nat) (_xl_mutable : _name_list _xn_mutable) (_arg : mutables)
  .

  Hint Constructors _mutable _mutables : LOOPW_database.

  Inductive _exp : Type :=
  | _cvar (x : string)
  | _mvar (x : _mutable)
  | _int (n : nat)
  | _proc (n : nat) (m : nat) (xl1 : _name_list n) (xl : _name_list m) (s : _seq)
  | _db_exp (_xn_mutable : nat) (_xl_mutable : _name_list _xn_mutable) (_xn_exp : nat) (_xl_exp : _name_list _xn_exp) (_arg : exp)

  with _exps : Type :=
  | _enil 
  | _econs (e : _exp) (es : _exps)
  | _db_exps (_xn_mutable : nat) (_xl_mutable : _name_list _xn_mutable) (_xn_exp : nat) (_xl_exp : _name_list _xn_exp) (_arg : exps)

  with _comm : Type :=
  | _assign (x : _mutable) (e : _exp)
  | _inc (x : _mutable)
  | _dec (x : _mutable)
  | _block (s : _seq)
  | _forloop (e : _exp) (xl1 : _name_list 1) (s : _seq)
  | _call (p : _exp) (es : _exps) (ms : _mutables)
  | _db_comm (_xn_mutable : nat) (_xl_mutable : _name_list _xn_mutable) (_xn_exp : nat) (_xl_exp : _name_list _xn_exp) (_arg : comm)

  with _seq : Type :=
  | _empty 
  | _cst (e : _exp) (xl1 : _name_list 1) (s : _seq)
  | _var (xl : _name_list 1) (s : _seq)
  | _com (c : _comm) (s : _seq)
  | _db_seq (_xn_mutable : nat) (_xl_mutable : _name_list _xn_mutable) (_xn_exp : nat) (_xl_exp : _name_list _xn_exp) (_arg : seq)
  .

  Hint Constructors _exp _exps _comm _seq : LOOPW_database.



  (** *** Free variable index permutations *)

  Fixpoint mutable_fv_permut_in_mutable (_k : nat) (_l_mutable : list nat) (_m : nat) (_arg : mutable) { struct _arg } : mutable :=
    match _arg with
      | id x =>
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_mutable) (x - _m)
          then id (x + _k)
          else id (_m + List.nth (x - _m) _l_mutable 0)
        else id x
    end

  with mutable_fv_permut_in_mutables (_k : nat) (_l_mutables : list nat) (_m : nat) (_arg : mutables) { struct _arg } : mutables :=
    match _arg with
      | mnil  =>
        mnil
      | mcons m ms =>
        mcons (mutable_fv_permut_in_mutable _k _l_mutables _m m) (mutable_fv_permut_in_mutables _k _l_mutables _m ms)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma mutable_fv_permut_in_mutable_id :
    forall (_k : nat) (_l_mutable : list nat) (_m : nat) (x : nat),
      mutable_fv_permut_in_mutable _k _l_mutable _m (id x) =
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_mutable) (x - _m)
          then id (x + _k)
          else id (_m + List.nth (x - _m) _l_mutable 0)
        else id x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_mutable_id : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma mutable_fv_permut_in_mutables_mnil :
    forall (_k : nat) (_l_mutables : list nat) (_m : nat) ,
      mutable_fv_permut_in_mutables _k _l_mutables _m (mnil ) =
        mnil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_mutables_mnil : LOOPW_database.

  Lemma mutable_fv_permut_in_mutables_mcons :
    forall (_k : nat) (_l_mutables : list nat) (_m : nat) (m : mutable) (ms : mutables),
      mutable_fv_permut_in_mutables _k _l_mutables _m (mcons m ms) =
        mcons (mutable_fv_permut_in_mutable _k _l_mutables _m m) (mutable_fv_permut_in_mutables _k _l_mutables _m ms)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_mutables_mcons : LOOPW_database.

  Fixpoint mutable_fv_permut_in_exp (_k : nat) (_l_exp : list nat) (_m : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | cvar x =>
        cvar x
      | mvar x =>
        mvar (mutable_fv_permut_in_mutable _k _l_exp _m x)
      | int n =>
        int n
      | proc n m s =>
        proc n m (mutable_fv_permut_in_seq _k _l_exp (_m + m) s)
    end

  with mutable_fv_permut_in_exps (_k : nat) (_l_exps : list nat) (_m : nat) (_arg : exps) { struct _arg } : exps :=
    match _arg with
      | enil  =>
        enil
      | econs e es =>
        econs (mutable_fv_permut_in_exp _k _l_exps _m e) (mutable_fv_permut_in_exps _k _l_exps _m es)
    end

  with mutable_fv_permut_in_comm (_k : nat) (_l_comm : list nat) (_m : nat) (_arg : comm) { struct _arg } : comm :=
    match _arg with
      | assign x e =>
        assign (mutable_fv_permut_in_mutable _k _l_comm _m x) (mutable_fv_permut_in_exp _k _l_comm _m e)
      | inc x =>
        inc (mutable_fv_permut_in_mutable _k _l_comm _m x)
      | dec x =>
        dec (mutable_fv_permut_in_mutable _k _l_comm _m x)
      | block s =>
        block (mutable_fv_permut_in_seq _k _l_comm _m s)
      | forloop e s =>
        forloop (mutable_fv_permut_in_exp _k _l_comm _m e) (mutable_fv_permut_in_seq _k _l_comm _m s)
      | call p es ms =>
        call (mutable_fv_permut_in_exp _k _l_comm _m p) (mutable_fv_permut_in_exps _k _l_comm _m es) (mutable_fv_permut_in_mutables _k _l_comm _m ms)
    end

  with mutable_fv_permut_in_seq (_k : nat) (_l_seq : list nat) (_m : nat) (_arg : seq) { struct _arg } : seq :=
    match _arg with
      | empty  =>
        empty
      | cst e s =>
        cst (mutable_fv_permut_in_exp _k _l_seq _m e) (mutable_fv_permut_in_seq _k _l_seq _m s)
      | var s =>
        var (mutable_fv_permut_in_seq _k _l_seq (_m + 1) s)
      | com c s =>
        com (mutable_fv_permut_in_comm _k _l_seq _m c) (mutable_fv_permut_in_seq _k _l_seq _m s)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma mutable_fv_permut_in_exp_cvar :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (x : nat),
      mutable_fv_permut_in_exp _k _l_exp _m (cvar x) =
        cvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exp_cvar : LOOPW_database.

  Lemma mutable_fv_permut_in_exp_mvar :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (x : mutable),
      mutable_fv_permut_in_exp _k _l_exp _m (mvar x) =
        mvar (mutable_fv_permut_in_mutable _k _l_exp _m x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exp_mvar : LOOPW_database.

  Lemma mutable_fv_permut_in_exp_int :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (n : nat),
      mutable_fv_permut_in_exp _k _l_exp _m (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exp_int : LOOPW_database.

  Lemma mutable_fv_permut_in_exp_proc :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (n : nat) (m : nat) (s : seq),
      mutable_fv_permut_in_exp _k _l_exp _m (proc n m s) =
        proc n m (mutable_fv_permut_in_seq _k _l_exp (_m + m) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exp_proc : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma mutable_fv_permut_in_exps_enil :
    forall (_k : nat) (_l_exps : list nat) (_m : nat) ,
      mutable_fv_permut_in_exps _k _l_exps _m (enil ) =
        enil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exps_enil : LOOPW_database.

  Lemma mutable_fv_permut_in_exps_econs :
    forall (_k : nat) (_l_exps : list nat) (_m : nat) (e : exp) (es : exps),
      mutable_fv_permut_in_exps _k _l_exps _m (econs e es) =
        econs (mutable_fv_permut_in_exp _k _l_exps _m e) (mutable_fv_permut_in_exps _k _l_exps _m es)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exps_econs : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma mutable_fv_permut_in_comm_assign :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (x : mutable) (e : exp),
      mutable_fv_permut_in_comm _k _l_comm _m (assign x e) =
        assign (mutable_fv_permut_in_mutable _k _l_comm _m x) (mutable_fv_permut_in_exp _k _l_comm _m e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_comm_assign : LOOPW_database.

  Lemma mutable_fv_permut_in_comm_inc :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (x : mutable),
      mutable_fv_permut_in_comm _k _l_comm _m (inc x) =
        inc (mutable_fv_permut_in_mutable _k _l_comm _m x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_comm_inc : LOOPW_database.

  Lemma mutable_fv_permut_in_comm_dec :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (x : mutable),
      mutable_fv_permut_in_comm _k _l_comm _m (dec x) =
        dec (mutable_fv_permut_in_mutable _k _l_comm _m x)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_comm_dec : LOOPW_database.

  Lemma mutable_fv_permut_in_comm_block :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (s : seq),
      mutable_fv_permut_in_comm _k _l_comm _m (block s) =
        block (mutable_fv_permut_in_seq _k _l_comm _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_comm_block : LOOPW_database.

  Lemma mutable_fv_permut_in_comm_forloop :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (e : exp) (s : seq),
      mutable_fv_permut_in_comm _k _l_comm _m (forloop e s) =
        forloop (mutable_fv_permut_in_exp _k _l_comm _m e) (mutable_fv_permut_in_seq _k _l_comm _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_comm_forloop : LOOPW_database.

  Lemma mutable_fv_permut_in_comm_call :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (p : exp) (es : exps) (ms : mutables),
      mutable_fv_permut_in_comm _k _l_comm _m (call p es ms) =
        call (mutable_fv_permut_in_exp _k _l_comm _m p) (mutable_fv_permut_in_exps _k _l_comm _m es) (mutable_fv_permut_in_mutables _k _l_comm _m ms)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_comm_call : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma mutable_fv_permut_in_seq_empty :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) ,
      mutable_fv_permut_in_seq _k _l_seq _m (empty ) =
        empty
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_seq_empty : LOOPW_database.

  Lemma mutable_fv_permut_in_seq_cst :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) (e : exp) (s : seq),
      mutable_fv_permut_in_seq _k _l_seq _m (cst e s) =
        cst (mutable_fv_permut_in_exp _k _l_seq _m e) (mutable_fv_permut_in_seq _k _l_seq _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_seq_cst : LOOPW_database.

  Lemma mutable_fv_permut_in_seq_var :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) (s : seq),
      mutable_fv_permut_in_seq _k _l_seq _m (var s) =
        var (mutable_fv_permut_in_seq _k _l_seq (_m + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_seq_var : LOOPW_database.

  Lemma mutable_fv_permut_in_seq_com :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) (c : comm) (s : seq),
      mutable_fv_permut_in_seq _k _l_seq _m (com c s) =
        com (mutable_fv_permut_in_comm _k _l_seq _m c) (mutable_fv_permut_in_seq _k _l_seq _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite mutable_fv_permut_in_seq_com : LOOPW_database.

  (** *** Free variable index permutations *)

  Fixpoint exp_fv_permut_in_exp (_k : nat) (_l_exp : list nat) (_m : nat) (_arg : exp) { struct _arg } : exp :=
    match _arg with
      | cvar x =>
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_exp) (x - _m)
          then cvar (x + _k)
          else cvar (_m + List.nth (x - _m) _l_exp 0)
        else cvar x
      | mvar x =>
        mvar x
      | int n =>
        int n
      | proc n m s =>
        proc n m (exp_fv_permut_in_seq _k _l_exp (_m + n) s)
    end

  with exp_fv_permut_in_exps (_k : nat) (_l_exps : list nat) (_m : nat) (_arg : exps) { struct _arg } : exps :=
    match _arg with
      | enil  =>
        enil
      | econs e es =>
        econs (exp_fv_permut_in_exp _k _l_exps _m e) (exp_fv_permut_in_exps _k _l_exps _m es)
    end

  with exp_fv_permut_in_comm (_k : nat) (_l_comm : list nat) (_m : nat) (_arg : comm) { struct _arg } : comm :=
    match _arg with
      | assign x e =>
        assign x (exp_fv_permut_in_exp _k _l_comm _m e)
      | inc x =>
        inc x
      | dec x =>
        dec x
      | block s =>
        block (exp_fv_permut_in_seq _k _l_comm _m s)
      | forloop e s =>
        forloop (exp_fv_permut_in_exp _k _l_comm _m e) (exp_fv_permut_in_seq _k _l_comm (_m + 1) s)
      | call p es ms =>
        call (exp_fv_permut_in_exp _k _l_comm _m p) (exp_fv_permut_in_exps _k _l_comm _m es) ms
    end

  with exp_fv_permut_in_seq (_k : nat) (_l_seq : list nat) (_m : nat) (_arg : seq) { struct _arg } : seq :=
    match _arg with
      | empty  =>
        empty
      | cst e s =>
        cst (exp_fv_permut_in_exp _k _l_seq _m e) (exp_fv_permut_in_seq _k _l_seq (_m + 1) s)
      | var s =>
        var (exp_fv_permut_in_seq _k _l_seq _m s)
      | com c s =>
        com (exp_fv_permut_in_comm _k _l_seq _m c) (exp_fv_permut_in_seq _k _l_seq _m s)
    end
  .

  (** Equations for Free variable index permutations *)

  Lemma exp_fv_permut_in_exp_cvar :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (x : nat),
      exp_fv_permut_in_exp _k _l_exp _m (cvar x) =
        if le_lt_dec _m x
        then
          if le_lt_dec (List.length _l_exp) (x - _m)
          then cvar (x + _k)
          else cvar (_m + List.nth (x - _m) _l_exp 0)
        else cvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_exp_cvar : LOOPW_database.

  Lemma exp_fv_permut_in_exp_mvar :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (x : mutable),
      exp_fv_permut_in_exp _k _l_exp _m (mvar x) =
        mvar x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_exp_mvar : LOOPW_database.

  Lemma exp_fv_permut_in_exp_int :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (n : nat),
      exp_fv_permut_in_exp _k _l_exp _m (int n) =
        int n
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_exp_int : LOOPW_database.

  Lemma exp_fv_permut_in_exp_proc :
    forall (_k : nat) (_l_exp : list nat) (_m : nat) (n : nat) (m : nat) (s : seq),
      exp_fv_permut_in_exp _k _l_exp _m (proc n m s) =
        proc n m (exp_fv_permut_in_seq _k _l_exp (_m + n) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_exp_proc : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma exp_fv_permut_in_exps_enil :
    forall (_k : nat) (_l_exps : list nat) (_m : nat) ,
      exp_fv_permut_in_exps _k _l_exps _m (enil ) =
        enil
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_exps_enil : LOOPW_database.

  Lemma exp_fv_permut_in_exps_econs :
    forall (_k : nat) (_l_exps : list nat) (_m : nat) (e : exp) (es : exps),
      exp_fv_permut_in_exps _k _l_exps _m (econs e es) =
        econs (exp_fv_permut_in_exp _k _l_exps _m e) (exp_fv_permut_in_exps _k _l_exps _m es)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_exps_econs : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma exp_fv_permut_in_comm_assign :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (x : mutable) (e : exp),
      exp_fv_permut_in_comm _k _l_comm _m (assign x e) =
        assign x (exp_fv_permut_in_exp _k _l_comm _m e)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_comm_assign : LOOPW_database.

  Lemma exp_fv_permut_in_comm_inc :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (x : mutable),
      exp_fv_permut_in_comm _k _l_comm _m (inc x) =
        inc x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_comm_inc : LOOPW_database.

  Lemma exp_fv_permut_in_comm_dec :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (x : mutable),
      exp_fv_permut_in_comm _k _l_comm _m (dec x) =
        dec x
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_comm_dec : LOOPW_database.

  Lemma exp_fv_permut_in_comm_block :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (s : seq),
      exp_fv_permut_in_comm _k _l_comm _m (block s) =
        block (exp_fv_permut_in_seq _k _l_comm _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_comm_block : LOOPW_database.

  Lemma exp_fv_permut_in_comm_forloop :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (e : exp) (s : seq),
      exp_fv_permut_in_comm _k _l_comm _m (forloop e s) =
        forloop (exp_fv_permut_in_exp _k _l_comm _m e) (exp_fv_permut_in_seq _k _l_comm (_m + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_comm_forloop : LOOPW_database.

  Lemma exp_fv_permut_in_comm_call :
    forall (_k : nat) (_l_comm : list nat) (_m : nat) (p : exp) (es : exps) (ms : mutables),
      exp_fv_permut_in_comm _k _l_comm _m (call p es ms) =
        call (exp_fv_permut_in_exp _k _l_comm _m p) (exp_fv_permut_in_exps _k _l_comm _m es) ms
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_comm_call : LOOPW_database.

  (** Equations for Free variable index permutations *)

  Lemma exp_fv_permut_in_seq_empty :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) ,
      exp_fv_permut_in_seq _k _l_seq _m (empty ) =
        empty
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_seq_empty : LOOPW_database.

  Lemma exp_fv_permut_in_seq_cst :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) (e : exp) (s : seq),
      exp_fv_permut_in_seq _k _l_seq _m (cst e s) =
        cst (exp_fv_permut_in_exp _k _l_seq _m e) (exp_fv_permut_in_seq _k _l_seq (_m + 1) s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_seq_cst : LOOPW_database.

  Lemma exp_fv_permut_in_seq_var :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) (s : seq),
      exp_fv_permut_in_seq _k _l_seq _m (var s) =
        var (exp_fv_permut_in_seq _k _l_seq _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_seq_var : LOOPW_database.

  Lemma exp_fv_permut_in_seq_com :
    forall (_k : nat) (_l_seq : list nat) (_m : nat) (c : comm) (s : seq),
      exp_fv_permut_in_seq _k _l_seq _m (com c s) =
        com (exp_fv_permut_in_comm _k _l_seq _m c) (exp_fv_permut_in_seq _k _l_seq _m s)
  .
  Proof.
    intros; simpl; auto.
  Qed.

  Hint Rewrite exp_fv_permut_in_seq_com : LOOPW_database.


  (** *** Named to De Bruijn translation function *)

  Fixpoint named_to_db_mutable (_n_mutable : nat) (_l_mutable : _name_list _n_mutable) (_arg : _mutable) { struct _arg } : mutable :=
    match _arg with
      | _id x =>
        id (_index_of x _n_mutable _l_mutable)
      | _db_mutable _xn_mutable _xl_mutable _arg =>
        (mutable_fv_permut_in_mutable (_n_mutable - _xn_mutable) (_build_permut _n_mutable _l_mutable _xn_mutable _xl_mutable) 0 _arg)
    end

  with named_to_db_mutables (_n_mutable : nat) (_l_mutable : _name_list _n_mutable) (_arg : _mutables) { struct _arg } : mutables :=
    match _arg with
      | _mnil  =>
        mnil
      | _mcons m ms =>
        mcons (named_to_db_mutable _n_mutable _l_mutable m) (named_to_db_mutables _n_mutable _l_mutable ms)
      | _db_mutables _xn_mutable _xl_mutable _arg =>
        (mutable_fv_permut_in_mutables (_n_mutable - _xn_mutable) (_build_permut _n_mutable _l_mutable _xn_mutable _xl_mutable) 0 _arg)
    end
  .

  (** Equations for Named to De Bruijn translation function *)


  (** Equations for Named to De Bruijn translation function *)


  Fixpoint named_to_db_exp (_n_mutable : nat) (_l_mutable : _name_list _n_mutable) (_n_exp : nat) (_l_exp : _name_list _n_exp) (_arg : _exp) { struct _arg } : exp :=
    match _arg with
      | _cvar x =>
        cvar (_index_of x _n_exp _l_exp)
      | _mvar x =>
        mvar (named_to_db_mutable _n_mutable _l_mutable x)
      | _int n =>
        int n
      | _proc n m xl1 xl2 s =>
        proc n m (named_to_db_seq (m + _n_mutable) (_concat m xl2 _n_mutable _l_mutable) (n + _n_exp) (_concat n xl1 _n_exp _l_exp) s)
      | _db_exp _xn_mutable _xl_mutable _xn_exp _xl_exp _arg =>
        (mutable_fv_permut_in_exp (_n_mutable - _xn_mutable) (_build_permut _n_mutable _l_mutable _xn_mutable _xl_mutable) 0 (exp_fv_permut_in_exp (_n_exp - _xn_exp) (_build_permut _n_exp _l_exp _xn_exp _xl_exp) 0 _arg))
    end

  with named_to_db_exps (_n_mutable : nat) (_l_mutable : _name_list _n_mutable) (_n_exp : nat) (_l_exp : _name_list _n_exp) (_arg : _exps) { struct _arg } : exps :=
    match _arg with
      | _enil  =>
        enil
      | _econs e es =>
        econs (named_to_db_exp _n_mutable _l_mutable _n_exp _l_exp e) (named_to_db_exps _n_mutable _l_mutable _n_exp _l_exp es)
      | _db_exps _xn_mutable _xl_mutable _xn_exp _xl_exp _arg =>
        (mutable_fv_permut_in_exps (_n_mutable - _xn_mutable) (_build_permut _n_mutable _l_mutable _xn_mutable _xl_mutable) 0 (exp_fv_permut_in_exps (_n_exp - _xn_exp) (_build_permut _n_exp _l_exp _xn_exp _xl_exp) 0 _arg))
    end

  with named_to_db_comm (_n_mutable : nat) (_l_mutable : _name_list _n_mutable) (_n_exp : nat) (_l_exp : _name_list _n_exp) (_arg : _comm) { struct _arg } : comm :=
    match _arg with
      | _assign x e =>
        assign (named_to_db_mutable _n_mutable _l_mutable x) (named_to_db_exp _n_mutable _l_mutable _n_exp _l_exp e)
      | _inc x =>
        inc (named_to_db_mutable _n_mutable _l_mutable x)
      | _dec x =>
        dec (named_to_db_mutable _n_mutable _l_mutable x)
      | _block s =>
        block (named_to_db_seq _n_mutable _l_mutable _n_exp _l_exp s)
      | _forloop e xl1 s =>
        forloop (named_to_db_exp _n_mutable _l_mutable _n_exp _l_exp e) (named_to_db_seq _n_mutable _l_mutable (1 + _n_exp) (_concat 1 xl1 _n_exp _l_exp) s)
      | _call p es ms =>
        call (named_to_db_exp _n_mutable _l_mutable _n_exp _l_exp p) (named_to_db_exps _n_mutable _l_mutable _n_exp _l_exp es) (named_to_db_mutables _n_mutable _l_mutable ms)
      | _db_comm _xn_mutable _xl_mutable _xn_exp _xl_exp _arg =>
        (mutable_fv_permut_in_comm (_n_mutable - _xn_mutable) (_build_permut _n_mutable _l_mutable _xn_mutable _xl_mutable) 0 (exp_fv_permut_in_comm (_n_exp - _xn_exp) (_build_permut _n_exp _l_exp _xn_exp _xl_exp) 0 _arg))
    end

  with named_to_db_seq (_n_mutable : nat) (_l_mutable : _name_list _n_mutable) (_n_exp : nat) (_l_exp : _name_list _n_exp) (_arg : _seq) { struct _arg } : seq :=
    match _arg with
      | _empty  =>
        empty
      | _cst e xl1 s =>
        cst (named_to_db_exp _n_mutable _l_mutable _n_exp _l_exp e) (named_to_db_seq _n_mutable _l_mutable (1 + _n_exp) (_concat 1 xl1 _n_exp _l_exp) s)
      | _var xl s =>
        var (named_to_db_seq (1 + _n_mutable) (_concat 1 xl _n_mutable _l_mutable) _n_exp _l_exp s)
      | _com c s =>
        com (named_to_db_comm _n_mutable _l_mutable _n_exp _l_exp c) (named_to_db_seq _n_mutable _l_mutable _n_exp _l_exp s)
      | _db_seq _xn_mutable _xl_mutable _xn_exp _xl_exp _arg =>
        (mutable_fv_permut_in_seq (_n_mutable - _xn_mutable) (_build_permut _n_mutable _l_mutable _xn_mutable _xl_mutable) 0 (exp_fv_permut_in_seq (_n_exp - _xn_exp) (_build_permut _n_exp _l_exp _xn_exp _xl_exp) 0 _arg))
    end
  .

  (** Equations for Named to De Bruijn translation function *)


  (** Equations for Named to De Bruijn translation function *)


  (** Equations for Named to De Bruijn translation function *)


  (** Equations for Named to De Bruijn translation function *)





  (** * Primary lifting and substitution properties *)

  Lemma mutable_lift_in_mutable_id_dec :
    forall _n _m _p : nat,
    { prod (_m <= _p) (mutable_lift_in_mutable _n _m (id _p) = id (_p + _n)) } +
    { prod (_p < _m) (mutable_lift_in_mutable _n _m (id _p) = id _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _mutable_lift_in_mutable_id_dec_tac n m p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (mutable_lift_in_mutable_id_dec n m p) as
              [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.
  Lemma exp_lift_in_exp_cvar_dec :
    forall _n _m _p : nat,
    { prod (_m <= _p) (exp_lift_in_exp _n _m (cvar _p) = cvar (_p + _n)) } +
    { prod (_p < _m) (exp_lift_in_exp _n _m (cvar _p) = cvar _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _exp_lift_in_exp_cvar_dec_tac n m p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (exp_lift_in_exp_cvar_dec n m p) as
              [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Ltac lift_index_dec_tac :=
    match goal with
      | [ |- context [ mutable_lift_in_mutable ?n ?m (id ?p) ] ] =>
        _mutable_lift_in_mutable_id_dec_tac n m p

      | [ H : context [ mutable_lift_in_mutable ?n ?m (id ?p) ] |- _ ] =>
        _mutable_lift_in_mutable_id_dec_tac n m p

      | [ |- context [ exp_lift_in_exp ?n ?m (cvar ?p) ] ] =>
        _exp_lift_in_exp_cvar_dec_tac n m p

      | [ H : context [ exp_lift_in_exp ?n ?m (cvar ?p) ] |- _ ] =>
        _exp_lift_in_exp_cvar_dec_tac n m p

    end.

  Lemma mutable_subst_in_mutable_id_dec :
    forall (_a : mutable) (_n _p : nat),
    { prod (_n < _p) (mutable_subst_in_mutable _a _n (id _p) = id (_p - 1)) } +
    { prod (_n = _p) (mutable_subst_in_mutable _a _n (id _p) = _a) } +
    { prod (_p < _n) (mutable_subst_in_mutable _a _n (id _p) = id _p) }.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ];
      subst; simpl; crush_tac.
  Qed.

  Ltac _mutable_subst_in_mutable_id_dec_tac a n p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (mutable_subst_in_mutable_id_dec a n p) as
              [ [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ]
                | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.
  Lemma exp_subst_in_exp_cvar_dec :
    forall (_a : exp) (_n _p : nat),
    { prod (_n < _p) (exp_subst_in_exp _a _n (cvar _p) = cvar (_p - 1)) } +
    { prod (_n = _p) (exp_subst_in_exp _a _n (cvar _p) = _a) } +
    { prod (_p < _n) (exp_subst_in_exp _a _n (cvar _p) = cvar _p) }.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ];
      subst; simpl; crush_tac.
  Qed.

  Ltac _exp_subst_in_exp_cvar_dec_tac a n p :=
    let Hcomp := fresh "Hcomp" in
          let Hfun := fresh "Hfun" in
            destruct (exp_subst_in_exp_cvar_dec a n p) as
              [ [ [ Hcomp Hfun ] | [ Hcomp Hfun ] ]
                | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Ltac subst_index_dec_tac :=
    match goal with
      | [ |- context [ mutable_subst_in_mutable ?a ?n (id ?p) ] ] =>
        _mutable_subst_in_mutable_id_dec_tac a n p

      | [ H : context [ mutable_subst_in_mutable ?a ?n (id ?p) ] |- _ ] =>
        _mutable_subst_in_mutable_id_dec_tac a n p

      | [ |- context [ exp_subst_in_exp ?a ?n (cvar ?p) ] ] =>
        _exp_subst_in_exp_cvar_dec_tac a n p

      | [ H : context [ exp_subst_in_exp ?a ?n (cvar ?p) ] |- _ ] =>
        _exp_subst_in_exp_cvar_dec_tac a n p

    end.

  Lemma mutable_lift_in_mutable_id_le :
    forall _n _m _p : nat,
      _m <= _p -> mutable_lift_in_mutable _n _m (id _p) = id (_p + _n).
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma mutable_lift_in_mutable_id_lt :
    forall _n _m _p : nat,
      _p < _m -> mutable_lift_in_mutable _n _m (id _p) = id _p.
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.
  Lemma exp_lift_in_exp_cvar_le :
    forall _n _m _p : nat,
      _m <= _p -> exp_lift_in_exp _n _m (cvar _p) = cvar (_p + _n).
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma exp_lift_in_exp_cvar_lt :
    forall _n _m _p : nat,
      _p < _m -> exp_lift_in_exp _n _m (cvar _p) = cvar _p.
  Proof.
    intros; simpl; destruct le_lt_dec; f_equal; omega.
  Qed.

  Ltac lift_index_tac :=
    match goal with
      | [ |- context [ mutable_lift_in_mutable ?n ?m (id ?p) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m (id p) = id (p + n));
            [ | apply (mutable_lift_in_mutable_id_le n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (id p) = id p);
            [ | apply (mutable_lift_in_mutable_id_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ H : context [ mutable_lift_in_mutable ?n ?m (id ?p) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m (id p) = id (p + n)) in H;
            [ | apply (mutable_lift_in_mutable_id_le n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (id p) = id p) in H;
            [ | apply (mutable_lift_in_mutable_id_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ |- context [ exp_lift_in_exp ?n ?m (cvar ?p) ] ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m (cvar p) = cvar (p + n));
            [ | apply (exp_lift_in_exp_cvar_le n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (cvar p) = cvar p);
            [ | apply (exp_lift_in_exp_cvar_lt n m p); cfail ]) ||
          lift_index_dec_tac

      | [ H : context [ exp_lift_in_exp ?n ?m (cvar ?p) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m (cvar p) = cvar (p + n)) in H;
            [ | apply (exp_lift_in_exp_cvar_le n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (cvar p) = cvar p) in H;
            [ | apply (exp_lift_in_exp_cvar_lt n m p); cfail ]) ||
          lift_index_dec_tac

    end.

  Lemma mutable_subst_in_mutable_id_lt_l :
    forall (_a : mutable) (_n _p : nat),
      _n < _p -> mutable_subst_in_mutable _a _n (id _p) = id (_p - 1).
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma mutable_subst_in_mutable_id_eq :
    forall (_a : mutable) (_n _p : nat),
      _n = _p -> mutable_subst_in_mutable _a _n (id _p) = _a.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma mutable_subst_in_mutable_id_lt_r :
    forall (_a : mutable) (_n _p : nat),
      _p < _n -> mutable_subst_in_mutable _a _n (id _p) = id _p.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.
  Lemma exp_subst_in_exp_cvar_lt_l :
    forall (_a : exp) (_n _p : nat),
      _n < _p -> exp_subst_in_exp _a _n (cvar _p) = cvar (_p - 1).
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma exp_subst_in_exp_cvar_eq :
    forall (_a : exp) (_n _p : nat),
      _n = _p -> exp_subst_in_exp _a _n (cvar _p) = _a.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Lemma exp_subst_in_exp_cvar_lt_r :
    forall (_a : exp) (_n _p : nat),
      _p < _n -> exp_subst_in_exp _a _n (cvar _p) = cvar _p.
  Proof.
    intros; simpl; destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; crush_tac.
  Qed.

  Ltac subst_index_tac :=
    match goal with
        | [ |- context [ mutable_subst_in_mutable ?a ?n (id ?m) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable a n (id m) = id (m - 1));
            [ | apply (mutable_subst_in_mutable_id_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (mutable_subst_in_mutable a n (id m) = a);
            [ | apply (mutable_subst_in_mutable_id_eq a n m); cfail ]) ||
          (cutrewrite ->
            (mutable_subst_in_mutable a n (id m) = id m);
            [ | apply (mutable_subst_in_mutable_id_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ H : context [ mutable_subst_in_mutable ?a ?n (id ?m) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable a n (id m) = id (m - 1)) in H;
            [ | apply (mutable_subst_in_mutable_id_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (mutable_subst_in_mutable a n (id m) = a) in H;
            [ | apply (mutable_subst_in_mutable_id_eq a n m); cfail ]) ||
          (cutrewrite ->
            (mutable_subst_in_mutable a n (id m) = id m) in H;
            [ | apply (mutable_subst_in_mutable_id_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ |- context [ exp_subst_in_exp ?a ?n (cvar ?m) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exp a n (cvar m) = cvar (m - 1));
            [ | apply (exp_subst_in_exp_cvar_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (exp_subst_in_exp a n (cvar m) = a);
            [ | apply (exp_subst_in_exp_cvar_eq a n m); cfail ]) ||
          (cutrewrite ->
            (exp_subst_in_exp a n (cvar m) = cvar m);
            [ | apply (exp_subst_in_exp_cvar_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

        | [ H : context [ exp_subst_in_exp ?a ?n (cvar ?m) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exp a n (cvar m) = cvar (m - 1)) in H;
            [ | apply (exp_subst_in_exp_cvar_lt_l a n m); cfail ]) ||
          (cutrewrite ->
            (exp_subst_in_exp a n (cvar m) = a) in H;
            [ | apply (exp_subst_in_exp_cvar_eq a n m); cfail ]) ||
          (cutrewrite ->
            (exp_subst_in_exp a n (cvar m) = cvar m) in H;
            [ | apply (exp_subst_in_exp_cvar_lt_r a n m); cfail ]) ||
          subst_index_dec_tac

    end.

  Ltac index_tac :=
    repeat (progress (lift_index_tac || subst_index_tac)).



  (** * Additional properties *)


  (** ** Lifting main properties *)


  (** *** Lifting with 0 simplification *)

  Lemma mutable_lift_in_mutable_0_simpl :
    forall (_arg : mutable) (_m : nat),
      mutable_lift_in_mutable 0 _m _arg = _arg

  with mutable_lift_in_mutables_0_simpl :
    forall (_arg : mutables) (_m : nat),
      mutable_lift_in_mutables 0 _m _arg = _arg
  .
  Proof.
    (* case mutable_lift_in_mutable_0_simpl *)
    Focus. clear mutable_lift_in_mutable_0_simpl.
    induction _arg as [ x ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_mutables_0_simpl *)
    Focus. clear mutable_lift_in_mutables_0_simpl.
    induction _arg as [  | m ms IHms ];
      intro _m; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_0_simpl; simpl; try rewrite IHms; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite mutable_lift_in_mutable_0_simpl : LOOPW_database.

  Hint Rewrite mutable_lift_in_mutables_0_simpl : LOOPW_database.

  Lemma mutable_lift_in_exp_0_simpl :
    forall (_arg : exp) (_m : nat),
      mutable_lift_in_exp 0 _m _arg = _arg

  with mutable_lift_in_exps_0_simpl :
    forall (_arg : exps) (_m : nat),
      mutable_lift_in_exps 0 _m _arg = _arg

  with mutable_lift_in_comm_0_simpl :
    forall (_arg : comm) (_m : nat),
      mutable_lift_in_comm 0 _m _arg = _arg

  with mutable_lift_in_seq_0_simpl :
    forall (_arg : seq) (_m : nat),
      mutable_lift_in_seq 0 _m _arg = _arg
  .
  Proof.
    (* case mutable_lift_in_exp_0_simpl *)
    Focus. clear mutable_lift_in_exp_0_simpl.
    induction _arg as [ x | x | n | n m s ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_0_simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_lift_in_seq_0_simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_exps_0_simpl *)
    Focus. clear mutable_lift_in_exps_0_simpl.
    induction _arg as [  | e es IHes ];
      intro _m; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_0_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_comm_0_simpl *)
    Focus. clear mutable_lift_in_comm_0_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intro _m; 
        [ simpl; try rewrite mutable_lift_in_mutable_0_simpl; simpl; try rewrite mutable_lift_in_exp_0_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_0_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_0_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_0_simpl; simpl; try rewrite mutable_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_0_simpl; simpl; try rewrite mutable_lift_in_exps_0_simpl; simpl; try rewrite mutable_lift_in_mutables_0_simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_seq_0_simpl *)
    Focus. clear mutable_lift_in_seq_0_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intro _m; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_0_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_lift_in_comm_0_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite mutable_lift_in_exp_0_simpl : LOOPW_database.

  Hint Rewrite mutable_lift_in_exps_0_simpl : LOOPW_database.

  Hint Rewrite mutable_lift_in_comm_0_simpl : LOOPW_database.

  Hint Rewrite mutable_lift_in_seq_0_simpl : LOOPW_database.

  Lemma exp_lift_in_exp_0_simpl :
    forall (_arg : exp) (_m : nat),
      exp_lift_in_exp 0 _m _arg = _arg

  with exp_lift_in_exps_0_simpl :
    forall (_arg : exps) (_m : nat),
      exp_lift_in_exps 0 _m _arg = _arg

  with exp_lift_in_comm_0_simpl :
    forall (_arg : comm) (_m : nat),
      exp_lift_in_comm 0 _m _arg = _arg

  with exp_lift_in_seq_0_simpl :
    forall (_arg : seq) (_m : nat),
      exp_lift_in_seq 0 _m _arg = _arg
  .
  Proof.
    (* case exp_lift_in_exp_0_simpl *)
    Focus. clear exp_lift_in_exp_0_simpl.
    induction _arg as [ x | x | n | n m s ];
      intro _m; 
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_lift_in_seq_0_simpl; crush_tac
        ];
      idtac.

    (* case exp_lift_in_exps_0_simpl *)
    Focus. clear exp_lift_in_exps_0_simpl.
    induction _arg as [  | e es IHes ];
      intro _m; 
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_0_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case exp_lift_in_comm_0_simpl *)
    Focus. clear exp_lift_in_comm_0_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intro _m; 
        [ simpl; simpl; try rewrite exp_lift_in_exp_0_simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite exp_lift_in_exp_0_simpl; simpl; try rewrite exp_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite exp_lift_in_exp_0_simpl; simpl; try rewrite exp_lift_in_exps_0_simpl; simpl; crush_tac
        ];
      idtac.

    (* case exp_lift_in_seq_0_simpl *)
    Focus. clear exp_lift_in_seq_0_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intro _m; 
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_0_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_lift_in_comm_0_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite exp_lift_in_exp_0_simpl : LOOPW_database.

  Hint Rewrite exp_lift_in_exps_0_simpl : LOOPW_database.

  Hint Rewrite exp_lift_in_comm_0_simpl : LOOPW_database.

  Hint Rewrite exp_lift_in_seq_0_simpl : LOOPW_database.

  (** *** Lifting with 0 simplification generalized *)

  Lemma mutable_lift_in_mutable_0_simpl_gen :
    forall (_arg : mutable) (_n _m : nat),
      _n = 0 -> mutable_lift_in_mutable _n _m _arg = _arg

  with mutable_lift_in_mutables_0_simpl_gen :
    forall (_arg : mutables) (_n _m : nat),
      _n = 0 -> mutable_lift_in_mutables _n _m _arg = _arg
  .
  Proof.
    (* case mutable_lift_in_mutable_0_simpl_gen *)
    Focus. clear mutable_lift_in_mutable_0_simpl_gen.
    intros; subst; crush_tac.

    (* case mutable_lift_in_mutables_0_simpl_gen *)
    Focus. clear mutable_lift_in_mutables_0_simpl_gen.
    intros; subst; crush_tac.
  Qed.


  Lemma mutable_lift_in_exp_0_simpl_gen :
    forall (_arg : exp) (_n _m : nat),
      _n = 0 -> mutable_lift_in_exp _n _m _arg = _arg

  with mutable_lift_in_exps_0_simpl_gen :
    forall (_arg : exps) (_n _m : nat),
      _n = 0 -> mutable_lift_in_exps _n _m _arg = _arg

  with mutable_lift_in_comm_0_simpl_gen :
    forall (_arg : comm) (_n _m : nat),
      _n = 0 -> mutable_lift_in_comm _n _m _arg = _arg

  with mutable_lift_in_seq_0_simpl_gen :
    forall (_arg : seq) (_n _m : nat),
      _n = 0 -> mutable_lift_in_seq _n _m _arg = _arg
  .
  Proof.
    (* case mutable_lift_in_exp_0_simpl_gen *)
    Focus. clear mutable_lift_in_exp_0_simpl_gen.
    intros; subst; crush_tac.

    (* case mutable_lift_in_exps_0_simpl_gen *)
    Focus. clear mutable_lift_in_exps_0_simpl_gen.
    intros; subst; crush_tac.

    (* case mutable_lift_in_comm_0_simpl_gen *)
    Focus. clear mutable_lift_in_comm_0_simpl_gen.
    intros; subst; crush_tac.

    (* case mutable_lift_in_seq_0_simpl_gen *)
    Focus. clear mutable_lift_in_seq_0_simpl_gen.
    intros; subst; crush_tac.
  Qed.


  Lemma exp_lift_in_exp_0_simpl_gen :
    forall (_arg : exp) (_n _m : nat),
      _n = 0 -> exp_lift_in_exp _n _m _arg = _arg

  with exp_lift_in_exps_0_simpl_gen :
    forall (_arg : exps) (_n _m : nat),
      _n = 0 -> exp_lift_in_exps _n _m _arg = _arg

  with exp_lift_in_comm_0_simpl_gen :
    forall (_arg : comm) (_n _m : nat),
      _n = 0 -> exp_lift_in_comm _n _m _arg = _arg

  with exp_lift_in_seq_0_simpl_gen :
    forall (_arg : seq) (_n _m : nat),
      _n = 0 -> exp_lift_in_seq _n _m _arg = _arg
  .
  Proof.
    (* case exp_lift_in_exp_0_simpl_gen *)
    Focus. clear exp_lift_in_exp_0_simpl_gen.
    intros; subst; crush_tac.

    (* case exp_lift_in_exps_0_simpl_gen *)
    Focus. clear exp_lift_in_exps_0_simpl_gen.
    intros; subst; crush_tac.

    (* case exp_lift_in_comm_0_simpl_gen *)
    Focus. clear exp_lift_in_comm_0_simpl_gen.
    intros; subst; crush_tac.

    (* case exp_lift_in_seq_0_simpl_gen *)
    Focus. clear exp_lift_in_seq_0_simpl_gen.
    intros; subst; crush_tac.
  Qed.


  Ltac lift_0_simpl_tac :=
    repeat
      match goal with
        | [ |- context [ mutable_lift_in_mutable ?n ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m t = t);
            [ | apply (mutable_lift_in_mutable_0_simpl_gen t n m); cfail ])
        | [ H : context [ mutable_lift_in_mutable ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m t = t) in H;
            [ | apply (mutable_lift_in_mutable_0_simpl_gen t n m); cfail ])
        | [ |- context [ mutable_lift_in_mutables ?n ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutables n m t = t);
            [ | apply (mutable_lift_in_mutables_0_simpl_gen t n m); cfail ])
        | [ H : context [ mutable_lift_in_mutables ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutables n m t = t) in H;
            [ | apply (mutable_lift_in_mutables_0_simpl_gen t n m); cfail ])
        | [ |- context [ mutable_lift_in_exp ?n ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_lift_in_exp n m t = t);
            [ | apply (mutable_lift_in_exp_0_simpl_gen t n m); cfail ])
        | [ H : context [ mutable_lift_in_exp ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_exp n m t = t) in H;
            [ | apply (mutable_lift_in_exp_0_simpl_gen t n m); cfail ])
        | [ |- context [ mutable_lift_in_exps ?n ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_lift_in_exps n m t = t);
            [ | apply (mutable_lift_in_exps_0_simpl_gen t n m); cfail ])
        | [ H : context [ mutable_lift_in_exps ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_exps n m t = t) in H;
            [ | apply (mutable_lift_in_exps_0_simpl_gen t n m); cfail ])
        | [ |- context [ mutable_lift_in_comm ?n ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_lift_in_comm n m t = t);
            [ | apply (mutable_lift_in_comm_0_simpl_gen t n m); cfail ])
        | [ H : context [ mutable_lift_in_comm ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_comm n m t = t) in H;
            [ | apply (mutable_lift_in_comm_0_simpl_gen t n m); cfail ])
        | [ |- context [ mutable_lift_in_seq ?n ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_lift_in_seq n m t = t);
            [ | apply (mutable_lift_in_seq_0_simpl_gen t n m); cfail ])
        | [ H : context [ mutable_lift_in_seq ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_seq n m t = t) in H;
            [ | apply (mutable_lift_in_seq_0_simpl_gen t n m); cfail ])
        | [ |- context [ exp_lift_in_exp ?n ?m ?t ] ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m t = t);
            [ | apply (exp_lift_in_exp_0_simpl_gen t n m); cfail ])
        | [ H : context [ exp_lift_in_exp ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m t = t) in H;
            [ | apply (exp_lift_in_exp_0_simpl_gen t n m); cfail ])
        | [ |- context [ exp_lift_in_exps ?n ?m ?t ] ] =>
          (cutrewrite ->
            (exp_lift_in_exps n m t = t);
            [ | apply (exp_lift_in_exps_0_simpl_gen t n m); cfail ])
        | [ H : context [ exp_lift_in_exps ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exps n m t = t) in H;
            [ | apply (exp_lift_in_exps_0_simpl_gen t n m); cfail ])
        | [ |- context [ exp_lift_in_comm ?n ?m ?t ] ] =>
          (cutrewrite ->
            (exp_lift_in_comm n m t = t);
            [ | apply (exp_lift_in_comm_0_simpl_gen t n m); cfail ])
        | [ H : context [ exp_lift_in_comm ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_comm n m t = t) in H;
            [ | apply (exp_lift_in_comm_0_simpl_gen t n m); cfail ])
        | [ |- context [ exp_lift_in_seq ?n ?m ?t ] ] =>
          (cutrewrite ->
            (exp_lift_in_seq n m t = t);
            [ | apply (exp_lift_in_seq_0_simpl_gen t n m); cfail ])
        | [ H : context [ exp_lift_in_seq ?n ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_seq n m t = t) in H;
            [ | apply (exp_lift_in_seq_0_simpl_gen t n m); cfail ])
      end; crush_tac.

  (** *** Lifting over lifting simplification and commutation *)

  Lemma mutable_lift_in_mutable_mutable_lift_in_mutable_simpl :
    forall (_arg : mutable) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      mutable_lift_in_mutable _n _m (mutable_lift_in_mutable _n' _m' _arg) =
      mutable_lift_in_mutable (_n' + _n) _m' _arg

  with mutable_lift_in_mutables_mutable_lift_in_mutables_simpl :
    forall (_arg : mutables) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      mutable_lift_in_mutables _n _m (mutable_lift_in_mutables _n' _m' _arg) =
      mutable_lift_in_mutables (_n' + _n) _m' _arg
  .
  Proof.
    (* case mutable_lift_in_mutable_mutable_lift_in_mutable_simpl *)
    Focus. clear mutable_lift_in_mutable_mutable_lift_in_mutable_simpl.
    induction _arg as [ x ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_mutables_mutable_lift_in_mutables_simpl *)
    Focus. clear mutable_lift_in_mutables_mutable_lift_in_mutables_simpl.
    induction _arg as [  | m ms IHms ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_simpl; simpl; try rewrite IHms; crush_tac
        ];
      idtac.
  Qed.


  Lemma mutable_lift_in_exp_mutable_lift_in_exp_simpl :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      mutable_lift_in_exp _n _m (mutable_lift_in_exp _n' _m' _arg) =
      mutable_lift_in_exp (_n' + _n) _m' _arg

  with mutable_lift_in_exps_mutable_lift_in_exps_simpl :
    forall (_arg : exps) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      mutable_lift_in_exps _n _m (mutable_lift_in_exps _n' _m' _arg) =
      mutable_lift_in_exps (_n' + _n) _m' _arg

  with mutable_lift_in_comm_mutable_lift_in_comm_simpl :
    forall (_arg : comm) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      mutable_lift_in_comm _n _m (mutable_lift_in_comm _n' _m' _arg) =
      mutable_lift_in_comm (_n' + _n) _m' _arg

  with mutable_lift_in_seq_mutable_lift_in_seq_simpl :
    forall (_arg : seq) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      mutable_lift_in_seq _n _m (mutable_lift_in_seq _n' _m' _arg) =
      mutable_lift_in_seq (_n' + _n) _m' _arg
  .
  Proof.
    (* case mutable_lift_in_exp_mutable_lift_in_exp_simpl *)
    Focus. clear mutable_lift_in_exp_mutable_lift_in_exp_simpl.
    induction _arg as [ x | x | n | n m s ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_lift_in_seq_mutable_lift_in_seq_simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_exps_mutable_lift_in_exps_simpl *)
    Focus. clear mutable_lift_in_exps_mutable_lift_in_exps_simpl.
    induction _arg as [  | e es IHes ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_comm_mutable_lift_in_comm_simpl *)
    Focus. clear mutable_lift_in_comm_mutable_lift_in_comm_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_simpl; simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_seq_mutable_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite mutable_lift_in_seq_mutable_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite mutable_lift_in_exps_mutable_lift_in_exps_simpl; simpl; try rewrite mutable_lift_in_mutables_mutable_lift_in_mutables_simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_seq_mutable_lift_in_seq_simpl *)
    Focus. clear mutable_lift_in_seq_mutable_lift_in_seq_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_lift_in_comm_mutable_lift_in_comm_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.


  Lemma exp_lift_in_exp_exp_lift_in_exp_simpl :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      exp_lift_in_exp _n _m (exp_lift_in_exp _n' _m' _arg) =
      exp_lift_in_exp (_n' + _n) _m' _arg

  with exp_lift_in_exps_exp_lift_in_exps_simpl :
    forall (_arg : exps) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      exp_lift_in_exps _n _m (exp_lift_in_exps _n' _m' _arg) =
      exp_lift_in_exps (_n' + _n) _m' _arg

  with exp_lift_in_comm_exp_lift_in_comm_simpl :
    forall (_arg : comm) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      exp_lift_in_comm _n _m (exp_lift_in_comm _n' _m' _arg) =
      exp_lift_in_comm (_n' + _n) _m' _arg

  with exp_lift_in_seq_exp_lift_in_seq_simpl :
    forall (_arg : seq) (_n _m _n' _m' : nat),
      _m' <= _m <= _n' + _m' ->
      exp_lift_in_seq _n _m (exp_lift_in_seq _n' _m' _arg) =
      exp_lift_in_seq (_n' + _n) _m' _arg
  .
  Proof.
    (* case exp_lift_in_exp_exp_lift_in_exp_simpl *)
    Focus. clear exp_lift_in_exp_exp_lift_in_exp_simpl.
    induction _arg as [ x | x | n | n m s ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_lift_in_seq_exp_lift_in_seq_simpl; crush_tac
        ];
      idtac.

    (* case exp_lift_in_exps_exp_lift_in_exps_simpl *)
    Focus. clear exp_lift_in_exps_exp_lift_in_exps_simpl.
    induction _arg as [  | e es IHes ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case exp_lift_in_comm_exp_lift_in_comm_simpl *)
    Focus. clear exp_lift_in_comm_exp_lift_in_comm_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ simpl; simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_lift_in_seq_exp_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite exp_lift_in_seq_exp_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite exp_lift_in_exps_exp_lift_in_exps_simpl; simpl; crush_tac
        ];
      idtac.

    (* case exp_lift_in_seq_exp_lift_in_seq_simpl *)
    Focus. clear exp_lift_in_seq_exp_lift_in_seq_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros _n _m _n' _m' Hyp; destruct Hyp;
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_lift_in_comm_exp_lift_in_comm_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.


  Lemma mutable_lift_in_mutable_mutable_lift_in_mutable_commut :
    forall (_arg : mutable) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      mutable_lift_in_mutable _n _m (mutable_lift_in_mutable _n' _m' _arg) =
      mutable_lift_in_mutable _n' _m' (mutable_lift_in_mutable _n (_m - _n') _arg)

  with mutable_lift_in_mutables_mutable_lift_in_mutables_commut :
    forall (_arg : mutables) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      mutable_lift_in_mutables _n _m (mutable_lift_in_mutables _n' _m' _arg) =
      mutable_lift_in_mutables _n' _m' (mutable_lift_in_mutables _n (_m - _n') _arg)
  .
  Proof.
    (* case mutable_lift_in_mutable_mutable_lift_in_mutable_commut *)
    Focus. clear mutable_lift_in_mutable_mutable_lift_in_mutable_commut.
    induction _arg as [ x ]; intros;
        [ index_tac; simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_mutables_mutable_lift_in_mutables_commut *)
    Focus. clear mutable_lift_in_mutables_mutable_lift_in_mutables_commut.
    induction _arg as [  | m ms IHms ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_commut; simpl; try rewrite IHms; crush_tac
        ];
      idtac.
  Qed.


  Lemma mutable_lift_in_exp_mutable_lift_in_exp_commut :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      mutable_lift_in_exp _n _m (mutable_lift_in_exp _n' _m' _arg) =
      mutable_lift_in_exp _n' _m' (mutable_lift_in_exp _n (_m - _n') _arg)

  with mutable_lift_in_exps_mutable_lift_in_exps_commut :
    forall (_arg : exps) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      mutable_lift_in_exps _n _m (mutable_lift_in_exps _n' _m' _arg) =
      mutable_lift_in_exps _n' _m' (mutable_lift_in_exps _n (_m - _n') _arg)

  with mutable_lift_in_comm_mutable_lift_in_comm_commut :
    forall (_arg : comm) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      mutable_lift_in_comm _n _m (mutable_lift_in_comm _n' _m' _arg) =
      mutable_lift_in_comm _n' _m' (mutable_lift_in_comm _n (_m - _n') _arg)

  with mutable_lift_in_seq_mutable_lift_in_seq_commut :
    forall (_arg : seq) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      mutable_lift_in_seq _n _m (mutable_lift_in_seq _n' _m' _arg) =
      mutable_lift_in_seq _n' _m' (mutable_lift_in_seq _n (_m - _n') _arg)
  .
  Proof.
    (* case mutable_lift_in_exp_mutable_lift_in_exp_commut *)
    Focus. clear mutable_lift_in_exp_mutable_lift_in_exp_commut.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_commut; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_lift_in_seq_mutable_lift_in_seq_commut; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_exps_mutable_lift_in_exps_commut *)
    Focus. clear mutable_lift_in_exps_mutable_lift_in_exps_commut.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_comm_mutable_lift_in_comm_commut *)
    Focus. clear mutable_lift_in_comm_mutable_lift_in_comm_commut.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_commut; simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_commut; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_commut; crush_tac
        | simpl; try rewrite mutable_lift_in_mutable_mutable_lift_in_mutable_commut; crush_tac
        | simpl; try rewrite mutable_lift_in_seq_mutable_lift_in_seq_commut; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite mutable_lift_in_seq_mutable_lift_in_seq_commut; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite mutable_lift_in_exps_mutable_lift_in_exps_commut; simpl; try rewrite mutable_lift_in_mutables_mutable_lift_in_mutables_commut; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_seq_mutable_lift_in_seq_commut *)
    Focus. clear mutable_lift_in_seq_mutable_lift_in_seq_commut.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_lift_in_comm_mutable_lift_in_comm_commut; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.


  Lemma exp_lift_in_exp_exp_lift_in_exp_commut :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      exp_lift_in_exp _n _m (exp_lift_in_exp _n' _m' _arg) =
      exp_lift_in_exp _n' _m' (exp_lift_in_exp _n (_m - _n') _arg)

  with exp_lift_in_exps_exp_lift_in_exps_commut :
    forall (_arg : exps) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      exp_lift_in_exps _n _m (exp_lift_in_exps _n' _m' _arg) =
      exp_lift_in_exps _n' _m' (exp_lift_in_exps _n (_m - _n') _arg)

  with exp_lift_in_comm_exp_lift_in_comm_commut :
    forall (_arg : comm) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      exp_lift_in_comm _n _m (exp_lift_in_comm _n' _m' _arg) =
      exp_lift_in_comm _n' _m' (exp_lift_in_comm _n (_m - _n') _arg)

  with exp_lift_in_seq_exp_lift_in_seq_commut :
    forall (_arg : seq) (_n _m _n' _m' : nat),
      _n' + _m' <= _m ->
      exp_lift_in_seq _n _m (exp_lift_in_seq _n' _m' _arg) =
      exp_lift_in_seq _n' _m' (exp_lift_in_seq _n (_m - _n') _arg)
  .
  Proof.
    (* case exp_lift_in_exp_exp_lift_in_exp_commut *)
    Focus. clear exp_lift_in_exp_exp_lift_in_exp_commut.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_lift_in_seq_exp_lift_in_seq_commut; crush_tac
        ];
      idtac.

    (* case exp_lift_in_exps_exp_lift_in_exps_commut *)
    Focus. clear exp_lift_in_exps_exp_lift_in_exps_commut.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_commut; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case exp_lift_in_comm_exp_lift_in_comm_commut *)
    Focus. clear exp_lift_in_comm_exp_lift_in_comm_commut.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_commut; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_lift_in_seq_exp_lift_in_seq_commut; crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_commut; simpl; try rewrite exp_lift_in_seq_exp_lift_in_seq_commut; crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_commut; simpl; try rewrite exp_lift_in_exps_exp_lift_in_exps_commut; simpl; crush_tac
        ];
      idtac.

    (* case exp_lift_in_seq_exp_lift_in_seq_commut *)
    Focus. clear exp_lift_in_seq_exp_lift_in_seq_commut.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_exp_lift_in_exp_commut; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_lift_in_comm_exp_lift_in_comm_commut; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.


  Ltac lift_lift_tac :=
    repeat
      match goal with
        | [ |- context [ mutable_lift_in_mutable ?n ?m (mutable_lift_in_mutable ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_lift_in_mutable p q t) =
             mutable_lift_in_mutable (p + n) q t);
            [ | apply (mutable_lift_in_mutable_mutable_lift_in_mutable_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_lift_in_mutable p q t) =
             mutable_lift_in_mutable p q (mutable_lift_in_mutable n (m - p) t));
            [ | apply (mutable_lift_in_mutable_mutable_lift_in_mutable_commut t n m p q); cfail ])
        | [ H : context [ mutable_lift_in_mutable ?n ?m (mutable_lift_in_mutable ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_lift_in_mutable p q t) =
             mutable_lift_in_mutable (p + n) q t) in H;
            [ | apply (mutable_lift_in_mutable_mutable_lift_in_mutable_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_lift_in_mutable p q t) =
             mutable_lift_in_mutable p q (mutable_lift_in_mutable n (m - p) t)) in H;
            [ | apply (mutable_lift_in_mutable_mutable_lift_in_mutable_commut t n m p q); cfail ])
        | [ |- context [ mutable_lift_in_mutables ?n ?m (mutable_lift_in_mutables ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_lift_in_mutables p q t) =
             mutable_lift_in_mutables (p + n) q t);
            [ | apply (mutable_lift_in_mutables_mutable_lift_in_mutables_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_lift_in_mutables p q t) =
             mutable_lift_in_mutables p q (mutable_lift_in_mutables n (m - p) t));
            [ | apply (mutable_lift_in_mutables_mutable_lift_in_mutables_commut t n m p q); cfail ])
        | [ H : context [ mutable_lift_in_mutables ?n ?m (mutable_lift_in_mutables ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_lift_in_mutables p q t) =
             mutable_lift_in_mutables (p + n) q t) in H;
            [ | apply (mutable_lift_in_mutables_mutable_lift_in_mutables_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_lift_in_mutables p q t) =
             mutable_lift_in_mutables p q (mutable_lift_in_mutables n (m - p) t)) in H;
            [ | apply (mutable_lift_in_mutables_mutable_lift_in_mutables_commut t n m p q); cfail ])
        | [ |- context [ mutable_lift_in_exp ?n ?m (mutable_lift_in_exp ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_lift_in_exp p q t) =
             mutable_lift_in_exp (p + n) q t);
            [ | apply (mutable_lift_in_exp_mutable_lift_in_exp_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_lift_in_exp p q t) =
             mutable_lift_in_exp p q (mutable_lift_in_exp n (m - p) t));
            [ | apply (mutable_lift_in_exp_mutable_lift_in_exp_commut t n m p q); cfail ])
        | [ H : context [ mutable_lift_in_exp ?n ?m (mutable_lift_in_exp ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_lift_in_exp p q t) =
             mutable_lift_in_exp (p + n) q t) in H;
            [ | apply (mutable_lift_in_exp_mutable_lift_in_exp_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_lift_in_exp p q t) =
             mutable_lift_in_exp p q (mutable_lift_in_exp n (m - p) t)) in H;
            [ | apply (mutable_lift_in_exp_mutable_lift_in_exp_commut t n m p q); cfail ])
        | [ |- context [ mutable_lift_in_exps ?n ?m (mutable_lift_in_exps ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_lift_in_exps p q t) =
             mutable_lift_in_exps (p + n) q t);
            [ | apply (mutable_lift_in_exps_mutable_lift_in_exps_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_lift_in_exps p q t) =
             mutable_lift_in_exps p q (mutable_lift_in_exps n (m - p) t));
            [ | apply (mutable_lift_in_exps_mutable_lift_in_exps_commut t n m p q); cfail ])
        | [ H : context [ mutable_lift_in_exps ?n ?m (mutable_lift_in_exps ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_lift_in_exps p q t) =
             mutable_lift_in_exps (p + n) q t) in H;
            [ | apply (mutable_lift_in_exps_mutable_lift_in_exps_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_lift_in_exps p q t) =
             mutable_lift_in_exps p q (mutable_lift_in_exps n (m - p) t)) in H;
            [ | apply (mutable_lift_in_exps_mutable_lift_in_exps_commut t n m p q); cfail ])
        | [ |- context [ mutable_lift_in_comm ?n ?m (mutable_lift_in_comm ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_lift_in_comm p q t) =
             mutable_lift_in_comm (p + n) q t);
            [ | apply (mutable_lift_in_comm_mutable_lift_in_comm_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_lift_in_comm p q t) =
             mutable_lift_in_comm p q (mutable_lift_in_comm n (m - p) t));
            [ | apply (mutable_lift_in_comm_mutable_lift_in_comm_commut t n m p q); cfail ])
        | [ H : context [ mutable_lift_in_comm ?n ?m (mutable_lift_in_comm ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_lift_in_comm p q t) =
             mutable_lift_in_comm (p + n) q t) in H;
            [ | apply (mutable_lift_in_comm_mutable_lift_in_comm_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_lift_in_comm p q t) =
             mutable_lift_in_comm p q (mutable_lift_in_comm n (m - p) t)) in H;
            [ | apply (mutable_lift_in_comm_mutable_lift_in_comm_commut t n m p q); cfail ])
        | [ |- context [ mutable_lift_in_seq ?n ?m (mutable_lift_in_seq ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_lift_in_seq p q t) =
             mutable_lift_in_seq (p + n) q t);
            [ | apply (mutable_lift_in_seq_mutable_lift_in_seq_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_lift_in_seq p q t) =
             mutable_lift_in_seq p q (mutable_lift_in_seq n (m - p) t));
            [ | apply (mutable_lift_in_seq_mutable_lift_in_seq_commut t n m p q); cfail ])
        | [ H : context [ mutable_lift_in_seq ?n ?m (mutable_lift_in_seq ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_lift_in_seq p q t) =
             mutable_lift_in_seq (p + n) q t) in H;
            [ | apply (mutable_lift_in_seq_mutable_lift_in_seq_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_lift_in_seq p q t) =
             mutable_lift_in_seq p q (mutable_lift_in_seq n (m - p) t)) in H;
            [ | apply (mutable_lift_in_seq_mutable_lift_in_seq_commut t n m p q); cfail ])
        | [ |- context [ exp_lift_in_exp ?n ?m (exp_lift_in_exp ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_lift_in_exp p q t) =
             exp_lift_in_exp (p + n) q t);
            [ | apply (exp_lift_in_exp_exp_lift_in_exp_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_lift_in_exp p q t) =
             exp_lift_in_exp p q (exp_lift_in_exp n (m - p) t));
            [ | apply (exp_lift_in_exp_exp_lift_in_exp_commut t n m p q); cfail ])
        | [ H : context [ exp_lift_in_exp ?n ?m (exp_lift_in_exp ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_lift_in_exp p q t) =
             exp_lift_in_exp (p + n) q t) in H;
            [ | apply (exp_lift_in_exp_exp_lift_in_exp_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_lift_in_exp p q t) =
             exp_lift_in_exp p q (exp_lift_in_exp n (m - p) t)) in H;
            [ | apply (exp_lift_in_exp_exp_lift_in_exp_commut t n m p q); cfail ])
        | [ |- context [ exp_lift_in_exps ?n ?m (exp_lift_in_exps ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_lift_in_exps p q t) =
             exp_lift_in_exps (p + n) q t);
            [ | apply (exp_lift_in_exps_exp_lift_in_exps_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_lift_in_exps p q t) =
             exp_lift_in_exps p q (exp_lift_in_exps n (m - p) t));
            [ | apply (exp_lift_in_exps_exp_lift_in_exps_commut t n m p q); cfail ])
        | [ H : context [ exp_lift_in_exps ?n ?m (exp_lift_in_exps ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_lift_in_exps p q t) =
             exp_lift_in_exps (p + n) q t) in H;
            [ | apply (exp_lift_in_exps_exp_lift_in_exps_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_lift_in_exps p q t) =
             exp_lift_in_exps p q (exp_lift_in_exps n (m - p) t)) in H;
            [ | apply (exp_lift_in_exps_exp_lift_in_exps_commut t n m p q); cfail ])
        | [ |- context [ exp_lift_in_comm ?n ?m (exp_lift_in_comm ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_lift_in_comm p q t) =
             exp_lift_in_comm (p + n) q t);
            [ | apply (exp_lift_in_comm_exp_lift_in_comm_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_lift_in_comm p q t) =
             exp_lift_in_comm p q (exp_lift_in_comm n (m - p) t));
            [ | apply (exp_lift_in_comm_exp_lift_in_comm_commut t n m p q); cfail ])
        | [ H : context [ exp_lift_in_comm ?n ?m (exp_lift_in_comm ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_lift_in_comm p q t) =
             exp_lift_in_comm (p + n) q t) in H;
            [ | apply (exp_lift_in_comm_exp_lift_in_comm_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_lift_in_comm p q t) =
             exp_lift_in_comm p q (exp_lift_in_comm n (m - p) t)) in H;
            [ | apply (exp_lift_in_comm_exp_lift_in_comm_commut t n m p q); cfail ])
        | [ |- context [ exp_lift_in_seq ?n ?m (exp_lift_in_seq ?p ?q ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_lift_in_seq p q t) =
             exp_lift_in_seq (p + n) q t);
            [ | apply (exp_lift_in_seq_exp_lift_in_seq_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_lift_in_seq p q t) =
             exp_lift_in_seq p q (exp_lift_in_seq n (m - p) t));
            [ | apply (exp_lift_in_seq_exp_lift_in_seq_commut t n m p q); cfail ])
        | [ H : context [ exp_lift_in_seq ?n ?m (exp_lift_in_seq ?p ?q ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_lift_in_seq p q t) =
             exp_lift_in_seq (p + n) q t) in H;
            [ | apply (exp_lift_in_seq_exp_lift_in_seq_simpl t n m p q); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_lift_in_seq p q t) =
             exp_lift_in_seq p q (exp_lift_in_seq n (m - p) t)) in H;
            [ | apply (exp_lift_in_seq_exp_lift_in_seq_commut t n m p q); cfail ])
      end; crush_tac.

  Ltac lift_tac :=
    crush_tac;
    repeat (progress (lift_index_tac || lift_0_simpl_tac || lift_lift_tac)).


  (** ** Substitution main properties *)


  (** *** Lifting and substitution respective independance *)

  Lemma mutable_lift_in_exp_exp_lift_in_exp_indep :
    forall (_arg : exp) (_n _m _n' _m' : nat),
      mutable_lift_in_exp _n _m (exp_lift_in_exp _n' _m' _arg) = 
      exp_lift_in_exp _n' _m' (mutable_lift_in_exp _n _m _arg)

  with mutable_lift_in_exps_exp_lift_in_exps_indep :
    forall (_arg : exps) (_n _m _n' _m' : nat),
      mutable_lift_in_exps _n _m (exp_lift_in_exps _n' _m' _arg) = 
      exp_lift_in_exps _n' _m' (mutable_lift_in_exps _n _m _arg)

  with mutable_lift_in_comm_exp_lift_in_comm_indep :
    forall (_arg : comm) (_n _m _n' _m' : nat),
      mutable_lift_in_comm _n _m (exp_lift_in_comm _n' _m' _arg) = 
      exp_lift_in_comm _n' _m' (mutable_lift_in_comm _n _m _arg)

  with mutable_lift_in_seq_exp_lift_in_seq_indep :
    forall (_arg : seq) (_n _m _n' _m' : nat),
      mutable_lift_in_seq _n _m (exp_lift_in_seq _n' _m' _arg) = 
      exp_lift_in_seq _n' _m' (mutable_lift_in_seq _n _m _arg)
  .
  Proof.
    (* case mutable_lift_in_exp_exp_lift_in_exp_indep *)
    Focus. clear mutable_lift_in_exp_exp_lift_in_exp_indep.
    induction _arg as [ x | x | n | n m s ];
      intros; 
        [ index_tac; simpl; try destruct le_lt_dec as [ ? | ? ]; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_lift_in_seq_exp_lift_in_seq_indep; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_exps_exp_lift_in_exps_indep *)
    Focus. clear mutable_lift_in_exps_exp_lift_in_exps_indep.
    induction _arg as [  | e es IHes ];
      intros; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_lift_in_exp_indep; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_comm_exp_lift_in_comm_indep *)
    Focus. clear mutable_lift_in_comm_exp_lift_in_comm_indep.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros; 
        [ simpl; simpl; try rewrite mutable_lift_in_exp_exp_lift_in_exp_indep; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_seq_exp_lift_in_seq_indep; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_lift_in_exp_indep; simpl; try rewrite mutable_lift_in_seq_exp_lift_in_seq_indep; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_lift_in_exp_indep; simpl; try rewrite mutable_lift_in_exps_exp_lift_in_exps_indep; simpl; crush_tac
        ];
      idtac.

    (* case mutable_lift_in_seq_exp_lift_in_seq_indep *)
    Focus. clear mutable_lift_in_seq_exp_lift_in_seq_indep.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_lift_in_exp_indep; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_lift_in_comm_exp_lift_in_comm_indep; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite mutable_lift_in_exp_exp_lift_in_exp_indep : LOOPW_database.

  Hint Rewrite mutable_lift_in_exps_exp_lift_in_exps_indep : LOOPW_database.

  Hint Rewrite mutable_lift_in_comm_exp_lift_in_comm_indep : LOOPW_database.

  Hint Rewrite mutable_lift_in_seq_exp_lift_in_seq_indep : LOOPW_database.

  Lemma mutable_lift_in_exp_exp_subst_in_exp_indep :
    forall (_arg : exp) (_n _m _p : nat) (_arg' : exp),
      mutable_lift_in_exp _n _m (exp_subst_in_exp _arg' _p _arg) = 
      exp_subst_in_exp (mutable_lift_in_exp _n _m _arg') _p (mutable_lift_in_exp _n _m _arg)

  with mutable_lift_in_exps_exp_subst_in_exps_indep :
    forall (_arg : exps) (_n _m _p : nat) (_arg' : exp),
      mutable_lift_in_exps _n _m (exp_subst_in_exps _arg' _p _arg) = 
      exp_subst_in_exps (mutable_lift_in_exp _n _m _arg') _p (mutable_lift_in_exps _n _m _arg)

  with mutable_lift_in_comm_exp_subst_in_comm_indep :
    forall (_arg : comm) (_n _m _p : nat) (_arg' : exp),
      mutable_lift_in_comm _n _m (exp_subst_in_comm _arg' _p _arg) = 
      exp_subst_in_comm (mutable_lift_in_exp _n _m _arg') _p (mutable_lift_in_comm _n _m _arg)

  with mutable_lift_in_seq_exp_subst_in_seq_indep :
    forall (_arg : seq) (_n _m _p : nat) (_arg' : exp),
      mutable_lift_in_seq _n _m (exp_subst_in_seq _arg' _p _arg) = 
      exp_subst_in_seq (mutable_lift_in_exp _n _m _arg') _p (mutable_lift_in_seq _n _m _arg)
  .
  Proof.
    (* case mutable_lift_in_exp_exp_subst_in_exp_indep *)
    Focus. clear mutable_lift_in_exp_exp_subst_in_exp_indep.
    induction _arg as [ x | x | n | n m s ];
      intros; 
        [ index_tac; simpl; try destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; try destruct le_lt_dec as [ ? | ? ]; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_lift_in_seq_exp_subst_in_seq_indep; crush_tac
        ];
      lift_lift_tac; crush_tac.

    (* case mutable_lift_in_exps_exp_subst_in_exps_indep *)
    Focus. clear mutable_lift_in_exps_exp_subst_in_exps_indep.
    induction _arg as [  | e es IHes ];
      intros; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_subst_in_exp_indep; simpl; try rewrite IHes; crush_tac
        ];
      lift_lift_tac; crush_tac.

    (* case mutable_lift_in_comm_exp_subst_in_comm_indep *)
    Focus. clear mutable_lift_in_comm_exp_subst_in_comm_indep.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros; 
        [ simpl; simpl; try rewrite mutable_lift_in_exp_exp_subst_in_exp_indep; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite mutable_lift_in_seq_exp_subst_in_seq_indep; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_subst_in_exp_indep; simpl; try rewrite mutable_lift_in_seq_exp_subst_in_seq_indep; crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_subst_in_exp_indep; simpl; try rewrite mutable_lift_in_exps_exp_subst_in_exps_indep; simpl; crush_tac
        ];
      lift_lift_tac; crush_tac.

    (* case mutable_lift_in_seq_exp_subst_in_seq_indep *)
    Focus. clear mutable_lift_in_seq_exp_subst_in_seq_indep.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros; 
        [ crush_tac
        | simpl; try rewrite mutable_lift_in_exp_exp_subst_in_exp_indep; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_lift_in_comm_exp_subst_in_comm_indep; simpl; try rewrite IHs; crush_tac
        ];
      lift_lift_tac; crush_tac.
  Qed.

  Hint Rewrite mutable_lift_in_exp_exp_subst_in_exp_indep : LOOPW_database.

  Hint Rewrite mutable_lift_in_exps_exp_subst_in_exps_indep : LOOPW_database.

  Hint Rewrite mutable_lift_in_comm_exp_subst_in_comm_indep : LOOPW_database.

  Hint Rewrite mutable_lift_in_seq_exp_subst_in_seq_indep : LOOPW_database.

  Lemma exp_lift_in_exp_mutable_subst_in_exp_indep :
    forall (_arg : exp) (_n _m _p : nat) (_arg' : mutable),
      exp_lift_in_exp _n _m (mutable_subst_in_exp _arg' _p _arg) = 
      mutable_subst_in_exp _arg' _p (exp_lift_in_exp _n _m _arg)

  with exp_lift_in_exps_mutable_subst_in_exps_indep :
    forall (_arg : exps) (_n _m _p : nat) (_arg' : mutable),
      exp_lift_in_exps _n _m (mutable_subst_in_exps _arg' _p _arg) = 
      mutable_subst_in_exps _arg' _p (exp_lift_in_exps _n _m _arg)

  with exp_lift_in_comm_mutable_subst_in_comm_indep :
    forall (_arg : comm) (_n _m _p : nat) (_arg' : mutable),
      exp_lift_in_comm _n _m (mutable_subst_in_comm _arg' _p _arg) = 
      mutable_subst_in_comm _arg' _p (exp_lift_in_comm _n _m _arg)

  with exp_lift_in_seq_mutable_subst_in_seq_indep :
    forall (_arg : seq) (_n _m _p : nat) (_arg' : mutable),
      exp_lift_in_seq _n _m (mutable_subst_in_seq _arg' _p _arg) = 
      mutable_subst_in_seq _arg' _p (exp_lift_in_seq _n _m _arg)
  .
  Proof.
    (* case exp_lift_in_exp_mutable_subst_in_exp_indep *)
    Focus. clear exp_lift_in_exp_mutable_subst_in_exp_indep.
    induction _arg as [ x | x | n | n m s ];
      intros; 
        [ index_tac; simpl; try destruct lt_eq_lt_dec as [ [ ? | ? ] | ? ]; try destruct le_lt_dec as [ ? | ? ]; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_lift_in_seq_mutable_subst_in_seq_indep; crush_tac
        ];
      lift_lift_tac; crush_tac.

    (* case exp_lift_in_exps_mutable_subst_in_exps_indep *)
    Focus. clear exp_lift_in_exps_mutable_subst_in_exps_indep.
    induction _arg as [  | e es IHes ];
      intros; 
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_mutable_subst_in_exp_indep; simpl; try rewrite IHes; crush_tac
        ];
      lift_lift_tac; crush_tac.

    (* case exp_lift_in_comm_mutable_subst_in_comm_indep *)
    Focus. clear exp_lift_in_comm_mutable_subst_in_comm_indep.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros; 
        [ simpl; simpl; try rewrite exp_lift_in_exp_mutable_subst_in_exp_indep; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_lift_in_seq_mutable_subst_in_seq_indep; crush_tac
        | simpl; try rewrite exp_lift_in_exp_mutable_subst_in_exp_indep; simpl; try rewrite exp_lift_in_seq_mutable_subst_in_seq_indep; crush_tac
        | simpl; try rewrite exp_lift_in_exp_mutable_subst_in_exp_indep; simpl; try rewrite exp_lift_in_exps_mutable_subst_in_exps_indep; simpl; crush_tac
        ];
      lift_lift_tac; crush_tac.

    (* case exp_lift_in_seq_mutable_subst_in_seq_indep *)
    Focus. clear exp_lift_in_seq_mutable_subst_in_seq_indep.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros; 
        [ crush_tac
        | simpl; try rewrite exp_lift_in_exp_mutable_subst_in_exp_indep; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_lift_in_comm_mutable_subst_in_comm_indep; simpl; try rewrite IHs; crush_tac
        ];
      lift_lift_tac; crush_tac.
  Qed.

  Hint Rewrite exp_lift_in_exp_mutable_subst_in_exp_indep : LOOPW_database.

  Hint Rewrite exp_lift_in_exps_mutable_subst_in_exps_indep : LOOPW_database.

  Hint Rewrite exp_lift_in_comm_mutable_subst_in_comm_indep : LOOPW_database.

  Hint Rewrite exp_lift_in_seq_mutable_subst_in_seq_indep : LOOPW_database.

  (** *** Interactions between lifting and substitution *)

  Lemma mutable_subst_in_mutable_mutable_lift_in_mutable_simpl :
    forall (_arg : mutable) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      mutable_subst_in_mutable _arg' _p (mutable_lift_in_mutable _n _m _arg) =
      mutable_lift_in_mutable (_n - 1) _m _arg

  with mutable_subst_in_mutables_mutable_lift_in_mutables_simpl :
    forall (_arg : mutables) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      mutable_subst_in_mutables _arg' _p (mutable_lift_in_mutables _n _m _arg) =
      mutable_lift_in_mutables (_n - 1) _m _arg
  .
  Proof.
    (* case mutable_subst_in_mutable_mutable_lift_in_mutable_simpl *)
    Focus. clear mutable_subst_in_mutable_mutable_lift_in_mutable_simpl.
    induction _arg as [ x ]; intros;
        [ index_tac; simpl; crush_tac
        ];
      idtac.

    (* case mutable_subst_in_mutables_mutable_lift_in_mutables_simpl *)
    Focus. clear mutable_subst_in_mutables_mutable_lift_in_mutables_simpl.
    induction _arg as [  | m ms IHms ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_simpl; simpl; try rewrite IHms; crush_tac
        ];
      idtac.
  Qed.


  Lemma mutable_subst_in_exp_mutable_lift_in_exp_simpl :
    forall (_arg : exp) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      mutable_subst_in_exp _arg' _p (mutable_lift_in_exp _n _m _arg) =
      mutable_lift_in_exp (_n - 1) _m _arg

  with mutable_subst_in_exps_mutable_lift_in_exps_simpl :
    forall (_arg : exps) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      mutable_subst_in_exps _arg' _p (mutable_lift_in_exps _n _m _arg) =
      mutable_lift_in_exps (_n - 1) _m _arg

  with mutable_subst_in_comm_mutable_lift_in_comm_simpl :
    forall (_arg : comm) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      mutable_subst_in_comm _arg' _p (mutable_lift_in_comm _n _m _arg) =
      mutable_lift_in_comm (_n - 1) _m _arg

  with mutable_subst_in_seq_mutable_lift_in_seq_simpl :
    forall (_arg : seq) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      mutable_subst_in_seq _arg' _p (mutable_lift_in_seq _n _m _arg) =
      mutable_lift_in_seq (_n - 1) _m _arg
  .
  Proof.
    (* case mutable_subst_in_exp_mutable_lift_in_exp_simpl *)
    Focus. clear mutable_subst_in_exp_mutable_lift_in_exp_simpl.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_simpl; crush_tac
        ];
      idtac.

    (* case mutable_subst_in_exps_mutable_lift_in_exps_simpl *)
    Focus. clear mutable_subst_in_exps_mutable_lift_in_exps_simpl.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case mutable_subst_in_comm_mutable_lift_in_comm_simpl *)
    Focus. clear mutable_subst_in_comm_mutable_lift_in_comm_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_simpl; simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite mutable_subst_in_exps_mutable_lift_in_exps_simpl; simpl; try rewrite mutable_subst_in_mutables_mutable_lift_in_mutables_simpl; crush_tac
        ];
      idtac.

    (* case mutable_subst_in_seq_mutable_lift_in_seq_simpl *)
    Focus. clear mutable_subst_in_seq_mutable_lift_in_seq_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_subst_in_comm_mutable_lift_in_comm_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.


  Lemma exp_subst_in_exp_exp_lift_in_exp_simpl :
    forall (_arg : exp) (_arg' : exp) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      exp_subst_in_exp _arg' _p (exp_lift_in_exp _n _m _arg) =
      exp_lift_in_exp (_n - 1) _m _arg

  with exp_subst_in_exps_exp_lift_in_exps_simpl :
    forall (_arg : exps) (_arg' : exp) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      exp_subst_in_exps _arg' _p (exp_lift_in_exps _n _m _arg) =
      exp_lift_in_exps (_n - 1) _m _arg

  with exp_subst_in_comm_exp_lift_in_comm_simpl :
    forall (_arg : comm) (_arg' : exp) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      exp_subst_in_comm _arg' _p (exp_lift_in_comm _n _m _arg) =
      exp_lift_in_comm (_n - 1) _m _arg

  with exp_subst_in_seq_exp_lift_in_seq_simpl :
    forall (_arg : seq) (_arg' : exp) (_n _m _p : nat),
      _m <= _p < _m + _n ->
      exp_subst_in_seq _arg' _p (exp_lift_in_seq _n _m _arg) =
      exp_lift_in_seq (_n - 1) _m _arg
  .
  Proof.
    (* case exp_subst_in_exp_exp_lift_in_exp_simpl *)
    Focus. clear exp_subst_in_exp_exp_lift_in_exp_simpl.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_simpl; crush_tac
        ];
      idtac.

    (* case exp_subst_in_exps_exp_lift_in_exps_simpl *)
    Focus. clear exp_subst_in_exps_exp_lift_in_exps_simpl.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case exp_subst_in_comm_exp_lift_in_comm_simpl *)
    Focus. clear exp_subst_in_comm_exp_lift_in_comm_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_simpl; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite exp_subst_in_exps_exp_lift_in_exps_simpl; simpl; crush_tac
        ];
      idtac.

    (* case exp_subst_in_seq_exp_lift_in_seq_simpl *)
    Focus. clear exp_subst_in_seq_exp_lift_in_seq_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_subst_in_comm_exp_lift_in_comm_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.


  Lemma mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl :
    forall (_arg : mutable) (_n _m : nat),
      0 < _n ->
      mutable_subst_in_mutable (id _m) _m (mutable_lift_in_mutable _n (S _m) _arg) =
      mutable_lift_in_mutable (_n - 1) (S _m) _arg

  with mutable_subst_in_mutables_mutable_lift_in_mutables_0_simpl :
    forall (_arg : mutables) (_n _m : nat),
      0 < _n ->
      mutable_subst_in_mutables (id _m) _m (mutable_lift_in_mutables _n (S _m) _arg) =
      mutable_lift_in_mutables (_n - 1) (S _m) _arg
  .
  Proof.
    (* case mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl *)
    Focus. clear mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl.
    induction _arg as [ x ]; intros;
        [ index_tac; simpl; crush_tac
        ];
      crush_tac.

    (* case mutable_subst_in_mutables_mutable_lift_in_mutables_0_simpl *)
    Focus. clear mutable_subst_in_mutables_mutable_lift_in_mutables_0_simpl.
    induction _arg as [  | m ms IHms ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl; simpl; try rewrite IHms; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma mutable_subst_in_exp_mutable_lift_in_exp_0_simpl :
    forall (_arg : exp) (_n _m : nat),
      0 < _n ->
      mutable_subst_in_exp (id _m) _m (mutable_lift_in_exp _n (S _m) _arg) =
      mutable_lift_in_exp (_n - 1) (S _m) _arg

  with mutable_subst_in_exps_mutable_lift_in_exps_0_simpl :
    forall (_arg : exps) (_n _m : nat),
      0 < _n ->
      mutable_subst_in_exps (id _m) _m (mutable_lift_in_exps _n (S _m) _arg) =
      mutable_lift_in_exps (_n - 1) (S _m) _arg

  with mutable_subst_in_comm_mutable_lift_in_comm_0_simpl :
    forall (_arg : comm) (_n _m : nat),
      0 < _n ->
      mutable_subst_in_comm (id _m) _m (mutable_lift_in_comm _n (S _m) _arg) =
      mutable_lift_in_comm (_n - 1) (S _m) _arg

  with mutable_subst_in_seq_mutable_lift_in_seq_0_simpl :
    forall (_arg : seq) (_n _m : nat),
      0 < _n ->
      mutable_subst_in_seq (id _m) _m (mutable_lift_in_seq _n (S _m) _arg) =
      mutable_lift_in_seq (_n - 1) (S _m) _arg
  .
  Proof.
    (* case mutable_subst_in_exp_mutable_lift_in_exp_0_simpl *)
    Focus. clear mutable_subst_in_exp_mutable_lift_in_exp_0_simpl.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_0_simpl; crush_tac
        ];
      crush_tac.

    (* case mutable_subst_in_exps_mutable_lift_in_exps_0_simpl *)
    Focus. clear mutable_subst_in_exps_mutable_lift_in_exps_0_simpl.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_0_simpl; simpl; try rewrite IHes; crush_tac
        ];
      crush_tac.

    (* case mutable_subst_in_comm_mutable_lift_in_comm_0_simpl *)
    Focus. clear mutable_subst_in_comm_mutable_lift_in_comm_0_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl; simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_0_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_0_simpl; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_0_simpl; simpl; try rewrite mutable_subst_in_exps_mutable_lift_in_exps_0_simpl; simpl; try rewrite mutable_subst_in_mutables_mutable_lift_in_mutables_0_simpl; crush_tac
        ];
      crush_tac.

    (* case mutable_subst_in_seq_mutable_lift_in_seq_0_simpl *)
    Focus. clear mutable_subst_in_seq_mutable_lift_in_seq_0_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_0_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_subst_in_comm_mutable_lift_in_comm_0_simpl; simpl; try rewrite IHs; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma exp_subst_in_exp_exp_lift_in_exp_0_simpl :
    forall (_arg : exp) (_n _m : nat),
      0 < _n ->
      exp_subst_in_exp (cvar _m) _m (exp_lift_in_exp _n (S _m) _arg) =
      exp_lift_in_exp (_n - 1) (S _m) _arg

  with exp_subst_in_exps_exp_lift_in_exps_0_simpl :
    forall (_arg : exps) (_n _m : nat),
      0 < _n ->
      exp_subst_in_exps (cvar _m) _m (exp_lift_in_exps _n (S _m) _arg) =
      exp_lift_in_exps (_n - 1) (S _m) _arg

  with exp_subst_in_comm_exp_lift_in_comm_0_simpl :
    forall (_arg : comm) (_n _m : nat),
      0 < _n ->
      exp_subst_in_comm (cvar _m) _m (exp_lift_in_comm _n (S _m) _arg) =
      exp_lift_in_comm (_n - 1) (S _m) _arg

  with exp_subst_in_seq_exp_lift_in_seq_0_simpl :
    forall (_arg : seq) (_n _m : nat),
      0 < _n ->
      exp_subst_in_seq (cvar _m) _m (exp_lift_in_seq _n (S _m) _arg) =
      exp_lift_in_seq (_n - 1) (S _m) _arg
  .
  Proof.
    (* case exp_subst_in_exp_exp_lift_in_exp_0_simpl *)
    Focus. clear exp_subst_in_exp_exp_lift_in_exp_0_simpl.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_0_simpl; crush_tac
        ];
      crush_tac.

    (* case exp_subst_in_exps_exp_lift_in_exps_0_simpl *)
    Focus. clear exp_subst_in_exps_exp_lift_in_exps_0_simpl.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_0_simpl; simpl; try rewrite IHes; crush_tac
        ];
      crush_tac.

    (* case exp_subst_in_comm_exp_lift_in_comm_0_simpl *)
    Focus. clear exp_subst_in_comm_exp_lift_in_comm_0_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_0_simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_0_simpl; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_0_simpl; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_0_simpl; simpl; try rewrite exp_subst_in_exps_exp_lift_in_exps_0_simpl; simpl; crush_tac
        ];
      crush_tac.

    (* case exp_subst_in_seq_exp_lift_in_seq_0_simpl *)
    Focus. clear exp_subst_in_seq_exp_lift_in_seq_0_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_0_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_subst_in_comm_exp_lift_in_comm_0_simpl; simpl; try rewrite IHs; crush_tac
        ];
      crush_tac.
  Qed.


  Lemma mutable_subst_in_mutable_mutable_lift_in_mutable_commut :
    forall (_arg : mutable) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p ->
      mutable_lift_in_mutable _n _m (mutable_subst_in_mutable _arg' _p _arg) =
      mutable_subst_in_mutable (mutable_lift_in_mutable _n _m _arg') (_p + _n) (mutable_lift_in_mutable _n _m _arg)

  with mutable_subst_in_mutables_mutable_lift_in_mutables_commut :
    forall (_arg : mutables) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p ->
      mutable_lift_in_mutables _n _m (mutable_subst_in_mutables _arg' _p _arg) =
      mutable_subst_in_mutables (mutable_lift_in_mutable _n _m _arg') (_p + _n) (mutable_lift_in_mutables _n _m _arg)
  .
  Proof.
    (* case mutable_subst_in_mutable_mutable_lift_in_mutable_commut *)
    Focus. clear mutable_subst_in_mutable_mutable_lift_in_mutable_commut.
    induction _arg as [ x ]; intros;
        [ index_tac; simpl; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_mutables_mutable_lift_in_mutables_commut *)
    Focus. clear mutable_subst_in_mutables_mutable_lift_in_mutables_commut.
    induction _arg as [  | m ms IHms ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_commut; simpl; try rewrite IHms; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma mutable_subst_in_exp_mutable_lift_in_exp_commut :
    forall (_arg : exp) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p ->
      mutable_lift_in_exp _n _m (mutable_subst_in_exp _arg' _p _arg) =
      mutable_subst_in_exp (mutable_lift_in_mutable _n _m _arg') (_p + _n) (mutable_lift_in_exp _n _m _arg)

  with mutable_subst_in_exps_mutable_lift_in_exps_commut :
    forall (_arg : exps) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p ->
      mutable_lift_in_exps _n _m (mutable_subst_in_exps _arg' _p _arg) =
      mutable_subst_in_exps (mutable_lift_in_mutable _n _m _arg') (_p + _n) (mutable_lift_in_exps _n _m _arg)

  with mutable_subst_in_comm_mutable_lift_in_comm_commut :
    forall (_arg : comm) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p ->
      mutable_lift_in_comm _n _m (mutable_subst_in_comm _arg' _p _arg) =
      mutable_subst_in_comm (mutable_lift_in_mutable _n _m _arg') (_p + _n) (mutable_lift_in_comm _n _m _arg)

  with mutable_subst_in_seq_mutable_lift_in_seq_commut :
    forall (_arg : seq) (_arg' : mutable) (_n _m _p : nat),
      _m <= _p ->
      mutable_lift_in_seq _n _m (mutable_subst_in_seq _arg' _p _arg) =
      mutable_subst_in_seq (mutable_lift_in_mutable _n _m _arg') (_p + _n) (mutable_lift_in_seq _n _m _arg)
  .
  Proof.
    (* case mutable_subst_in_exp_mutable_lift_in_exp_commut *)
    Focus. clear mutable_subst_in_exp_mutable_lift_in_exp_commut.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_commut; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_commut; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_exps_mutable_lift_in_exps_commut *)
    Focus. clear mutable_subst_in_exps_mutable_lift_in_exps_commut.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite IHes; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_comm_mutable_lift_in_comm_commut *)
    Focus. clear mutable_subst_in_comm_mutable_lift_in_comm_commut.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_commut; simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_commut; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_commut; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_commut; crush_tac
        | simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_commut; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_commut; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite mutable_subst_in_exps_mutable_lift_in_exps_commut; simpl; try rewrite mutable_subst_in_mutables_mutable_lift_in_mutables_commut; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_seq_mutable_lift_in_seq_commut *)
    Focus. clear mutable_subst_in_seq_mutable_lift_in_seq_commut.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_commut; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_subst_in_comm_mutable_lift_in_comm_commut; simpl; try rewrite IHs; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma exp_subst_in_exp_exp_lift_in_exp_commut :
    forall (_arg : exp) (_arg' : exp) (_n _m _p : nat),
      _m <= _p ->
      exp_lift_in_exp _n _m (exp_subst_in_exp _arg' _p _arg) =
      exp_subst_in_exp (exp_lift_in_exp _n _m _arg') (_p + _n) (exp_lift_in_exp _n _m _arg)

  with exp_subst_in_exps_exp_lift_in_exps_commut :
    forall (_arg : exps) (_arg' : exp) (_n _m _p : nat),
      _m <= _p ->
      exp_lift_in_exps _n _m (exp_subst_in_exps _arg' _p _arg) =
      exp_subst_in_exps (exp_lift_in_exp _n _m _arg') (_p + _n) (exp_lift_in_exps _n _m _arg)

  with exp_subst_in_comm_exp_lift_in_comm_commut :
    forall (_arg : comm) (_arg' : exp) (_n _m _p : nat),
      _m <= _p ->
      exp_lift_in_comm _n _m (exp_subst_in_comm _arg' _p _arg) =
      exp_subst_in_comm (exp_lift_in_exp _n _m _arg') (_p + _n) (exp_lift_in_comm _n _m _arg)

  with exp_subst_in_seq_exp_lift_in_seq_commut :
    forall (_arg : seq) (_arg' : exp) (_n _m _p : nat),
      _m <= _p ->
      exp_lift_in_seq _n _m (exp_subst_in_seq _arg' _p _arg) =
      exp_subst_in_seq (exp_lift_in_exp _n _m _arg') (_p + _n) (exp_lift_in_seq _n _m _arg)
  .
  Proof.
    (* case exp_subst_in_exp_exp_lift_in_exp_commut *)
    Focus. clear exp_subst_in_exp_exp_lift_in_exp_commut.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_commut; crush_tac
        ];
      lift_tac; crush_tac.

    (* case exp_subst_in_exps_exp_lift_in_exps_commut *)
    Focus. clear exp_subst_in_exps_exp_lift_in_exps_commut.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_commut; simpl; try rewrite IHes; crush_tac
        ];
      lift_tac; crush_tac.

    (* case exp_subst_in_comm_exp_lift_in_comm_commut *)
    Focus. clear exp_subst_in_comm_exp_lift_in_comm_commut.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_commut; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_commut; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_commut; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_commut; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_commut; simpl; try rewrite exp_subst_in_exps_exp_lift_in_exps_commut; simpl; crush_tac
        ];
      lift_tac; crush_tac.

    (* case exp_subst_in_seq_exp_lift_in_seq_commut *)
    Focus. clear exp_subst_in_seq_exp_lift_in_seq_commut.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_commut; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_subst_in_comm_exp_lift_in_comm_commut; simpl; try rewrite IHs; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma mutable_subst_in_mutable_mutable_lift_in_mutable_distrib :
    forall (_arg : mutable) (_arg' : mutable) (_n _m _p : nat),
      _p <= _m ->
      mutable_lift_in_mutable _n _m (mutable_subst_in_mutable _arg' _p _arg) =
      mutable_subst_in_mutable (mutable_lift_in_mutable _n _m _arg') _p (mutable_lift_in_mutable _n (S _m) _arg)

  with mutable_subst_in_mutables_mutable_lift_in_mutables_distrib :
    forall (_arg : mutables) (_arg' : mutable) (_n _m _p : nat),
      _p <= _m ->
      mutable_lift_in_mutables _n _m (mutable_subst_in_mutables _arg' _p _arg) =
      mutable_subst_in_mutables (mutable_lift_in_mutable _n _m _arg') _p (mutable_lift_in_mutables _n (S _m) _arg)
  .
  Proof.
    (* case mutable_subst_in_mutable_mutable_lift_in_mutable_distrib *)
    Focus. clear mutable_subst_in_mutable_mutable_lift_in_mutable_distrib.
    induction _arg as [ x ]; intros;
        [ index_tac; simpl; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_mutables_mutable_lift_in_mutables_distrib *)
    Focus. clear mutable_subst_in_mutables_mutable_lift_in_mutables_distrib.
    induction _arg as [  | m ms IHms ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_distrib; simpl; try rewrite IHms; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma mutable_subst_in_exp_mutable_lift_in_exp_distrib :
    forall (_arg : exp) (_arg' : mutable) (_n _m _p : nat),
      _p <= _m ->
      mutable_lift_in_exp _n _m (mutable_subst_in_exp _arg' _p _arg) =
      mutable_subst_in_exp (mutable_lift_in_mutable _n _m _arg') _p (mutable_lift_in_exp _n (S _m) _arg)

  with mutable_subst_in_exps_mutable_lift_in_exps_distrib :
    forall (_arg : exps) (_arg' : mutable) (_n _m _p : nat),
      _p <= _m ->
      mutable_lift_in_exps _n _m (mutable_subst_in_exps _arg' _p _arg) =
      mutable_subst_in_exps (mutable_lift_in_mutable _n _m _arg') _p (mutable_lift_in_exps _n (S _m) _arg)

  with mutable_subst_in_comm_mutable_lift_in_comm_distrib :
    forall (_arg : comm) (_arg' : mutable) (_n _m _p : nat),
      _p <= _m ->
      mutable_lift_in_comm _n _m (mutable_subst_in_comm _arg' _p _arg) =
      mutable_subst_in_comm (mutable_lift_in_mutable _n _m _arg') _p (mutable_lift_in_comm _n (S _m) _arg)

  with mutable_subst_in_seq_mutable_lift_in_seq_distrib :
    forall (_arg : seq) (_arg' : mutable) (_n _m _p : nat),
      _p <= _m ->
      mutable_lift_in_seq _n _m (mutable_subst_in_seq _arg' _p _arg) =
      mutable_subst_in_seq (mutable_lift_in_mutable _n _m _arg') _p (mutable_lift_in_seq _n (S _m) _arg)
  .
  Proof.
    (* case mutable_subst_in_exp_mutable_lift_in_exp_distrib *)
    Focus. clear mutable_subst_in_exp_mutable_lift_in_exp_distrib.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_distrib; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_distrib; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_exps_mutable_lift_in_exps_distrib *)
    Focus. clear mutable_subst_in_exps_mutable_lift_in_exps_distrib.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_distrib; simpl; try rewrite IHes; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_comm_mutable_lift_in_comm_distrib *)
    Focus. clear mutable_subst_in_comm_mutable_lift_in_comm_distrib.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_distrib; simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_lift_in_mutable_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_distrib; simpl; try rewrite mutable_subst_in_seq_mutable_lift_in_seq_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_distrib; simpl; try rewrite mutable_subst_in_exps_mutable_lift_in_exps_distrib; simpl; try rewrite mutable_subst_in_mutables_mutable_lift_in_mutables_distrib; crush_tac
        ];
      lift_tac; crush_tac.

    (* case mutable_subst_in_seq_mutable_lift_in_seq_distrib *)
    Focus. clear mutable_subst_in_seq_mutable_lift_in_seq_distrib.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_lift_in_exp_distrib; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_subst_in_comm_mutable_lift_in_comm_distrib; simpl; try rewrite IHs; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Lemma exp_subst_in_exp_exp_lift_in_exp_distrib :
    forall (_arg : exp) (_arg' : exp) (_n _m _p : nat),
      _p <= _m ->
      exp_lift_in_exp _n _m (exp_subst_in_exp _arg' _p _arg) =
      exp_subst_in_exp (exp_lift_in_exp _n _m _arg') _p (exp_lift_in_exp _n (S _m) _arg)

  with exp_subst_in_exps_exp_lift_in_exps_distrib :
    forall (_arg : exps) (_arg' : exp) (_n _m _p : nat),
      _p <= _m ->
      exp_lift_in_exps _n _m (exp_subst_in_exps _arg' _p _arg) =
      exp_subst_in_exps (exp_lift_in_exp _n _m _arg') _p (exp_lift_in_exps _n (S _m) _arg)

  with exp_subst_in_comm_exp_lift_in_comm_distrib :
    forall (_arg : comm) (_arg' : exp) (_n _m _p : nat),
      _p <= _m ->
      exp_lift_in_comm _n _m (exp_subst_in_comm _arg' _p _arg) =
      exp_subst_in_comm (exp_lift_in_exp _n _m _arg') _p (exp_lift_in_comm _n (S _m) _arg)

  with exp_subst_in_seq_exp_lift_in_seq_distrib :
    forall (_arg : seq) (_arg' : exp) (_n _m _p : nat),
      _p <= _m ->
      exp_lift_in_seq _n _m (exp_subst_in_seq _arg' _p _arg) =
      exp_subst_in_seq (exp_lift_in_exp _n _m _arg') _p (exp_lift_in_seq _n (S _m) _arg)
  .
  Proof.
    (* case exp_subst_in_exp_exp_lift_in_exp_distrib *)
    Focus. clear exp_subst_in_exp_exp_lift_in_exp_distrib.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_distrib; crush_tac
        ];
      lift_tac; crush_tac.

    (* case exp_subst_in_exps_exp_lift_in_exps_distrib *)
    Focus. clear exp_subst_in_exps_exp_lift_in_exps_distrib.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_distrib; simpl; try rewrite IHes; crush_tac
        ];
      lift_tac; crush_tac.

    (* case exp_subst_in_comm_exp_lift_in_comm_distrib *)
    Focus. clear exp_subst_in_comm_exp_lift_in_comm_distrib.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_distrib; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_distrib; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_distrib; simpl; try rewrite exp_subst_in_seq_exp_lift_in_seq_distrib; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_distrib; simpl; try rewrite exp_subst_in_exps_exp_lift_in_exps_distrib; simpl; crush_tac
        ];
      lift_tac; crush_tac.

    (* case exp_subst_in_seq_exp_lift_in_seq_distrib *)
    Focus. clear exp_subst_in_seq_exp_lift_in_seq_distrib.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_lift_in_exp_distrib; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_subst_in_comm_exp_lift_in_comm_distrib; simpl; try rewrite IHs; crush_tac
        ];
      lift_tac; crush_tac.
  Qed.


  Ltac subst_lift_tac :=
    repeat
      match goal with
        | [ |- context [ mutable_subst_in_mutable ?v ?p (mutable_lift_in_mutable ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable v p (mutable_lift_in_mutable n m t) =
             mutable_lift_in_mutable (n - 1) m t);
            [ | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_simpl t v n m p); cfail ])
        | [ H : context [ mutable_subst_in_mutable ?v ?p (mutable_lift_in_mutable ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable v p (mutable_lift_in_mutable n m t) =
             mutable_lift_in_mutable (n - 1) m t) in H;
            [ | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_simpl t v n m p); cfail ])
        | [ |- context [ mutable_subst_in_mutables ?v ?p (mutable_lift_in_mutables ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutables v p (mutable_lift_in_mutables n m t) =
             mutable_lift_in_mutables (n - 1) m t);
            [ | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_simpl t v n m p); cfail ])
        | [ H : context [ mutable_subst_in_mutables ?v ?p (mutable_lift_in_mutables ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutables v p (mutable_lift_in_mutables n m t) =
             mutable_lift_in_mutables (n - 1) m t) in H;
            [ | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_simpl t v n m p); cfail ])
        | [ |- context [ mutable_subst_in_exp ?v ?p (mutable_lift_in_exp ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_exp v p (mutable_lift_in_exp n m t) =
             mutable_lift_in_exp (n - 1) m t);
            [ | apply (mutable_subst_in_exp_mutable_lift_in_exp_simpl t v n m p); cfail ])
        | [ H : context [ mutable_subst_in_exp ?v ?p (mutable_lift_in_exp ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_exp v p (mutable_lift_in_exp n m t) =
             mutable_lift_in_exp (n - 1) m t) in H;
            [ | apply (mutable_subst_in_exp_mutable_lift_in_exp_simpl t v n m p); cfail ])
        | [ |- context [ mutable_subst_in_exps ?v ?p (mutable_lift_in_exps ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_exps v p (mutable_lift_in_exps n m t) =
             mutable_lift_in_exps (n - 1) m t);
            [ | apply (mutable_subst_in_exps_mutable_lift_in_exps_simpl t v n m p); cfail ])
        | [ H : context [ mutable_subst_in_exps ?v ?p (mutable_lift_in_exps ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_exps v p (mutable_lift_in_exps n m t) =
             mutable_lift_in_exps (n - 1) m t) in H;
            [ | apply (mutable_subst_in_exps_mutable_lift_in_exps_simpl t v n m p); cfail ])
        | [ |- context [ mutable_subst_in_comm ?v ?p (mutable_lift_in_comm ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_comm v p (mutable_lift_in_comm n m t) =
             mutable_lift_in_comm (n - 1) m t);
            [ | apply (mutable_subst_in_comm_mutable_lift_in_comm_simpl t v n m p); cfail ])
        | [ H : context [ mutable_subst_in_comm ?v ?p (mutable_lift_in_comm ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_comm v p (mutable_lift_in_comm n m t) =
             mutable_lift_in_comm (n - 1) m t) in H;
            [ | apply (mutable_subst_in_comm_mutable_lift_in_comm_simpl t v n m p); cfail ])
        | [ |- context [ mutable_subst_in_seq ?v ?p (mutable_lift_in_seq ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_seq v p (mutable_lift_in_seq n m t) =
             mutable_lift_in_seq (n - 1) m t);
            [ | apply (mutable_subst_in_seq_mutable_lift_in_seq_simpl t v n m p); cfail ])
        | [ H : context [ mutable_subst_in_seq ?v ?p (mutable_lift_in_seq ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_seq v p (mutable_lift_in_seq n m t) =
             mutable_lift_in_seq (n - 1) m t) in H;
            [ | apply (mutable_subst_in_seq_mutable_lift_in_seq_simpl t v n m p); cfail ])
        | [ |- context [ exp_subst_in_exp ?v ?p (exp_lift_in_exp ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exp v p (exp_lift_in_exp n m t) =
             exp_lift_in_exp (n - 1) m t);
            [ | apply (exp_subst_in_exp_exp_lift_in_exp_simpl t v n m p); cfail ])
        | [ H : context [ exp_subst_in_exp ?v ?p (exp_lift_in_exp ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exp v p (exp_lift_in_exp n m t) =
             exp_lift_in_exp (n - 1) m t) in H;
            [ | apply (exp_subst_in_exp_exp_lift_in_exp_simpl t v n m p); cfail ])
        | [ |- context [ exp_subst_in_exps ?v ?p (exp_lift_in_exps ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exps v p (exp_lift_in_exps n m t) =
             exp_lift_in_exps (n - 1) m t);
            [ | apply (exp_subst_in_exps_exp_lift_in_exps_simpl t v n m p); cfail ])
        | [ H : context [ exp_subst_in_exps ?v ?p (exp_lift_in_exps ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exps v p (exp_lift_in_exps n m t) =
             exp_lift_in_exps (n - 1) m t) in H;
            [ | apply (exp_subst_in_exps_exp_lift_in_exps_simpl t v n m p); cfail ])
        | [ |- context [ exp_subst_in_comm ?v ?p (exp_lift_in_comm ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_comm v p (exp_lift_in_comm n m t) =
             exp_lift_in_comm (n - 1) m t);
            [ | apply (exp_subst_in_comm_exp_lift_in_comm_simpl t v n m p); cfail ])
        | [ H : context [ exp_subst_in_comm ?v ?p (exp_lift_in_comm ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_comm v p (exp_lift_in_comm n m t) =
             exp_lift_in_comm (n - 1) m t) in H;
            [ | apply (exp_subst_in_comm_exp_lift_in_comm_simpl t v n m p); cfail ])
        | [ |- context [ exp_subst_in_seq ?v ?p (exp_lift_in_seq ?n ?m ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_seq v p (exp_lift_in_seq n m t) =
             exp_lift_in_seq (n - 1) m t);
            [ | apply (exp_subst_in_seq_exp_lift_in_seq_simpl t v n m p); cfail ])
        | [ H : context [ exp_subst_in_seq ?v ?p (exp_lift_in_seq ?n ?m ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_seq v p (exp_lift_in_seq n m t) =
             exp_lift_in_seq (n - 1) m t) in H;
            [ | apply (exp_subst_in_seq_exp_lift_in_seq_simpl t v n m p); cfail ])
        | [ |- context [ mutable_subst_in_mutable (id ?m) ?m (mutable_lift_in_mutable ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable (id m) m (mutable_lift_in_mutable n (S m) t) =
             mutable_lift_in_mutable (n - 1) (S m) t);
            [ | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl t n m); cfail ])
        | [ H : context [ mutable_subst_in_mutable (id ?m) ?m (mutable_lift_in_mutable ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable (id m) m (mutable_lift_in_mutable n (S m) t) =
             mutable_lift_in_mutable (n - 1) (S m) t) in H;
            [ | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_0_simpl t n m); cfail ])
        | [ |- context [ mutable_subst_in_mutables (id ?m) ?m (mutable_lift_in_mutables ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutables (id m) m (mutable_lift_in_mutables n (S m) t) =
             mutable_lift_in_mutables (n - 1) (S m) t);
            [ | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_0_simpl t n m); cfail ])
        | [ H : context [ mutable_subst_in_mutables (id ?m) ?m (mutable_lift_in_mutables ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutables (id m) m (mutable_lift_in_mutables n (S m) t) =
             mutable_lift_in_mutables (n - 1) (S m) t) in H;
            [ | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_0_simpl t n m); cfail ])
        | [ |- context [ mutable_subst_in_exp (id ?m) ?m (mutable_lift_in_exp ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_exp (id m) m (mutable_lift_in_exp n (S m) t) =
             mutable_lift_in_exp (n - 1) (S m) t);
            [ | apply (mutable_subst_in_exp_mutable_lift_in_exp_0_simpl t n m); cfail ])
        | [ H : context [ mutable_subst_in_exp (id ?m) ?m (mutable_lift_in_exp ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_exp (id m) m (mutable_lift_in_exp n (S m) t) =
             mutable_lift_in_exp (n - 1) (S m) t) in H;
            [ | apply (mutable_subst_in_exp_mutable_lift_in_exp_0_simpl t n m); cfail ])
        | [ |- context [ mutable_subst_in_exps (id ?m) ?m (mutable_lift_in_exps ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_exps (id m) m (mutable_lift_in_exps n (S m) t) =
             mutable_lift_in_exps (n - 1) (S m) t);
            [ | apply (mutable_subst_in_exps_mutable_lift_in_exps_0_simpl t n m); cfail ])
        | [ H : context [ mutable_subst_in_exps (id ?m) ?m (mutable_lift_in_exps ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_exps (id m) m (mutable_lift_in_exps n (S m) t) =
             mutable_lift_in_exps (n - 1) (S m) t) in H;
            [ | apply (mutable_subst_in_exps_mutable_lift_in_exps_0_simpl t n m); cfail ])
        | [ |- context [ mutable_subst_in_comm (id ?m) ?m (mutable_lift_in_comm ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_comm (id m) m (mutable_lift_in_comm n (S m) t) =
             mutable_lift_in_comm (n - 1) (S m) t);
            [ | apply (mutable_subst_in_comm_mutable_lift_in_comm_0_simpl t n m); cfail ])
        | [ H : context [ mutable_subst_in_comm (id ?m) ?m (mutable_lift_in_comm ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_comm (id m) m (mutable_lift_in_comm n (S m) t) =
             mutable_lift_in_comm (n - 1) (S m) t) in H;
            [ | apply (mutable_subst_in_comm_mutable_lift_in_comm_0_simpl t n m); cfail ])
        | [ |- context [ mutable_subst_in_seq (id ?m) ?m (mutable_lift_in_seq ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_seq (id m) m (mutable_lift_in_seq n (S m) t) =
             mutable_lift_in_seq (n - 1) (S m) t);
            [ | apply (mutable_subst_in_seq_mutable_lift_in_seq_0_simpl t n m); cfail ])
        | [ H : context [ mutable_subst_in_seq (id ?m) ?m (mutable_lift_in_seq ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_seq (id m) m (mutable_lift_in_seq n (S m) t) =
             mutable_lift_in_seq (n - 1) (S m) t) in H;
            [ | apply (mutable_subst_in_seq_mutable_lift_in_seq_0_simpl t n m); cfail ])
        | [ |- context [ exp_subst_in_exp (cvar ?m) ?m (exp_lift_in_exp ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exp (cvar m) m (exp_lift_in_exp n (S m) t) =
             exp_lift_in_exp (n - 1) (S m) t);
            [ | apply (exp_subst_in_exp_exp_lift_in_exp_0_simpl t n m); cfail ])
        | [ H : context [ exp_subst_in_exp (cvar ?m) ?m (exp_lift_in_exp ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exp (cvar m) m (exp_lift_in_exp n (S m) t) =
             exp_lift_in_exp (n - 1) (S m) t) in H;
            [ | apply (exp_subst_in_exp_exp_lift_in_exp_0_simpl t n m); cfail ])
        | [ |- context [ exp_subst_in_exps (cvar ?m) ?m (exp_lift_in_exps ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exps (cvar m) m (exp_lift_in_exps n (S m) t) =
             exp_lift_in_exps (n - 1) (S m) t);
            [ | apply (exp_subst_in_exps_exp_lift_in_exps_0_simpl t n m); cfail ])
        | [ H : context [ exp_subst_in_exps (cvar ?m) ?m (exp_lift_in_exps ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exps (cvar m) m (exp_lift_in_exps n (S m) t) =
             exp_lift_in_exps (n - 1) (S m) t) in H;
            [ | apply (exp_subst_in_exps_exp_lift_in_exps_0_simpl t n m); cfail ])
        | [ |- context [ exp_subst_in_comm (cvar ?m) ?m (exp_lift_in_comm ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_comm (cvar m) m (exp_lift_in_comm n (S m) t) =
             exp_lift_in_comm (n - 1) (S m) t);
            [ | apply (exp_subst_in_comm_exp_lift_in_comm_0_simpl t n m); cfail ])
        | [ H : context [ exp_subst_in_comm (cvar ?m) ?m (exp_lift_in_comm ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_comm (cvar m) m (exp_lift_in_comm n (S m) t) =
             exp_lift_in_comm (n - 1) (S m) t) in H;
            [ | apply (exp_subst_in_comm_exp_lift_in_comm_0_simpl t n m); cfail ])
        | [ |- context [ exp_subst_in_seq (cvar ?m) ?m (exp_lift_in_seq ?n (S ?m) ?t) ] ] =>
          (cutrewrite ->
            (exp_subst_in_seq (cvar m) m (exp_lift_in_seq n (S m) t) =
             exp_lift_in_seq (n - 1) (S m) t);
            [ | apply (exp_subst_in_seq_exp_lift_in_seq_0_simpl t n m); cfail ])
        | [ H : context [ exp_subst_in_seq (cvar ?m) ?m (exp_lift_in_seq ?n (S ?m) ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_seq (cvar m) m (exp_lift_in_seq n (S m) t) =
             exp_lift_in_seq (n - 1) (S m) t) in H;
            [ | apply (exp_subst_in_seq_exp_lift_in_seq_0_simpl t n m); cfail ])
        | [ |- context [ mutable_lift_in_mutable ?n ?m (mutable_subst_in_mutable ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_subst_in_mutable v p t) =
             mutable_subst_in_mutable (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutable n m t));
            [ cfail | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_subst_in_mutable v p t) =
             mutable_subst_in_mutable (mutable_lift_in_mutable n m v) p (mutable_lift_in_mutable n (S m) t));
            [ cfail | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_subst_in_mutable v p t) =
             mutable_subst_in_mutable (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutable n m t));
            [ | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_commut t v n m p); cfail ])
        | [ H : context [ mutable_lift_in_mutable ?n ?m (mutable_subst_in_mutable ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_subst_in_mutable v p t) =
             mutable_subst_in_mutable (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutable n m t)) in H;
            [ cfail | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_subst_in_mutable v p t) =
             mutable_subst_in_mutable (mutable_lift_in_mutable n m v) p (mutable_lift_in_mutable n (S m) t)) in H;
            [ cfail | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutable n m (mutable_subst_in_mutable v p t) =
             mutable_subst_in_mutable (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutable n m t)) in H;
            [ | apply (mutable_subst_in_mutable_mutable_lift_in_mutable_commut t v n m p); cfail ])
        | [ |- context [ mutable_lift_in_mutables ?n ?m (mutable_subst_in_mutables ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_subst_in_mutables v p t) =
             mutable_subst_in_mutables (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutables n m t));
            [ cfail | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_subst_in_mutables v p t) =
             mutable_subst_in_mutables (mutable_lift_in_mutable n m v) p (mutable_lift_in_mutables n (S m) t));
            [ cfail | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_subst_in_mutables v p t) =
             mutable_subst_in_mutables (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutables n m t));
            [ | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_commut t v n m p); cfail ])
        | [ H : context [ mutable_lift_in_mutables ?n ?m (mutable_subst_in_mutables ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_subst_in_mutables v p t) =
             mutable_subst_in_mutables (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutables n m t)) in H;
            [ cfail | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_subst_in_mutables v p t) =
             mutable_subst_in_mutables (mutable_lift_in_mutable n m v) p (mutable_lift_in_mutables n (S m) t)) in H;
            [ cfail | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_mutables n m (mutable_subst_in_mutables v p t) =
             mutable_subst_in_mutables (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_mutables n m t)) in H;
            [ | apply (mutable_subst_in_mutables_mutable_lift_in_mutables_commut t v n m p); cfail ])
        | [ |- context [ mutable_lift_in_exp ?n ?m (mutable_subst_in_exp ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_subst_in_exp v p t) =
             mutable_subst_in_exp (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exp n m t));
            [ cfail | apply (mutable_subst_in_exp_mutable_lift_in_exp_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_subst_in_exp v p t) =
             mutable_subst_in_exp (mutable_lift_in_mutable n m v) p (mutable_lift_in_exp n (S m) t));
            [ cfail | apply (mutable_subst_in_exp_mutable_lift_in_exp_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_subst_in_exp v p t) =
             mutable_subst_in_exp (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exp n m t));
            [ | apply (mutable_subst_in_exp_mutable_lift_in_exp_commut t v n m p); cfail ])
        | [ H : context [ mutable_lift_in_exp ?n ?m (mutable_subst_in_exp ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_subst_in_exp v p t) =
             mutable_subst_in_exp (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exp n m t)) in H;
            [ cfail | apply (mutable_subst_in_exp_mutable_lift_in_exp_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_subst_in_exp v p t) =
             mutable_subst_in_exp (mutable_lift_in_mutable n m v) p (mutable_lift_in_exp n (S m) t)) in H;
            [ cfail | apply (mutable_subst_in_exp_mutable_lift_in_exp_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exp n m (mutable_subst_in_exp v p t) =
             mutable_subst_in_exp (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exp n m t)) in H;
            [ | apply (mutable_subst_in_exp_mutable_lift_in_exp_commut t v n m p); cfail ])
        | [ |- context [ mutable_lift_in_exps ?n ?m (mutable_subst_in_exps ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_subst_in_exps v p t) =
             mutable_subst_in_exps (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exps n m t));
            [ cfail | apply (mutable_subst_in_exps_mutable_lift_in_exps_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_subst_in_exps v p t) =
             mutable_subst_in_exps (mutable_lift_in_mutable n m v) p (mutable_lift_in_exps n (S m) t));
            [ cfail | apply (mutable_subst_in_exps_mutable_lift_in_exps_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_subst_in_exps v p t) =
             mutable_subst_in_exps (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exps n m t));
            [ | apply (mutable_subst_in_exps_mutable_lift_in_exps_commut t v n m p); cfail ])
        | [ H : context [ mutable_lift_in_exps ?n ?m (mutable_subst_in_exps ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_subst_in_exps v p t) =
             mutable_subst_in_exps (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exps n m t)) in H;
            [ cfail | apply (mutable_subst_in_exps_mutable_lift_in_exps_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_subst_in_exps v p t) =
             mutable_subst_in_exps (mutable_lift_in_mutable n m v) p (mutable_lift_in_exps n (S m) t)) in H;
            [ cfail | apply (mutable_subst_in_exps_mutable_lift_in_exps_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_exps n m (mutable_subst_in_exps v p t) =
             mutable_subst_in_exps (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_exps n m t)) in H;
            [ | apply (mutable_subst_in_exps_mutable_lift_in_exps_commut t v n m p); cfail ])
        | [ |- context [ mutable_lift_in_comm ?n ?m (mutable_subst_in_comm ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_subst_in_comm v p t) =
             mutable_subst_in_comm (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_comm n m t));
            [ cfail | apply (mutable_subst_in_comm_mutable_lift_in_comm_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_subst_in_comm v p t) =
             mutable_subst_in_comm (mutable_lift_in_mutable n m v) p (mutable_lift_in_comm n (S m) t));
            [ cfail | apply (mutable_subst_in_comm_mutable_lift_in_comm_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_subst_in_comm v p t) =
             mutable_subst_in_comm (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_comm n m t));
            [ | apply (mutable_subst_in_comm_mutable_lift_in_comm_commut t v n m p); cfail ])
        | [ H : context [ mutable_lift_in_comm ?n ?m (mutable_subst_in_comm ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_subst_in_comm v p t) =
             mutable_subst_in_comm (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_comm n m t)) in H;
            [ cfail | apply (mutable_subst_in_comm_mutable_lift_in_comm_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_subst_in_comm v p t) =
             mutable_subst_in_comm (mutable_lift_in_mutable n m v) p (mutable_lift_in_comm n (S m) t)) in H;
            [ cfail | apply (mutable_subst_in_comm_mutable_lift_in_comm_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_comm n m (mutable_subst_in_comm v p t) =
             mutable_subst_in_comm (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_comm n m t)) in H;
            [ | apply (mutable_subst_in_comm_mutable_lift_in_comm_commut t v n m p); cfail ])
        | [ |- context [ mutable_lift_in_seq ?n ?m (mutable_subst_in_seq ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_subst_in_seq v p t) =
             mutable_subst_in_seq (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_seq n m t));
            [ cfail | apply (mutable_subst_in_seq_mutable_lift_in_seq_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_subst_in_seq v p t) =
             mutable_subst_in_seq (mutable_lift_in_mutable n m v) p (mutable_lift_in_seq n (S m) t));
            [ cfail | apply (mutable_subst_in_seq_mutable_lift_in_seq_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_subst_in_seq v p t) =
             mutable_subst_in_seq (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_seq n m t));
            [ | apply (mutable_subst_in_seq_mutable_lift_in_seq_commut t v n m p); cfail ])
        | [ H : context [ mutable_lift_in_seq ?n ?m (mutable_subst_in_seq ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_subst_in_seq v p t) =
             mutable_subst_in_seq (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_seq n m t)) in H;
            [ cfail | apply (mutable_subst_in_seq_mutable_lift_in_seq_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_subst_in_seq v p t) =
             mutable_subst_in_seq (mutable_lift_in_mutable n m v) p (mutable_lift_in_seq n (S m) t)) in H;
            [ cfail | apply (mutable_subst_in_seq_mutable_lift_in_seq_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (mutable_lift_in_seq n m (mutable_subst_in_seq v p t) =
             mutable_subst_in_seq (mutable_lift_in_mutable n m v) (p + n) (mutable_lift_in_seq n m t)) in H;
            [ | apply (mutable_subst_in_seq_mutable_lift_in_seq_commut t v n m p); cfail ])
        | [ |- context [ exp_lift_in_exp ?n ?m (exp_subst_in_exp ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_subst_in_exp v p t) =
             exp_subst_in_exp (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exp n m t));
            [ cfail | apply (exp_subst_in_exp_exp_lift_in_exp_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_subst_in_exp v p t) =
             exp_subst_in_exp (exp_lift_in_exp n m v) p (exp_lift_in_exp n (S m) t));
            [ cfail | apply (exp_subst_in_exp_exp_lift_in_exp_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_subst_in_exp v p t) =
             exp_subst_in_exp (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exp n m t));
            [ | apply (exp_subst_in_exp_exp_lift_in_exp_commut t v n m p); cfail ])
        | [ H : context [ exp_lift_in_exp ?n ?m (exp_subst_in_exp ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_subst_in_exp v p t) =
             exp_subst_in_exp (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exp n m t)) in H;
            [ cfail | apply (exp_subst_in_exp_exp_lift_in_exp_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_subst_in_exp v p t) =
             exp_subst_in_exp (exp_lift_in_exp n m v) p (exp_lift_in_exp n (S m) t)) in H;
            [ cfail | apply (exp_subst_in_exp_exp_lift_in_exp_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exp n m (exp_subst_in_exp v p t) =
             exp_subst_in_exp (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exp n m t)) in H;
            [ | apply (exp_subst_in_exp_exp_lift_in_exp_commut t v n m p); cfail ])
        | [ |- context [ exp_lift_in_exps ?n ?m (exp_subst_in_exps ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_subst_in_exps v p t) =
             exp_subst_in_exps (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exps n m t));
            [ cfail | apply (exp_subst_in_exps_exp_lift_in_exps_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_subst_in_exps v p t) =
             exp_subst_in_exps (exp_lift_in_exp n m v) p (exp_lift_in_exps n (S m) t));
            [ cfail | apply (exp_subst_in_exps_exp_lift_in_exps_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_subst_in_exps v p t) =
             exp_subst_in_exps (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exps n m t));
            [ | apply (exp_subst_in_exps_exp_lift_in_exps_commut t v n m p); cfail ])
        | [ H : context [ exp_lift_in_exps ?n ?m (exp_subst_in_exps ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_subst_in_exps v p t) =
             exp_subst_in_exps (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exps n m t)) in H;
            [ cfail | apply (exp_subst_in_exps_exp_lift_in_exps_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_subst_in_exps v p t) =
             exp_subst_in_exps (exp_lift_in_exp n m v) p (exp_lift_in_exps n (S m) t)) in H;
            [ cfail | apply (exp_subst_in_exps_exp_lift_in_exps_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_exps n m (exp_subst_in_exps v p t) =
             exp_subst_in_exps (exp_lift_in_exp n m v) (p + n) (exp_lift_in_exps n m t)) in H;
            [ | apply (exp_subst_in_exps_exp_lift_in_exps_commut t v n m p); cfail ])
        | [ |- context [ exp_lift_in_comm ?n ?m (exp_subst_in_comm ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_subst_in_comm v p t) =
             exp_subst_in_comm (exp_lift_in_exp n m v) (p + n) (exp_lift_in_comm n m t));
            [ cfail | apply (exp_subst_in_comm_exp_lift_in_comm_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_subst_in_comm v p t) =
             exp_subst_in_comm (exp_lift_in_exp n m v) p (exp_lift_in_comm n (S m) t));
            [ cfail | apply (exp_subst_in_comm_exp_lift_in_comm_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_subst_in_comm v p t) =
             exp_subst_in_comm (exp_lift_in_exp n m v) (p + n) (exp_lift_in_comm n m t));
            [ | apply (exp_subst_in_comm_exp_lift_in_comm_commut t v n m p); cfail ])
        | [ H : context [ exp_lift_in_comm ?n ?m (exp_subst_in_comm ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_subst_in_comm v p t) =
             exp_subst_in_comm (exp_lift_in_exp n m v) (p + n) (exp_lift_in_comm n m t)) in H;
            [ cfail | apply (exp_subst_in_comm_exp_lift_in_comm_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_subst_in_comm v p t) =
             exp_subst_in_comm (exp_lift_in_exp n m v) p (exp_lift_in_comm n (S m) t)) in H;
            [ cfail | apply (exp_subst_in_comm_exp_lift_in_comm_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_comm n m (exp_subst_in_comm v p t) =
             exp_subst_in_comm (exp_lift_in_exp n m v) (p + n) (exp_lift_in_comm n m t)) in H;
            [ | apply (exp_subst_in_comm_exp_lift_in_comm_commut t v n m p); cfail ])
        | [ |- context [ exp_lift_in_seq ?n ?m (exp_subst_in_seq ?v ?p ?t) ] ] =>
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_subst_in_seq v p t) =
             exp_subst_in_seq (exp_lift_in_exp n m v) (p + n) (exp_lift_in_seq n m t));
            [ cfail | apply (exp_subst_in_seq_exp_lift_in_seq_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_subst_in_seq v p t) =
             exp_subst_in_seq (exp_lift_in_exp n m v) p (exp_lift_in_seq n (S m) t));
            [ cfail | apply (exp_subst_in_seq_exp_lift_in_seq_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_subst_in_seq v p t) =
             exp_subst_in_seq (exp_lift_in_exp n m v) (p + n) (exp_lift_in_seq n m t));
            [ | apply (exp_subst_in_seq_exp_lift_in_seq_commut t v n m p); cfail ])
        | [ H : context [ exp_lift_in_seq ?n ?m (exp_subst_in_seq ?v ?p ?t) ] |- _ ] =>
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_subst_in_seq v p t) =
             exp_subst_in_seq (exp_lift_in_exp n m v) (p + n) (exp_lift_in_seq n m t)) in H;
            [ cfail | apply (exp_subst_in_seq_exp_lift_in_seq_commut t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_subst_in_seq v p t) =
             exp_subst_in_seq (exp_lift_in_exp n m v) p (exp_lift_in_seq n (S m) t)) in H;
            [ cfail | apply (exp_subst_in_seq_exp_lift_in_seq_distrib t v n m p); cfail ]) ||
          (cutrewrite ->
            (exp_lift_in_seq n m (exp_subst_in_seq v p t) =
             exp_subst_in_seq (exp_lift_in_exp n m v) (p + n) (exp_lift_in_seq n m t)) in H;
            [ | apply (exp_subst_in_seq_exp_lift_in_seq_commut t v n m p); cfail ])
      end; crush_tac.

  (** *** Substitution lemma *)

  Lemma mutable_subst_in_mutable_mutable_subst_in_mutable_distrib :
    forall (_arg : mutable) (_arg' _arg'' : mutable) (_n _m : nat),
      _m <= _n ->
      mutable_subst_in_mutable _arg' _n (mutable_subst_in_mutable _arg'' _m _arg) =
      mutable_subst_in_mutable (mutable_subst_in_mutable _arg' _n _arg'') _m (mutable_subst_in_mutable (mutable_lift_in_mutable 1 _m _arg') (S _n) _arg)

  with mutable_subst_in_mutables_mutable_subst_in_mutables_distrib :
    forall (_arg : mutables) (_arg' _arg'' : mutable) (_n _m : nat),
      _m <= _n ->
      mutable_subst_in_mutables _arg' _n (mutable_subst_in_mutables _arg'' _m _arg) =
      mutable_subst_in_mutables (mutable_subst_in_mutable _arg' _n _arg'') _m (mutable_subst_in_mutables (mutable_lift_in_mutable 1 _m _arg') (S _n) _arg)
  .
  Proof.
    (* case mutable_subst_in_mutable_mutable_subst_in_mutable_distrib *)
    Focus. clear mutable_subst_in_mutable_mutable_subst_in_mutable_distrib.
    induction _arg as [ x ]; intros;
        [ index_tac; simpl; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case mutable_subst_in_mutables_mutable_subst_in_mutables_distrib *)
    Focus. clear mutable_subst_in_mutables_mutable_subst_in_mutables_distrib.
    induction _arg as [  | m ms IHms ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_subst_in_mutable_distrib; simpl; try rewrite IHms; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.
  Qed.


  Lemma mutable_subst_in_exp_mutable_subst_in_exp_distrib :
    forall (_arg : exp) (_arg' _arg'' : mutable) (_n _m : nat),
      _m <= _n ->
      mutable_subst_in_exp _arg' _n (mutable_subst_in_exp _arg'' _m _arg) =
      mutable_subst_in_exp (mutable_subst_in_mutable _arg' _n _arg'') _m (mutable_subst_in_exp (mutable_lift_in_mutable 1 _m _arg') (S _n) _arg)

  with mutable_subst_in_exps_mutable_subst_in_exps_distrib :
    forall (_arg : exps) (_arg' _arg'' : mutable) (_n _m : nat),
      _m <= _n ->
      mutable_subst_in_exps _arg' _n (mutable_subst_in_exps _arg'' _m _arg) =
      mutable_subst_in_exps (mutable_subst_in_mutable _arg' _n _arg'') _m (mutable_subst_in_exps (mutable_lift_in_mutable 1 _m _arg') (S _n) _arg)

  with mutable_subst_in_comm_mutable_subst_in_comm_distrib :
    forall (_arg : comm) (_arg' _arg'' : mutable) (_n _m : nat),
      _m <= _n ->
      mutable_subst_in_comm _arg' _n (mutable_subst_in_comm _arg'' _m _arg) =
      mutable_subst_in_comm (mutable_subst_in_mutable _arg' _n _arg'') _m (mutable_subst_in_comm (mutable_lift_in_mutable 1 _m _arg') (S _n) _arg)

  with mutable_subst_in_seq_mutable_subst_in_seq_distrib :
    forall (_arg : seq) (_arg' _arg'' : mutable) (_n _m : nat),
      _m <= _n ->
      mutable_subst_in_seq _arg' _n (mutable_subst_in_seq _arg'' _m _arg) =
      mutable_subst_in_seq (mutable_subst_in_mutable _arg' _n _arg'') _m (mutable_subst_in_seq (mutable_lift_in_mutable 1 _m _arg') (S _n) _arg)
  .
  Proof.
    (* case mutable_subst_in_exp_mutable_subst_in_exp_distrib *)
    Focus. clear mutable_subst_in_exp_mutable_subst_in_exp_distrib.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_subst_in_mutable_distrib; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_subst_in_seq_mutable_subst_in_seq_distrib; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case mutable_subst_in_exps_mutable_subst_in_exps_distrib *)
    Focus. clear mutable_subst_in_exps_mutable_subst_in_exps_distrib.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_subst_in_exp_distrib; simpl; try rewrite IHes; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case mutable_subst_in_comm_mutable_subst_in_comm_distrib *)
    Focus. clear mutable_subst_in_comm_mutable_subst_in_comm_distrib.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; try rewrite mutable_subst_in_mutable_mutable_subst_in_mutable_distrib; simpl; try rewrite mutable_subst_in_exp_mutable_subst_in_exp_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_subst_in_mutable_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_mutable_mutable_subst_in_mutable_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_seq_mutable_subst_in_seq_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_subst_in_exp_distrib; simpl; try rewrite mutable_subst_in_seq_mutable_subst_in_seq_distrib; crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_subst_in_exp_distrib; simpl; try rewrite mutable_subst_in_exps_mutable_subst_in_exps_distrib; simpl; try rewrite mutable_subst_in_mutables_mutable_subst_in_mutables_distrib; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case mutable_subst_in_seq_mutable_subst_in_seq_distrib *)
    Focus. clear mutable_subst_in_seq_mutable_subst_in_seq_distrib.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite mutable_subst_in_exp_mutable_subst_in_exp_distrib; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_subst_in_comm_mutable_subst_in_comm_distrib; simpl; try rewrite IHs; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.
  Qed.


  Lemma exp_subst_in_exp_exp_subst_in_exp_distrib :
    forall (_arg : exp) (_arg' _arg'' : exp) (_n _m : nat),
      _m <= _n ->
      exp_subst_in_exp _arg' _n (exp_subst_in_exp _arg'' _m _arg) =
      exp_subst_in_exp (exp_subst_in_exp _arg' _n _arg'') _m (exp_subst_in_exp (exp_lift_in_exp 1 _m _arg') (S _n) _arg)

  with exp_subst_in_exps_exp_subst_in_exps_distrib :
    forall (_arg : exps) (_arg' _arg'' : exp) (_n _m : nat),
      _m <= _n ->
      exp_subst_in_exps _arg' _n (exp_subst_in_exps _arg'' _m _arg) =
      exp_subst_in_exps (exp_subst_in_exp _arg' _n _arg'') _m (exp_subst_in_exps (exp_lift_in_exp 1 _m _arg') (S _n) _arg)

  with exp_subst_in_comm_exp_subst_in_comm_distrib :
    forall (_arg : comm) (_arg' _arg'' : exp) (_n _m : nat),
      _m <= _n ->
      exp_subst_in_comm _arg' _n (exp_subst_in_comm _arg'' _m _arg) =
      exp_subst_in_comm (exp_subst_in_exp _arg' _n _arg'') _m (exp_subst_in_comm (exp_lift_in_exp 1 _m _arg') (S _n) _arg)

  with exp_subst_in_seq_exp_subst_in_seq_distrib :
    forall (_arg : seq) (_arg' _arg'' : exp) (_n _m : nat),
      _m <= _n ->
      exp_subst_in_seq _arg' _n (exp_subst_in_seq _arg'' _m _arg) =
      exp_subst_in_seq (exp_subst_in_exp _arg' _n _arg'') _m (exp_subst_in_seq (exp_lift_in_exp 1 _m _arg') (S _n) _arg)
  .
  Proof.
    (* case exp_subst_in_exp_exp_subst_in_exp_distrib *)
    Focus. clear exp_subst_in_exp_exp_subst_in_exp_distrib.
    induction _arg as [ x | x | n | n m s ]; intros;
        [ index_tac; simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_subst_in_seq_exp_subst_in_seq_distrib; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case exp_subst_in_exps_exp_subst_in_exps_distrib *)
    Focus. clear exp_subst_in_exps_exp_subst_in_exps_distrib.
    induction _arg as [  | e es IHes ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_subst_in_exp_distrib; simpl; try rewrite IHes; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case exp_subst_in_comm_exp_subst_in_comm_distrib *)
    Focus. clear exp_subst_in_comm_exp_subst_in_comm_distrib.
    induction _arg as [ x e | x | x | s | e s | p es ms ]; intros;
        [ simpl; simpl; try rewrite exp_subst_in_exp_exp_subst_in_exp_distrib; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_subst_in_seq_exp_subst_in_seq_distrib; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_subst_in_exp_distrib; simpl; try rewrite exp_subst_in_seq_exp_subst_in_seq_distrib; crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_subst_in_exp_distrib; simpl; try rewrite exp_subst_in_exps_exp_subst_in_exps_distrib; simpl; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.

    (* case exp_subst_in_seq_exp_subst_in_seq_distrib *)
    Focus. clear exp_subst_in_seq_exp_subst_in_seq_distrib.
    induction _arg as [  | e s IHs | s IHs | c s IHs ]; intros;
        [ crush_tac
        | simpl; try rewrite exp_subst_in_exp_exp_subst_in_exp_distrib; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_subst_in_comm_exp_subst_in_comm_distrib; simpl; try rewrite IHs; crush_tac
        ];
      subst_lift_tac; lift_lift_tac; crush_tac.
  Qed.


  Ltac subst_subst_tac :=
    repeat
      match goal with
        | [ |- context [ mutable_subst_in_mutable ?b ?n (mutable_subst_in_mutable ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable b n (mutable_subst_in_mutable c m a) =
             mutable_subst_in_mutable (mutable_subst_in_mutable b n c) m (mutable_subst_in_mutable (mutable_lift_in_mutable 1 m b) (S n) a));
            [ | apply (mutable_subst_in_mutable_mutable_subst_in_mutable_distrib a b c n m); cfail ])
        | [ H : context [ mutable_subst_in_mutable ?b ?n (mutable_subst_in_mutable ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutable b n (mutable_subst_in_mutable c m a) =
             mutable_subst_in_mutable (mutable_subst_in_mutable b n c) m (mutable_subst_in_mutable (mutable_lift_in_mutable 1 m b) (S n) a)) in H;
            [ | apply (mutable_subst_in_mutable_mutable_subst_in_mutable_distrib a b c n m); cfail ])
        | [ |- context [ mutable_subst_in_mutables ?b ?n (mutable_subst_in_mutables ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_mutables b n (mutable_subst_in_mutables c m a) =
             mutable_subst_in_mutables (mutable_subst_in_mutable b n c) m (mutable_subst_in_mutables (mutable_lift_in_mutable 1 m b) (S n) a));
            [ | apply (mutable_subst_in_mutables_mutable_subst_in_mutables_distrib a b c n m); cfail ])
        | [ H : context [ mutable_subst_in_mutables ?b ?n (mutable_subst_in_mutables ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_mutables b n (mutable_subst_in_mutables c m a) =
             mutable_subst_in_mutables (mutable_subst_in_mutable b n c) m (mutable_subst_in_mutables (mutable_lift_in_mutable 1 m b) (S n) a)) in H;
            [ | apply (mutable_subst_in_mutables_mutable_subst_in_mutables_distrib a b c n m); cfail ])
        | [ |- context [ mutable_subst_in_exp ?b ?n (mutable_subst_in_exp ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_exp b n (mutable_subst_in_exp c m a) =
             mutable_subst_in_exp (mutable_subst_in_mutable b n c) m (mutable_subst_in_exp (mutable_lift_in_mutable 1 m b) (S n) a));
            [ | apply (mutable_subst_in_exp_mutable_subst_in_exp_distrib a b c n m); cfail ])
        | [ H : context [ mutable_subst_in_exp ?b ?n (mutable_subst_in_exp ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_exp b n (mutable_subst_in_exp c m a) =
             mutable_subst_in_exp (mutable_subst_in_mutable b n c) m (mutable_subst_in_exp (mutable_lift_in_mutable 1 m b) (S n) a)) in H;
            [ | apply (mutable_subst_in_exp_mutable_subst_in_exp_distrib a b c n m); cfail ])
        | [ |- context [ mutable_subst_in_exps ?b ?n (mutable_subst_in_exps ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_exps b n (mutable_subst_in_exps c m a) =
             mutable_subst_in_exps (mutable_subst_in_mutable b n c) m (mutable_subst_in_exps (mutable_lift_in_mutable 1 m b) (S n) a));
            [ | apply (mutable_subst_in_exps_mutable_subst_in_exps_distrib a b c n m); cfail ])
        | [ H : context [ mutable_subst_in_exps ?b ?n (mutable_subst_in_exps ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_exps b n (mutable_subst_in_exps c m a) =
             mutable_subst_in_exps (mutable_subst_in_mutable b n c) m (mutable_subst_in_exps (mutable_lift_in_mutable 1 m b) (S n) a)) in H;
            [ | apply (mutable_subst_in_exps_mutable_subst_in_exps_distrib a b c n m); cfail ])
        | [ |- context [ mutable_subst_in_comm ?b ?n (mutable_subst_in_comm ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_comm b n (mutable_subst_in_comm c m a) =
             mutable_subst_in_comm (mutable_subst_in_mutable b n c) m (mutable_subst_in_comm (mutable_lift_in_mutable 1 m b) (S n) a));
            [ | apply (mutable_subst_in_comm_mutable_subst_in_comm_distrib a b c n m); cfail ])
        | [ H : context [ mutable_subst_in_comm ?b ?n (mutable_subst_in_comm ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_comm b n (mutable_subst_in_comm c m a) =
             mutable_subst_in_comm (mutable_subst_in_mutable b n c) m (mutable_subst_in_comm (mutable_lift_in_mutable 1 m b) (S n) a)) in H;
            [ | apply (mutable_subst_in_comm_mutable_subst_in_comm_distrib a b c n m); cfail ])
        | [ |- context [ mutable_subst_in_seq ?b ?n (mutable_subst_in_seq ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (mutable_subst_in_seq b n (mutable_subst_in_seq c m a) =
             mutable_subst_in_seq (mutable_subst_in_mutable b n c) m (mutable_subst_in_seq (mutable_lift_in_mutable 1 m b) (S n) a));
            [ | apply (mutable_subst_in_seq_mutable_subst_in_seq_distrib a b c n m); cfail ])
        | [ H : context [ mutable_subst_in_seq ?b ?n (mutable_subst_in_seq ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (mutable_subst_in_seq b n (mutable_subst_in_seq c m a) =
             mutable_subst_in_seq (mutable_subst_in_mutable b n c) m (mutable_subst_in_seq (mutable_lift_in_mutable 1 m b) (S n) a)) in H;
            [ | apply (mutable_subst_in_seq_mutable_subst_in_seq_distrib a b c n m); cfail ])
        | [ |- context [ exp_subst_in_exp ?b ?n (exp_subst_in_exp ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exp b n (exp_subst_in_exp c m a) =
             exp_subst_in_exp (exp_subst_in_exp b n c) m (exp_subst_in_exp (exp_lift_in_exp 1 m b) (S n) a));
            [ | apply (exp_subst_in_exp_exp_subst_in_exp_distrib a b c n m); cfail ])
        | [ H : context [ exp_subst_in_exp ?b ?n (exp_subst_in_exp ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exp b n (exp_subst_in_exp c m a) =
             exp_subst_in_exp (exp_subst_in_exp b n c) m (exp_subst_in_exp (exp_lift_in_exp 1 m b) (S n) a)) in H;
            [ | apply (exp_subst_in_exp_exp_subst_in_exp_distrib a b c n m); cfail ])
        | [ |- context [ exp_subst_in_exps ?b ?n (exp_subst_in_exps ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (exp_subst_in_exps b n (exp_subst_in_exps c m a) =
             exp_subst_in_exps (exp_subst_in_exp b n c) m (exp_subst_in_exps (exp_lift_in_exp 1 m b) (S n) a));
            [ | apply (exp_subst_in_exps_exp_subst_in_exps_distrib a b c n m); cfail ])
        | [ H : context [ exp_subst_in_exps ?b ?n (exp_subst_in_exps ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_exps b n (exp_subst_in_exps c m a) =
             exp_subst_in_exps (exp_subst_in_exp b n c) m (exp_subst_in_exps (exp_lift_in_exp 1 m b) (S n) a)) in H;
            [ | apply (exp_subst_in_exps_exp_subst_in_exps_distrib a b c n m); cfail ])
        | [ |- context [ exp_subst_in_comm ?b ?n (exp_subst_in_comm ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (exp_subst_in_comm b n (exp_subst_in_comm c m a) =
             exp_subst_in_comm (exp_subst_in_exp b n c) m (exp_subst_in_comm (exp_lift_in_exp 1 m b) (S n) a));
            [ | apply (exp_subst_in_comm_exp_subst_in_comm_distrib a b c n m); cfail ])
        | [ H : context [ exp_subst_in_comm ?b ?n (exp_subst_in_comm ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_comm b n (exp_subst_in_comm c m a) =
             exp_subst_in_comm (exp_subst_in_exp b n c) m (exp_subst_in_comm (exp_lift_in_exp 1 m b) (S n) a)) in H;
            [ | apply (exp_subst_in_comm_exp_subst_in_comm_distrib a b c n m); cfail ])
        | [ |- context [ exp_subst_in_seq ?b ?n (exp_subst_in_seq ?c ?m ?a) ] ] =>
          (cutrewrite ->
            (exp_subst_in_seq b n (exp_subst_in_seq c m a) =
             exp_subst_in_seq (exp_subst_in_exp b n c) m (exp_subst_in_seq (exp_lift_in_exp 1 m b) (S n) a));
            [ | apply (exp_subst_in_seq_exp_subst_in_seq_distrib a b c n m); cfail ])
        | [ H : context [ exp_subst_in_seq ?b ?n (exp_subst_in_seq ?c ?m ?a) ] |- _ ] =>
          (cutrewrite ->
            (exp_subst_in_seq b n (exp_subst_in_seq c m a) =
             exp_subst_in_seq (exp_subst_in_exp b n c) m (exp_subst_in_seq (exp_lift_in_exp 1 m b) (S n) a)) in H;
            [ | apply (exp_subst_in_seq_exp_subst_in_seq_distrib a b c n m); cfail ])
      end; crush_tac.

  Ltac subst_tac :=
    crush_tac;
    repeat (progress (subst_index_tac || subst_lift_tac || subst_subst_tac)).


  (** ** Free variables permutation properties *)

  Lemma mutable_fv_permut_in_mutable_id_dec :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
    { prod (prod (_m <= _p) ((_p - _m) < List.length _l)) (mutable_fv_permut_in_mutable _k _l _m (id _p) = id (_m + List.nth (_p - _m) _l 0)) } +
    { prod (prod (_m <= _p) (List.length _l <= (_p - _m))) (mutable_fv_permut_in_mutable _k _l _m (id _p) = id (_p + _k)) } +
    { prod (_p < _m) (mutable_fv_permut_in_mutable _k _l _m (id _p) = id _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _mutable_fv_permut_in_mutable_id_dec_tac k l m p :=
    let Hcomp := fresh "Hcomp" in
       let Hcomp' := fresh "Hcomp'" in
          let Hfun := fresh "Hfun" in
            destruct (mutable_fv_permut_in_mutable_id_dec k l m p) as
              [ [ [ [ Hcomp Hcomp' ] Hfun ] | [ [ Hcomp Hcomp' ] Hfun ] ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.

  Lemma exp_fv_permut_in_exp_cvar_dec :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
    { prod (prod (_m <= _p) ((_p - _m) < List.length _l)) (exp_fv_permut_in_exp _k _l _m (cvar _p) = cvar (_m + List.nth (_p - _m) _l 0)) } +
    { prod (prod (_m <= _p) (List.length _l <= (_p - _m))) (exp_fv_permut_in_exp _k _l _m (cvar _p) = cvar (_p + _k)) } +
    { prod (_p < _m) (exp_fv_permut_in_exp _k _l _m (cvar _p) = cvar _p) }.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; subst; simpl; auto.
  Qed.

  Ltac _exp_fv_permut_in_exp_cvar_dec_tac k l m p :=
    let Hcomp := fresh "Hcomp" in
       let Hcomp' := fresh "Hcomp'" in
          let Hfun := fresh "Hfun" in
            destruct (exp_fv_permut_in_exp_cvar_dec k l m p) as
              [ [ [ [ Hcomp Hcomp' ] Hfun ] | [ [ Hcomp Hcomp' ] Hfun ] ] | [ Hcomp Hfun ] ];
              rewrite ?Hfun in *; clear Hfun.


  Ltac fv_permut_index_dec_tac :=
    match goal with
      | [ |- context [ mutable_fv_permut_in_mutable ?k ?l ?m (id ?p) ] ] =>
        _mutable_fv_permut_in_mutable_id_dec_tac k l m p

      | [ H : context [ mutable_fv_permut_in_mutable ?k ?l ?m (id ?p) ] |- _ ] =>
        _mutable_fv_permut_in_mutable_id_dec_tac k l m p

      | [ |- context [ exp_fv_permut_in_exp ?k ?l ?m (cvar ?p) ] ] =>
        _exp_fv_permut_in_exp_cvar_dec_tac k l m p

      | [ H : context [ exp_fv_permut_in_exp ?k ?l ?m (cvar ?p) ] |- _ ] =>
        _exp_fv_permut_in_exp_cvar_dec_tac k l m p

    end.

  Lemma mutable_fv_permut_in_mutable_id_le_le :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> List.length _l <= (_p - _m) -> mutable_fv_permut_in_mutable _k _l _m (id _p) = id (_p + _k).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma mutable_fv_permut_in_mutable_id_le_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> (_p - _m) < List.length _l -> mutable_fv_permut_in_mutable _k _l _m (id _p) = id (_m + List.nth (_p - _m) _l 0).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma mutable_fv_permut_in_mutable_id_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _p < _m -> mutable_fv_permut_in_mutable _k _l _m (id _p) = id _p.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma exp_fv_permut_in_exp_cvar_le_le :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> List.length _l <= (_p - _m) -> exp_fv_permut_in_exp _k _l _m (cvar _p) = cvar (_p + _k).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma exp_fv_permut_in_exp_cvar_le_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _m <= _p -> (_p - _m) < List.length _l -> exp_fv_permut_in_exp _k _l _m (cvar _p) = cvar (_m + List.nth (_p - _m) _l 0).
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.

  Lemma exp_fv_permut_in_exp_cvar_lt :
    forall (_k : nat) (_l : list nat) (_m _p : nat),
      _p < _m -> exp_fv_permut_in_exp _k _l _m (cvar _p) = cvar _p.
  Proof.
    intros; simpl; destruct le_lt_dec; try destruct le_lt_dec; f_equal; omega.
  Qed.


  Ltac fv_permut_index_tac :=
    repeat match goal with
      | [ |- context [ mutable_fv_permut_in_mutable ?k ?l ?m (id ?p) ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m (id p) = id (p + k));
            [ | apply (mutable_fv_permut_in_mutable_id_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m (id p) = id (m + List.nth (p - m) l 0));
            [ | apply (mutable_fv_permut_in_mutable_id_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m (id p) = id p);
            [ | apply (mutable_fv_permut_in_mutable_id_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ H : context [ mutable_fv_permut_in_mutable ?k ?l ?m (id ?p) ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m (id p) = id (p + k)) in H;
            [ | apply (mutable_fv_permut_in_mutable_id_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m (id p) = id (m + List.nth (p - m) l 0)) in H;
            [ | apply (mutable_fv_permut_in_mutable_id_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m (id p) = id p) in H;
            [ | apply (mutable_fv_permut_in_mutable_id_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ |- context [ exp_fv_permut_in_exp ?k ?l ?m (cvar ?p) ] ] =>
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m (cvar p) = cvar (p + k));
            [ | apply (exp_fv_permut_in_exp_cvar_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m (cvar p) = cvar (m + List.nth (p - m) l 0));
            [ | apply (exp_fv_permut_in_exp_cvar_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m (cvar p) = cvar p);
            [ | apply (exp_fv_permut_in_exp_cvar_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

      | [ H : context [ exp_fv_permut_in_exp ?k ?l ?m (cvar ?p) ] |- _ ] =>
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m (cvar p) = cvar (p + k)) in H;
            [ | apply (exp_fv_permut_in_exp_cvar_le_le k l m p); cfail ]) ||
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m (cvar p) = cvar (m + List.nth (p - m) l 0)) in H;
            [ | apply (exp_fv_permut_in_exp_cvar_le_lt k l m p); cfail ]) ||
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m (cvar p) = cvar p) in H;
            [ | apply (exp_fv_permut_in_exp_cvar_lt k l m p); cfail ]) ||
          fv_permut_index_dec_tac

    end.

  (** *** Identity free variables permutation simplification *)

  Lemma mutable_fv_permut_in_mutable_id_simpl :
    forall (_k : nat) (_arg : mutable) (_m _n : nat),
      mutable_fv_permut_in_mutable _k (List.seq 0 _n) _m _arg = mutable_lift_in_mutable _k (_m + _n) _arg

  with mutable_fv_permut_in_mutables_id_simpl :
    forall (_k : nat) (_arg : mutables) (_m _n : nat),
      mutable_fv_permut_in_mutables _k (List.seq 0 _n) _m _arg = mutable_lift_in_mutables _k (_m + _n) _arg
  .
  Proof.
    (* case mutable_fv_permut_in_mutable_id_simpl *)
    Focus. clear mutable_fv_permut_in_mutable_id_simpl.
    induction _arg as [ x ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        ];
      idtac.

    (* case mutable_fv_permut_in_mutables_id_simpl *)
    Focus. clear mutable_fv_permut_in_mutables_id_simpl.
    induction _arg as [  | m ms IHms ];
      intros _m _n;
        [ crush_tac
        | simpl; try rewrite mutable_fv_permut_in_mutable_id_simpl; simpl; try rewrite IHms; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite mutable_fv_permut_in_mutable_id_simpl : LOOPW_database.

  Hint Rewrite mutable_fv_permut_in_mutables_id_simpl : LOOPW_database.

  Lemma mutable_fv_permut_in_exp_id_simpl :
    forall (_k : nat) (_arg : exp) (_m _n : nat),
      mutable_fv_permut_in_exp _k (List.seq 0 _n) _m _arg = mutable_lift_in_exp _k (_m + _n) _arg

  with mutable_fv_permut_in_exps_id_simpl :
    forall (_k : nat) (_arg : exps) (_m _n : nat),
      mutable_fv_permut_in_exps _k (List.seq 0 _n) _m _arg = mutable_lift_in_exps _k (_m + _n) _arg

  with mutable_fv_permut_in_comm_id_simpl :
    forall (_k : nat) (_arg : comm) (_m _n : nat),
      mutable_fv_permut_in_comm _k (List.seq 0 _n) _m _arg = mutable_lift_in_comm _k (_m + _n) _arg

  with mutable_fv_permut_in_seq_id_simpl :
    forall (_k : nat) (_arg : seq) (_m _n : nat),
      mutable_fv_permut_in_seq _k (List.seq 0 _n) _m _arg = mutable_lift_in_seq _k (_m + _n) _arg
  .
  Proof.
    (* case mutable_fv_permut_in_exp_id_simpl *)
    Focus. clear mutable_fv_permut_in_exp_id_simpl.
    induction _arg as [ x | x | n | n m s ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        | simpl; try rewrite mutable_fv_permut_in_mutable_id_simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite mutable_fv_permut_in_seq_id_simpl; crush_tac
        ];
      idtac.

    (* case mutable_fv_permut_in_exps_id_simpl *)
    Focus. clear mutable_fv_permut_in_exps_id_simpl.
    induction _arg as [  | e es IHes ];
      intros _m _n;
        [ crush_tac
        | simpl; try rewrite mutable_fv_permut_in_exp_id_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case mutable_fv_permut_in_comm_id_simpl *)
    Focus. clear mutable_fv_permut_in_comm_id_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros _m _n;
        [ simpl; try rewrite mutable_fv_permut_in_mutable_id_simpl; simpl; try rewrite mutable_fv_permut_in_exp_id_simpl; crush_tac
        | simpl; try rewrite mutable_fv_permut_in_mutable_id_simpl; crush_tac
        | simpl; try rewrite mutable_fv_permut_in_mutable_id_simpl; crush_tac
        | simpl; try rewrite mutable_fv_permut_in_seq_id_simpl; crush_tac
        | simpl; try rewrite mutable_fv_permut_in_exp_id_simpl; simpl; try rewrite mutable_fv_permut_in_seq_id_simpl; crush_tac
        | simpl; try rewrite mutable_fv_permut_in_exp_id_simpl; simpl; try rewrite mutable_fv_permut_in_exps_id_simpl; simpl; try rewrite mutable_fv_permut_in_mutables_id_simpl; crush_tac
        ];
      idtac.

    (* case mutable_fv_permut_in_seq_id_simpl *)
    Focus. clear mutable_fv_permut_in_seq_id_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros _m _n;
        [ crush_tac
        | simpl; try rewrite mutable_fv_permut_in_exp_id_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite mutable_fv_permut_in_comm_id_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite mutable_fv_permut_in_exp_id_simpl : LOOPW_database.

  Hint Rewrite mutable_fv_permut_in_exps_id_simpl : LOOPW_database.

  Hint Rewrite mutable_fv_permut_in_comm_id_simpl : LOOPW_database.

  Hint Rewrite mutable_fv_permut_in_seq_id_simpl : LOOPW_database.

  Lemma exp_fv_permut_in_exp_id_simpl :
    forall (_k : nat) (_arg : exp) (_m _n : nat),
      exp_fv_permut_in_exp _k (List.seq 0 _n) _m _arg = exp_lift_in_exp _k (_m + _n) _arg

  with exp_fv_permut_in_exps_id_simpl :
    forall (_k : nat) (_arg : exps) (_m _n : nat),
      exp_fv_permut_in_exps _k (List.seq 0 _n) _m _arg = exp_lift_in_exps _k (_m + _n) _arg

  with exp_fv_permut_in_comm_id_simpl :
    forall (_k : nat) (_arg : comm) (_m _n : nat),
      exp_fv_permut_in_comm _k (List.seq 0 _n) _m _arg = exp_lift_in_comm _k (_m + _n) _arg

  with exp_fv_permut_in_seq_id_simpl :
    forall (_k : nat) (_arg : seq) (_m _n : nat),
      exp_fv_permut_in_seq _k (List.seq 0 _n) _m _arg = exp_lift_in_seq _k (_m + _n) _arg
  .
  Proof.
    (* case exp_fv_permut_in_exp_id_simpl *)
    Focus. clear exp_fv_permut_in_exp_id_simpl.
    induction _arg as [ x | x | n | n m s ];
      intros _m _n;
        [ fv_permut_index_tac; index_tac; crush_tac; repeat (progress (rewrite List.seq_nth || rewrite List.seq_length in *)); crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; simpl; simpl; try rewrite exp_fv_permut_in_seq_id_simpl; crush_tac
        ];
      idtac.

    (* case exp_fv_permut_in_exps_id_simpl *)
    Focus. clear exp_fv_permut_in_exps_id_simpl.
    induction _arg as [  | e es IHes ];
      intros _m _n;
        [ crush_tac
        | simpl; try rewrite exp_fv_permut_in_exp_id_simpl; simpl; try rewrite IHes; crush_tac
        ];
      idtac.

    (* case exp_fv_permut_in_comm_id_simpl *)
    Focus. clear exp_fv_permut_in_comm_id_simpl.
    induction _arg as [ x e | x | x | s | e s | p es ms ];
      intros _m _n;
        [ simpl; simpl; try rewrite exp_fv_permut_in_exp_id_simpl; crush_tac
        | simpl; crush_tac
        | simpl; crush_tac
        | simpl; try rewrite exp_fv_permut_in_seq_id_simpl; crush_tac
        | simpl; try rewrite exp_fv_permut_in_exp_id_simpl; simpl; try rewrite exp_fv_permut_in_seq_id_simpl; crush_tac
        | simpl; try rewrite exp_fv_permut_in_exp_id_simpl; simpl; try rewrite exp_fv_permut_in_exps_id_simpl; simpl; crush_tac
        ];
      idtac.

    (* case exp_fv_permut_in_seq_id_simpl *)
    Focus. clear exp_fv_permut_in_seq_id_simpl.
    induction _arg as [  | e s IHs | s IHs | c s IHs ];
      intros _m _n;
        [ crush_tac
        | simpl; try rewrite exp_fv_permut_in_exp_id_simpl; simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite IHs; crush_tac
        | simpl; try rewrite exp_fv_permut_in_comm_id_simpl; simpl; try rewrite IHs; crush_tac
        ];
      idtac.
  Qed.

  Hint Rewrite exp_fv_permut_in_exp_id_simpl : LOOPW_database.

  Hint Rewrite exp_fv_permut_in_exps_id_simpl : LOOPW_database.

  Hint Rewrite exp_fv_permut_in_comm_id_simpl : LOOPW_database.

  Hint Rewrite exp_fv_permut_in_seq_id_simpl : LOOPW_database.

  (** *** Identity free variables permutation simplification generalized *)

  Lemma mutable_fv_permut_in_mutable_id_simpl_gen :
    forall (_k : nat) (_arg : mutable) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> mutable_fv_permut_in_mutable _k _l _m _arg = mutable_lift_in_mutable _k (_m + List.length _l) _arg

  with mutable_fv_permut_in_mutables_id_simpl_gen :
    forall (_k : nat) (_arg : mutables) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> mutable_fv_permut_in_mutables _k _l _m _arg = mutable_lift_in_mutables _k (_m + List.length _l) _arg
  .
  Proof.
    (* case mutable_fv_permut_in_mutable_id_simpl_gen *)
    Focus. clear mutable_fv_permut_in_mutable_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case mutable_fv_permut_in_mutables_id_simpl_gen *)
    Focus. clear mutable_fv_permut_in_mutables_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Lemma mutable_fv_permut_in_exp_id_simpl_gen :
    forall (_k : nat) (_arg : exp) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> mutable_fv_permut_in_exp _k _l _m _arg = mutable_lift_in_exp _k (_m + List.length _l) _arg

  with mutable_fv_permut_in_exps_id_simpl_gen :
    forall (_k : nat) (_arg : exps) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> mutable_fv_permut_in_exps _k _l _m _arg = mutable_lift_in_exps _k (_m + List.length _l) _arg

  with mutable_fv_permut_in_comm_id_simpl_gen :
    forall (_k : nat) (_arg : comm) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> mutable_fv_permut_in_comm _k _l _m _arg = mutable_lift_in_comm _k (_m + List.length _l) _arg

  with mutable_fv_permut_in_seq_id_simpl_gen :
    forall (_k : nat) (_arg : seq) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> mutable_fv_permut_in_seq _k _l _m _arg = mutable_lift_in_seq _k (_m + List.length _l) _arg
  .
  Proof.
    (* case mutable_fv_permut_in_exp_id_simpl_gen *)
    Focus. clear mutable_fv_permut_in_exp_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case mutable_fv_permut_in_exps_id_simpl_gen *)
    Focus. clear mutable_fv_permut_in_exps_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case mutable_fv_permut_in_comm_id_simpl_gen *)
    Focus. clear mutable_fv_permut_in_comm_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case mutable_fv_permut_in_seq_id_simpl_gen *)
    Focus. clear mutable_fv_permut_in_seq_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Lemma exp_fv_permut_in_exp_id_simpl_gen :
    forall (_k : nat) (_arg : exp) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> exp_fv_permut_in_exp _k _l _m _arg = exp_lift_in_exp _k (_m + List.length _l) _arg

  with exp_fv_permut_in_exps_id_simpl_gen :
    forall (_k : nat) (_arg : exps) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> exp_fv_permut_in_exps _k _l _m _arg = exp_lift_in_exps _k (_m + List.length _l) _arg

  with exp_fv_permut_in_comm_id_simpl_gen :
    forall (_k : nat) (_arg : comm) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> exp_fv_permut_in_comm _k _l _m _arg = exp_lift_in_comm _k (_m + List.length _l) _arg

  with exp_fv_permut_in_seq_id_simpl_gen :
    forall (_k : nat) (_arg : seq) (_l : list nat) (_m _n : nat),
      _l = List.seq 0 _n -> exp_fv_permut_in_seq _k _l _m _arg = exp_lift_in_seq _k (_m + List.length _l) _arg
  .
  Proof.
    (* case exp_fv_permut_in_exp_id_simpl_gen *)
    Focus. clear exp_fv_permut_in_exp_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case exp_fv_permut_in_exps_id_simpl_gen *)
    Focus. clear exp_fv_permut_in_exps_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case exp_fv_permut_in_comm_id_simpl_gen *)
    Focus. clear exp_fv_permut_in_comm_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.

    (* case exp_fv_permut_in_seq_id_simpl_gen *)
    Focus. clear exp_fv_permut_in_seq_id_simpl_gen.
    intros; subst; rewrite List.seq_length; crush_tac.
  Qed.


  Ltac fv_permut_id_simpl_tac :=
    repeat
      match goal with
        | [ |- context [ mutable_fv_permut_in_mutable ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m t = mutable_lift_in_mutable k (m + List.length l) t);
            [ | (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ mutable_fv_permut_in_mutable ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_mutable k l m t = mutable_lift_in_mutable k (m + List.length l) t) in H;
            [ | (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_mutable_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ mutable_fv_permut_in_mutables ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_mutables k l m t = mutable_lift_in_mutables k (m + List.length l) t);
            [ | (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ mutable_fv_permut_in_mutables ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_mutables k l m t = mutable_lift_in_mutables k (m + List.length l) t) in H;
            [ | (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_mutables_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ mutable_fv_permut_in_exp ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_exp k l m t = mutable_lift_in_exp k (m + List.length l) t);
            [ | (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ mutable_fv_permut_in_exp ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_exp k l m t = mutable_lift_in_exp k (m + List.length l) t) in H;
            [ | (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_exp_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ mutable_fv_permut_in_exps ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_exps k l m t = mutable_lift_in_exps k (m + List.length l) t);
            [ | (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ mutable_fv_permut_in_exps ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_exps k l m t = mutable_lift_in_exps k (m + List.length l) t) in H;
            [ | (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_exps_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ mutable_fv_permut_in_comm ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_comm k l m t = mutable_lift_in_comm k (m + List.length l) t);
            [ | (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ mutable_fv_permut_in_comm ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_comm k l m t = mutable_lift_in_comm k (m + List.length l) t) in H;
            [ | (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_comm_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ mutable_fv_permut_in_seq ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_seq k l m t = mutable_lift_in_seq k (m + List.length l) t);
            [ | (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ mutable_fv_permut_in_seq ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (mutable_fv_permut_in_seq k l m t = mutable_lift_in_seq k (m + List.length l) t) in H;
            [ | (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 0); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 1); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 2); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 3); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 4); cfail) ||
                (apply (mutable_fv_permut_in_seq_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ exp_fv_permut_in_exp ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m t = exp_lift_in_exp k (m + List.length l) t);
            [ | (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ exp_fv_permut_in_exp ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_fv_permut_in_exp k l m t = exp_lift_in_exp k (m + List.length l) t) in H;
            [ | (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_exp_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ exp_fv_permut_in_exps ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (exp_fv_permut_in_exps k l m t = exp_lift_in_exps k (m + List.length l) t);
            [ | (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ exp_fv_permut_in_exps ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_fv_permut_in_exps k l m t = exp_lift_in_exps k (m + List.length l) t) in H;
            [ | (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_exps_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ exp_fv_permut_in_comm ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (exp_fv_permut_in_comm k l m t = exp_lift_in_comm k (m + List.length l) t);
            [ | (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ exp_fv_permut_in_comm ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_fv_permut_in_comm k l m t = exp_lift_in_comm k (m + List.length l) t) in H;
            [ | (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_comm_id_simpl_gen k t l m 5); cfail) ])
        | [ |- context [ exp_fv_permut_in_seq ?k ?l ?m ?t ] ] =>
          (cutrewrite ->
            (exp_fv_permut_in_seq k l m t = exp_lift_in_seq k (m + List.length l) t);
            [ | (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 5); cfail) ])
        | [ H : context [ exp_fv_permut_in_seq ?k ?l ?m ?t ] |- _ ] =>
          (cutrewrite ->
            (exp_fv_permut_in_seq k l m t = exp_lift_in_seq k (m + List.length l) t) in H;
            [ | (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 0); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 1); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 2); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 3); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 4); cfail) ||
                (apply (exp_fv_permut_in_seq_id_simpl_gen k t l m 5); cfail) ])
      end; crush_tac.

  Ltac fv_permut_tac :=
    crush_tac;
    repeat (progress (fv_permut_index_tac || fv_permut_id_simpl_tac)).




  (** * Main dbgen tactic *)

  Ltac dbgen_tac :=
    crush_tac;
    repeat (progress (index_tac || lift_tac || subst_tac || fv_permut_tac)).


End LOOPW.
